IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[pjm6UserActivityBrowse]') AND type in (N'P', N'PC'))
BEGIN
	PRINT 'Dropping procedure [pjm6UserActivityBrowse]'
	DROP PROCEDURE [pjm6UserActivityBrowse]
END
GO

PRINT 'Creating procedure [pjm6UserActivityBrowse]'
GO

CREATE PROCEDURE [dbo].[pjm6UserActivityBrowse] 
	@Date datetime,
	@UserID int
AS
	SET NOCOUNT ON
	
	DECLARE @Total int
	SELECT TOP 1
		@Total = SUM(DATEDIFF(second, [Created], [Closed]))
	FROM 
		[pjmams].[Session] 
		INNER JOIN [pjmams].[Process] 
			ON ([Session].[ID] = [Process].[SessionID])
		INNER JOIN [UserNTLoginMapping]
			ON [UserNTLoginMapping].[NTLogin] = [Process].[UserName]
		--INNER JOIN [pjmams].[Module]
			--ON [Process].[ModuleID] = [Module].[ID]
	WHERE
		CONVERT(datetime, CONVERT(varchar(8), [Created], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Closed], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		[UserNTLoginMapping].[UserID] = @UserID
	--GROUP BY
		--ISNULL([Module].[Description], [Module].[Name])
	--ORDER BY
		--1 DESC;
		
	SELECT --TOP 10
		ISNULL([Module].[Description], [Module].[Name]) as [Name], 
		SUM(DATEDIFF(second, [Created], [Closed])) AS [Duration],
		CAST(SUM(DATEDIFF(second, [Created], [Closed])) AS decimal(18,2)) / @Total AS [RelativeDuration],
		ISNULL([Module].[Description], [Module].[Name]) as [Module]
	FROM 
		[pjmams].[Session] 
		INNER JOIN [pjmams].[Process] 
			ON ([Session].[ID] = [Process].[SessionID])
		INNER JOIN [UserNTLoginMapping]
			ON [UserNTLoginMapping].[NTLogin] = [Process].[UserName]
		INNER JOIN [pjmams].[Module]
			ON [Process].[ModuleID] = [Module].[ID]
	WHERE
		CONVERT(datetime, CONVERT(varchar(8), [Created], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Closed], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		[UserNTLoginMapping].[UserID] = @UserID
	GROUP BY
		ISNULL([Module].[Description], [Module].[Name])
	HAVING
		CAST(SUM(DATEDIFF(second, [Created], [Closed])) / CAST(60 as decimal(18,4)) as decimal(18,1)) >= 0.1
	ORDER BY 
		 3 DESC	
	
	RETURN 0
GO


GRANT EXECUTE ON [pjm6UserActivityBrowse] TO PUBLIC
GO 