 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfAnnouncementBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfAnnouncementBrowse'
		DROP PROCEDURE [dbo].[adfAnnouncementBrowse]
	END
GO

PRINT 'Creating procedure adfAnnouncementBrowse'
GO

/******************************************************************************
**		File: adfAnnouncementBrowse.sql
**		Name: adfAnnouncementBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 02/16/2006 11:44:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfAnnouncementBrowse]
	@StateSelector INT
AS
	DECLARE @UserID TIdentifier, 
			@EmployeeID TIdentifier,
			@HasFullAccess TBool
	
	SET NOCOUNT ON
	
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @HasFullAccess = dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAnnouncements'))
	SELECT
		[Announcement].[Class],
		[Announcement].[ID],
		[Announcement].[State],
		[Announcement].[Flag],
		[Announcement].[FileAs],
		[Announcement].[PublicationTime],
		[Announcement].[ProjectID],
		[Announcement].[Comments],
		[Announcement].[Created],
		[Announcement].[CreatedBy],
		[Announcement].[Modified],
		[Announcement].[ModifiedBy],
		[Announcement].[Timestamp],
		CAST(ISNULL([DocumentUserState].[Read], 0) as BIT) as [Read]
	FROM
		[Announcement] LEFT OUTER JOIN [DocumentUserState]
			ON ([Announcement].[Class] = [DocumentUserState].[DocumentClass] AND 
				[Announcement].[ID] = [DocumentUserState].[DocumentID] AND
				[DocumentUserState].[UserID] = @UserID)
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [Announcement].[State] = @StateSelector))
	AND
		(@HasFullAccess = 1 OR [Announcement].[ProjectID] IS NULL OR
			([Announcement].[ProjectID] IS NOT NULL AND 
				(dbo.fnPjm5IsProjectMember([Announcement].[ProjectID], @EmployeeID) = 1 OR
				 dbo.fnPjm5IsProjectManager([Announcement].[ProjectID], @EmployeeID) = 1
				 )
			)
		)
	ORDER BY 
		[Announcement].[Created] DESC
		
	RETURN 0
GO

GRANT EXECUTE ON [adfAnnouncementBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfAnnouncementGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfAnnouncementGet'
		DROP PROCEDURE [dbo].[adfAnnouncementGet]
	END
GO

PRINT 'Creating procedure adfAnnouncementGet'
GO

/******************************************************************************
**		File: adfAnnouncementGet.sql
**		Name: adfAnnouncementGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 02/16/2006 11:44:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfAnnouncementGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[Announcement].[Class],
		[Announcement].[ID],
		[Announcement].[State],
		[Announcement].[Flag],
		[Announcement].[FileAs],
		[Announcement].[PublicationTime],
		[Announcement].[ProjectID],
		[Announcement].[Href],
		[Announcement].[PublishOnWeb],
		[Announcement].[Comments],
		[Announcement].[Created],
		[Announcement].[CreatedBy],
		[Announcement].[Modified],
		[Announcement].[ModifiedBy],
		[Announcement].[Timestamp]
	FROM
		[Announcement]
	WHERE
		[Announcement].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [adfAnnouncementGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfAnnouncementCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfAnnouncementCreate'
		DROP PROCEDURE [dbo].[adfAnnouncementCreate]
	END
GO

PRINT 'Creating procedure adfAnnouncementCreate'
GO

/******************************************************************************
**		File: adfAnnouncementCreate.sql
**		Name: adfAnnouncementCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 02/16/2006 11:44:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfAnnouncementCreate]
	@FileAs TName,
	@PublicationTime TDateTime,
	@Comments TNotes,
	@ProjectID TIdentifier,
	@Href THref,
	@PublishOnWeb TBool
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('147b6f54-cbf6-45ff-8584-9175a1ccd8aa')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @PublicationTime IS NULL
		SET @PublicationTime = CONVERT(datetime, CONVERT(varchar(8), GETDATE(), 112), 112)
		
	INSERT INTO [Announcement]
		([Flag], [State], [FileAs], [ProjectID], [Comments], [Href], [PublishOnWeb], [PublicationTime])
	VALUES
		(0, @State, @FileAs, @ProjectID, @Comments, @Href, @PublishOnWeb, @PublicationTime)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfAnnouncementGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfAnnouncementCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfAnnouncementUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfAnnouncementUpdate'
		DROP PROCEDURE [dbo].[adfAnnouncementUpdate]
	END
GO

PRINT 'Creating procedure adfAnnouncementUpdate'
GO

/******************************************************************************
**		File: adfAnnouncementUpdate.sql
**		Name: adfAnnouncementUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 02/16/2006 11:44:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfAnnouncementUpdate
	@ID TIdentifier,
	@FileAs TName,
	@PublicationTime TDateTime,
	@Comments TNotes,
	@ProjectID TIdentifier,
	@Href THref,
	@PublishOnWeb TBool
AS
	
	SET NOCOUNT ON
	
	IF @PublicationTime IS NULL
		SET @PublicationTime = CONVERT(datetime, CONVERT(varchar(8), GETDATE(), 112), 112)

	UPDATE [Announcement]
	SET
		[Announcement].[FileAs] = @FileAs,
		[Announcement].[PublicationTime] = @PublicationTime,
		[Announcement].[ProjectID] = @ProjectID,
		[Announcement].[Comments] = @Comments,
		[Announcement].[Href] = @Href,
		[Announcement].[PublishOnWeb] = @PublishOnWeb,
		[Announcement].[Modified] = DEFAULT,
		[Announcement].[ModifiedBy] = DEFAULT
	WHERE
		[Announcement].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfAnnouncementGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfAnnouncementUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfAnnouncementDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfAnnouncementDelete'
		DROP PROCEDURE [dbo].[adfAnnouncementDelete]
	END
GO

PRINT 'Creating procedure adfAnnouncementDelete'
GO

/******************************************************************************
**		File: adfAnnouncementDelete.sql
**		Name: adfAnnouncementDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 02/16/2006 11:44:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfAnnouncementDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [Announcement] WHERE [Announcement].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfAnnouncementDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfAnnouncementChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfAnnouncementChangeState'
		DROP PROCEDURE [dbo].[adfAnnouncementChangeState]
	END
GO

PRINT 'Creating procedure adfAnnouncementChangeState'
GO

/******************************************************************************
**		File: adfAnnouncementChangeState.sql
**		Name: adfAnnouncementChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 02/16/2006 11:44:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfAnnouncementChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [Announcement].[Class],
		@FromState = [Announcement].[State]
	FROM
		[Announcement]
	WHERE
		[Announcement].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[Announcement]
	SET
		[Announcement].[State] = @ToState,
		[Announcement].[Modified] = DEFAULT,
		[Announcement].[ModifiedBy] = DEFAULT
	WHERE
		[Announcement].[ID] = @ID
	AND
		[Announcement].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfAnnouncementChangeState TO PUBLIC
GO


