IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfDocumentInfoGet')
	BEGIN
		PRINT 'Dropping Procedure adfDocumentInfoGet'
		DROP  Procedure  adfDocumentInfoGet
	END

GO

PRINT 'Creating Procedure adfDocumentInfoGet'
GO
/******************************************************************************
**		File: 
**		Name: adfDocumentInfoGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfDocumentInfoGet
	@Class TClass,
	@ID TIdentifier
AS

	SET NOCOUNT ON
	
	SELECT
		[Note].[ID],
		[Note].[Text],
		[Note].[Created],
		[Note].[CreatedBy]
	FROM
		[Note]
	WHERE
		[Note].[DocumentClass] = @Class
	AND
		[Note].[DocumentID] = @ID
	
	SELECT
		[Attachment].[ID],
		[Attachment].[AttachmentTypeID],
		[Attachment].[Name],
		[Attachment].[LinkDocumentClass],
		[Attachment].[LinkDocumentID]
	FROM
		[Attachment]
	WHERE
		[Attachment].[DocumentClass] = @Class
		AND
		[Attachment].[DocumentID] = @ID
	

	SELECT
		[DocumentContact].[BusinessCardClass],
		[DocumentContact].[BusinessCardID],
		[BusinessCard].[FileAs]
	FROM
		[DocumentContact] INNER JOIN [BusinessCard]
			ON ([DocumentContact].[BusinessCardClass] = [BusinessCard].[Class] AND
				[DocumentContact].[BusinessCardID] = [BusinessCard].[ID])
	WHERE
		[DocumentContact].[DocumentClass] = @Class 
		AND
		[DocumentContact].[DocumentID] = @ID 
	
	SELECT
		[Category].[FileAs]
	FROM
		[DocumentCategory] INNER JOIN [Category]
			ON ([DocumentCategory].[CategoryID] = [Category].[ID])
	WHERE
		[DocumentCategory].[DocumentClass] = @Class 
		AND
		[DocumentCategory].[DocumentID] = @ID 
	
	SELECT
		[PropertyValue].[PropertyID],
		[Property].[Name],
		[PropertyValue].[Value]
	FROM
		[PropertyValue] INNER JOIN [Property]
			ON ([PropertyValue].[PropertyID] = [Property].[ID])
	WHERE
		[PropertyValue].[DocumentClass] = @Class 
	AND
		[PropertyValue].[DocumentID] = @ID

	RETURN 0

GO

GRANT EXEC ON adfDocumentInfoGet TO PUBLIC
GO
 