IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfGetDateInterval]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfGetDateInterval'
		DROP FUNCTION [dbo].[adfGetDateInterval]
	END

GO

PRINT 'Creating function adfGetDateInterval'
GO
/******************************************************************************
**		File: 
**		Name: adfGetDateInterval
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfGetDateInterval
	(@DateSelector INT, @CurrentDate datetime, @StartDate datetime, @EndDate datetime)
RETURNS @interval TABLE ([StartDate] datetime, [EndDate] datetime)
AS
BEGIN
	DECLARE @Date datetime, @Day INT, @Month INT, @Year INT, @Quarter INT

	SET @EndDate = DATEADD(day, 1, @EndDate)
	SET @EndDate = DATEADD(ms, -3, @EndDate)

	SET @Date = CONVERT(datetime, CONVERT(varchar(8), @CurrentDate, 112), 112)
	
	IF @DateSelector = 0
	BEGIN
		SET @StartDate = DATEADD(day, -7, @Date)
		SET @EndDate = DATEADD(day, 1, @Date)
	END
	
	SET @Day = DAY(@Date)
	SET @Month = MONTH(@Date)
	SET @Year = YEAR(@Date)
	SET @Quarter = DATEPART(QUARTER, @Date)
	
	SET @Date = DATEADD(day, -@Day + 1, @Date)
	
	IF @DateSelector = 1 --  
	BEGIN
		SET @StartDate = DATEADD(month, -1, @Date)
		SET @EndDate = @Date
	END
	ELSE IF @DateSelector = 2 --  
	BEGIN
		SET @StartDate = @Date
		SET @EndDate = DATEADD(month, 1, @Date)
	END
	
	SET @Date = DATEADD(month, -@Month + 1, @Date)
	
	IF @DateSelector = 3 --  
	BEGIN
		SET @StartDate = DATEADD(quarter, @Quarter - 2, @Date)
		SET @EndDate =  DATEADD(quarter, @Quarter - 1, @Date)
	END
	ELSE IF @DateSelector = 4 --  
	BEGIN
		SET @StartDate = DATEADD(quarter, @Quarter - 1, @Date)
		SET @EndDate =  DATEADD(quarter, @Quarter, @Date)
	END

	INSERT INTO @interval VALUES(@StartDate, @EndDate)
	RETURN
END
GO

GRANT SELECT ON adfGetDateInterval TO PUBLIC
GO
