IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPropertyCreate')
	BEGIN
		PRINT 'Dropping Procedure adfPropertyCreate'
		DROP  Procedure  adfPropertyCreate
	END

GO

PRINT 'Creating Procedure adfPropertyCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfPropertyCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPropertyCreate
	@Class TClass,
	@Name TName,
	@Type TCode,
	@Format TCode,
	@Description TNotes,
	@ID TIdentifier OUTPUT
AS

	SET NOCOUNT ON

	BEGIN TRANSACTION
	
	INSERT INTO [Property] 
		([Class], [Name], [Type], [Description], [Format])
	VALUES
		(@Class, @Name, @Type, @Description, @Format)

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
		
	INSERT INTO [PropertyGlobal]
		([ID], [Language], [Name], [Format], [Description])
	VALUES
		(@ID, dbo.adfGetLanguage(), @Name, @Format, @Description)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION		
	
	RETURN 0
GO

GRANT EXEC ON adfPropertyCreate TO PUBLIC

GO
