IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'adftrAttachmentDelete')
	BEGIN
		PRINT 'Dropping Trigger adftrAttachmentDelete'
		DROP  Trigger adftrAttachmentDelete
	END
GO

/******************************************************************************
**		File: 
**		Name: adftrAttachmentDelete
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger adftrAttachmentDelete'
GO
CREATE Trigger adftrAttachmentDelete ON [Attachment] FOR DELETE
AS
	SET NOCOUNT ON
	UPDATE [Document]
	SET
		[AttachmentCount] = [AttachmentCount] - [I].[Count]
	FROM
		[Document] INNER JOIN (SELECT [DocumentClass], [DocumentID], COUNT(*) as [Count] FROM deleted GROUP BY [DocumentClass], [DocumentID]) as [I]
			ON ([Document].[ID] = [I].[DocumentID] AND [Document].[Class] = [I].[DocumentClass])

GO

