IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyCalendarCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyCalendarCreate'
		DROP PROCEDURE [dbo].[adfCompanyCalendarCreate]
	END
GO

PRINT 'Creating procedure adfCompanyCalendarCreate'
GO

/******************************************************************************
**		File: adfCompanyCalendarCreate.sql
**		Name: adfCompanyCalendarCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/04/2004 12:32:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfCompanyCalendarCreate]
	@ID TIdentifier,
	@Own TBool
AS
	IF @Own IS NULL
		SELECT @Own = [Own] FROM [Company] WHERE [ID] = @ID
		
	IF @Own = 1 AND NOT EXISTS(SELECT * FROM [CompanyCalendar] WHERE [CompanyID] = @ID)
	BEGIN
		DECLARE 
			@startDate TDate,
			@working TCount,
			@value TVariant
		
		EXEC adfParameterGet @Name='WorkTime', @Group='Pjm5', @Value = @value OUTPUT
		SET @working = CAST(@value as int)
		SET @startDate = '20030101'
		WHILE @startDate < '20150101'
		BEGIN
			IF dbo.fnPjm5IsWorkingDay(@startDate) = 1
				INSERT INTO [CompanyCalendar] VALUES(@ID, @startDate, @working)
			ELSE
				INSERT INTO [CompanyCalendar] VALUES(@ID, @startDate, 0)
			SET @startDate = DATEADD(day, 1, @startDate)
		END
	END

	RETURN 0
GO

GRANT EXECUTE ON adfCompanyCalendarCreate TO PUBLIC
GO
