IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfCurrencyRateCreate')
	BEGIN
		PRINT 'Dropping Procedure adfCurrencyRateCreate'
		DROP  Procedure  adfCurrencyRateCreate
	END

GO

PRINT 'Creating Procedure adfCurrencyRateCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfCurrencyRateCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfCurrencyRateCreate
	@FromCurrencyCode TCode3,
	@ToCurrencyCode TCode3,
	@ValidFrom TDate,
	@ValidTo TDate,
	@Rate TMoney
AS
	SET NOCOUNT ON
	
	IF EXISTS(SELECT * FROM [CurrencyRate] WHERE
		[FromCurrencyCode]=@FromCurrencyCode 
		AND 
		[ToCurrencyCode]=@ToCurrencyCode 
		AND
		(
			(@ValidFrom BETWEEN [ValidFrom] AND [ValidTo]) 
			OR
			(@ValidTo BETWEEN [ValidFrom] AND [ValidTo])
			OR
			(@ValidFrom < [ValidFrom] AND @ValidTo > [ValidTo])
		)
	)
	BEGIN
		RAISERROR('#CurrencyRateAlreadyExists', 18, -1)
		RETURN 1
	END
	
	INSERT [CurrencyRate]
		([FromCurrencyCode], [ToCurrencyCode], [ValidFrom], [ValidTo], [Rate])
	VALUES
		(@FromCurrencyCode, @ToCurrencyCode, @ValidFrom, @ValidTo, @Rate)
	
	RETURN 0
GO

GRANT EXEC ON adfCurrencyRateCreate TO PUBLIC
GO
