﻿IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfDivisionExecutiveEmployeeList')
	BEGIN
		PRINT 'Dropping Procedure adfDivisionExecutiveEmployeeList'
		DROP  Procedure  adfDivisionExecutiveEmployeeList
	END

GO

PRINT 'Creating Procedure adfDivisionExecutiveEmployeeList'
GO

/******************************************************************************
**		File: 
**		Name: adfDivisionExecutiveEmployeeList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Sergey Pelevin
**		Date: 27.05.14
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure [dbo].[adfDivisionExecutiveEmployeeList]
AS
	SET NOCOUNT ON
	SELECT
		[Employee].[ID],
		[Employee].[FileAs] as [Name],
		[Employee].[CompanyID],
		(CASE WHEN [Employee].[State] = 1 AND [Company].[State] = 1 THEN 1 ELSE 2 END) as [State],
		[Employee].[UserID],
		[Company].[Own],
		[Employee].[Initials] as [Code],
		[Employee].[DivisionID]
	FROM
		[Employee] LEFT JOIN [Company]
			ON ([Employee].[CompanyID] = [Company].[ID])
	WHERE  
		[dbo].[adfHasAccessRightByNameForUser]('CanBeDivisionManager',[Employee].[UserID])=1
			
RETURN 0
GO

GRANT EXEC ON adfDivisionExecutiveEmployeeList TO PUBLIC
GO
