IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPaymentTermList')
	BEGIN
		PRINT 'Dropping Procedure adfPaymentTermList'
		DROP  Procedure  adfPaymentTermList
	END

GO

PRINT 'Creating Procedure adfPaymentTermList'
GO
/******************************************************************************
**		File: 
**		Name: adfPaymentTermList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPaymentTermList
AS
	SET NOCOUNT ON
	
	SELECT
		[PaymentTerm].[ID], 
		[DocumentGlobal].[FileAs] as [Name], 
		[PaymentTerm].[State]
	FROM
		[PaymentTerm] INNER JOIN [DocumentGlobal]
			ON ([PaymentTerm].[Class] = [DocumentGlobal].[Class] AND
				[PaymentTerm].[ID] = [DocumentGlobal].[ID] AND
				[DocumentGlobal].[Language] = dbo.adfGetLanguage())
			

	RETURN 0
GO

GRANT EXEC ON adfPaymentTermList TO PUBLIC
GO
