IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfActivityExpenseWizardProjectsBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfActivityExpenseWizardProjectsBrowse'
		DROP PROCEDURE [dbo].[adfActivityExpenseWizardProjectsBrowse]
	END
GO

PRINT 'Creating procedure adfActivityExpenseWizardProjectsBrowse'
GO

/******************************************************************************
**		File: adfServicePWProjectsBrowse.sql
**		Name: adfServicePWProjectsBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 12:32:27
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    29.09.09		syv				  
*******************************************************************************/
CREATE PROCEDURE [adfActivityExpenseWizardProjectsBrowse]
	@CostCentersXML			XML,
	@ProjectManagerXML		XML,
	@CustomerXML			XML,
	@ProjectTypeXML			XML,
	@CostCenterSelector		TBool,
	@ManagerSelector		TBool,
	@CustomerSelector		TBool,
	@WithEmptyCostCenter	INT,
	@WithEmptyManager		INT,
	@WithEmptyCustomer		INT
	
AS
	SET NOCOUNT ON
	
		
	SELECT
		[Project].[ID],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[State]
	FROM
		[Project]
	WHERE
	(
		@CostCenterSelector = 0
		OR
		(
		@CostCenterSelector = 1
			AND
			(
				[Project].[CostCenterID] IN
				(
					SELECT T.c.value('ID[1]', 'int')
					FROM @CostCentersXML.nodes('/CostCenters/CostCenter') T(c)
				)
				OR 
				(
					@WithEmptyCostCenter = 1 
					AND 
					[Project].[CostCenterID] IS NULL
				)
			)
		)
	)
	AND 
	(
		@ManagerSelector = 0
		OR
		(
		@ManagerSelector = 1
			AND
			(
				[Project].[ProjectManagerEmployeeID] IN 
				(
					SELECT T.c.value('ID[1]', 'int')
					FROM @ProjectManagerXML.nodes('/Managers/Manager') T(c)
				)
				OR 
				(
					@WithEmptyManager = 1 
					AND 
					[Project].[ProjectManagerEmployeeID]  IS NULL
				)
			)
		)
	)
	AND 
	(
		@CustomerSelector = 0
		OR		
		(
		@CustomerSelector = 1
			AND
			(
				[Project].[CustomerCompanyID] IN 
				(
					SELECT T.c.value('ID[1]', 'int') 
					FROM @CustomerXML.nodes('/Customers/Customer') T(c)
				) 
				OR 
				(
					@WithEmptyCustomer = 1 
					AND 
					[Project].[CustomerCompanyID] IS NULL
				)
			)
		)
	)
	AND 
	(
		[Project].[ProjectTypeID] IN 
		(
			SELECT T.c.value('ID[1]', 'int')
			FROM @ProjectTypeXML.nodes('/ProjectTypes/ProjectType') T(c)
		) 
	)
	AND ([Project].[State] IN (1,2))
	
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [adfActivityExpenseWizardProjectsBrowse] TO PUBLIC
GO
 
 
