IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfDocumentGetByName')
	BEGIN
		PRINT 'Dropping Procedure adfDocumentGetByName'
		DROP  Procedure  adfDocumentGetByName
	END

GO

PRINT 'Creating Procedure adfDocumentGetByName'
GO
/******************************************************************************
**		File: 
**		Name: adfDocumentGetByName
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfDocumentGetByName
	@Class TClass,
	@FileAs TName
AS
	DECLARE @Count INT
	
	SET NOCOUNT ON

	IF (SELECT COUNT(*) FROM [Document] WHERE [Class]=@Class AND [FileAs]=@FileAs) = 1
	BEGIN
		SELECT TOP 1
			[Class],
			[ID],
			[State],
			[FileAs],
			[Created],
			[CreatedBy],
			[Modified],
			[ModifiedBy],
			[Timestamp]
		FROM
			[Document]
		WHERE
			[Class] = @Class AND [FileAs] = @FileAs
		RETURN 0
	END
	
	SET @FileAs = @FileAs + N'%'

	IF (SELECT COUNT(*) FROM [Document] WHERE [Class]=@Class AND [FileAs] LIKE @FileAs) = 1
	BEGIN
		SELECT TOP 1
			[Class],
			[ID],
			[State],
			[FileAs],
			[Created],
			[CreatedBy],
			[Modified],
			[ModifiedBy],
			[Timestamp]
		FROM
			[Document]
		WHERE
			[Class] = @Class AND [FileAs] LIKE @FileAs
	END

	RETURN 0
GO

GRANT EXEC ON adfDocumentGetByName TO PUBLIC
GO
