IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfGetStateName]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfGetStateName'
		DROP FUNCTION [dbo].[adfGetStateName]
	END

GO

PRINT 'Creating function adfGetStateName'
GO
/******************************************************************************
**		File: 
**		Name: adfGetStateName
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfGetStateName
	(@Class TClass, @State TState)
RETURNS varchar(256)
AS
BEGIN
	DECLARE @Name varchar(256)

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		@Name = ISNULL([StateGlobal].[Name], [State].[Name])
	FROM
		[State] LEFT OUTER JOIN [StateGlobal] 
			ON ([State].[Class] = [StateGlobal].[Class] AND [State].[State] = [StateGlobal].[State]
				AND [StateGlobal].[Language] = @Lang)
	WHERE
		[State].[Class] = @Class AND [State].[State] = @State
	RETURN @Name
END
GO

GRANT EXEC ON adfGetStateName TO PUBLIC
GO
