IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserParameterUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfUserParameterUpdate'
		DROP  Procedure  adfUserParameterUpdate
	END

GO

PRINT 'Creating Procedure adfUserParameterUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfUserParameterUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfUserParameterUpdate
	@Name TName,
	@Value TVariant
AS
	DECLARE @UserID TIdentifier
	SET NOCOUNT ON
	
	SET @UserID = dbo.adfGetCurrentUserID()

	IF @Value IS NULL
	BEGIN
		DELETE [UserParameter] WHERE [UserID] = @UserID AND [Name] = @Name
	END
	ELSE
	BEGIN
		IF EXISTS(SELECT * FROM [UserParameter] WHERE [UserID] = @UserID AND [Name] = @Name)
		BEGIN
			UPDATE [UserParameter]
			SET 
				[Value] = @Value
			WHERE 
				[UserID] = @UserID AND [Name] = @Name
		END
		ELSE
		BEGIN
			INSERT [UserParameter] ([UserID], [Name], [Value]) VALUES(@UserID, @Name, @Value)
		END
	END
	
	RETURN 0
GO

GRANT EXEC ON adfUserParameterUpdate TO PUBLIC
GO
  