IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfCurrentUserRightsGet')
	BEGIN
		PRINT 'Dropping Procedure adfCurrentUserRightsGet'
		DROP  Procedure  adfCurrentUserRightsGet
	END

GO

PRINT 'Creating Procedure adfCurrentUserRightsGet'
GO
/******************************************************************************
**		File: 
**		Name: adfCurrentUserRightsGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		05.06.14	SAP				    [Active]
*******************************************************************************/
CREATE Procedure adfCurrentUserRightsGet
AS
	SET NOCOUNT ON
	DECLARE 
		@UserID TIdentifier,
		@isDbOwner TBool,
		@Active bit = 1

	SET @isDbOwner = IS_MEMBER('db_owner')
	SET @UserID = dbo.adfGetCurrentUserID()

	SELECT DISTINCT
		[Right].[Name],
		[Right].[Active]
	FROM
		[AccessRight] INNER JOIN [Right]
			ON ([AccessRight].[RightID] = [Right].[ID])
	WHERE
		[AccessRight].[TrusteeID] = @UserID
	OR
		[AccessRight].[TrusteeID] IN (SELECT [UserRole].[RoleID] FROM [UserRole] WHERE [UserRole].[UserID] = @UserID)
	UNION
	SELECT 'ManageLogins', @Active WHERE @isDbOwner = 1 AND is_srvrolemember('securityadmin') = 1
	UNION
	SELECT 'ManageRights', @Active WHERE @isDbOwner = 1
	UNION
	SELECT 'ManageUsers', @Active WHERE @isDbOwner = 1
	UNION
	SELECT 'ManageCompanies', @Active WHERE @isDbOwner = 1
	UNION
	SELECT 'ManageOwnCompanies', @Active WHERE @isDbOwner = 1
	UNION
	SELECT 'ManageEmployees', @Active WHERE @isDbOwner = 1
	UNION
	SELECT 'ManageContacts', @Active WHERE @isDbOwner = 1
	UNION
	SELECT 'ManagePerson', @Active WHERE @isDbOwner = 1
	UNION
	SELECT 'ViewContactDetails', @Active WHERE @isDbOwner = 1
	UNION
	SELECT 'ViewEmployee', @Active WHERE @isDbOwner = 1
	UNION
	SELECT 'ViewEmployeeDetails', @Active WHERE @isDbOwner = 1
			
	RETURN 0
GO

GRANT EXEC ON adfCurrentUserRightsGet TO PUBLIC
GO
