﻿IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfLocalizationObjectBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfLocalizationObjectBrowse'
		DROP  Procedure  adfLocalizationObjectBrowse
	END

GO

PRINT 'Creating Procedure adfLocalizationObjectBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfLocalizationObjectBrowse
**		Desc: Возвращает списко таблиц, где хранятся локализованные данные
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfLocalizationObjectBrowse
AS
	SET NOCOUNT ON
	
	DECLARE
		@Class int = [dbo].[adfGetClassByName]('Adf.LocalizationObject')

	SELECT
		@Class AS [Class], 1 AS [State], 'ActionGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'BudgetLineGroupGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'BudgetLineGroupTypeGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'BudgetTypeGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'BudgetWarningFlagGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'ClassGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'CountryGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'CurrencyGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'DocumentGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'MailItemEventTypeGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'NotificationMessageTemplateGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'NotificationMessageTemplateTokenGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'NotificationWayGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'PropertyGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'RightGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'StateGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'SubscriptionTypeGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'TransitionTemplateGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'TrusteeGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'UICommandGlobal' AS [Name] UNION SELECT
		@Class AS [Class], 1 AS [State], 'WarningFlagGlobal' AS [Name]
 
	
	RETURN 0
GO

GRANT EXEC ON adfLocalizationObjectBrowse TO PUBLIC
GO
