IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRightDelete')
	BEGIN
		PRINT 'Dropping Procedure adfRightDelete'
		DROP  Procedure  adfRightDelete
	END

GO

PRINT 'Creating Procedure adfRightDelete'
GO
/******************************************************************************
**		File: 
**		Name: adfRightDelete
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfRightDelete
	@Name TSysname
AS
	DECLARE @result INT
	SET NOCOUNT ON
	
	EXEC @result = adfAccessRightCheck 'CreateRights'
	IF @result != 0
		RETURN @result

	DELETE 
		[Right] 
	WHERE 
		[Right].[Name] = @Name
	RETURN 0
GO

GRANT EXEC ON adfRightDelete TO PUBLIC
GO
