IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfTrusteeBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfTrusteeBrowse'
		DROP  Procedure  adfTrusteeBrowse
	END

GO

PRINT 'Creating Procedure adfTrusteeBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfTrusteeBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		05.06.13	SOV				   
*******************************************************************************/
CREATE Procedure adfTrusteeBrowse
AS
	SET NOCOUNT ON
	SELECT     
		[Trustee].[ID], 
		[Trustee].[Name], 
		[Trustee].[DisplayName],
		[Trustee].[Comments],
		[User].[SQLLogin],
		[User].[NTLogin],
		[User].[Locked],
		(CASE WHEN [User].[Locked]=0 THEN 1 ELSE 0 END) as [State],
		2 as [Type]
	FROM         
		[User] INNER JOIN [adfvwTrustee] as [Trustee] ON [User].[ID] = [Trustee].[ID]
	UNION
	SELECT     
		[Trustee].[ID], 
		[Trustee].[Name], 
		[Trustee].[DisplayName], 
		[Trustee].[Comments],
		NULL as [SQLLogin],
		NULL as [NTLogin],
		NULL as [Locked],
		1 as [State],
		1 as [Type]
	FROM         
		[Role] INNER JOIN [adfvwTrustee] as [Trustee] ON [Role].[ID] = [Trustee].[ID]
	WHERE
		[Role].[IsGroup] = 0 AND [Trustee].[Active] = 1
		AND
		([Trustee].[Name] != 'Everyone')
	UNION
	SELECT     
		[Trustee].[ID], 
		[Trustee].[Name], 
		[Trustee].[DisplayName], 
		[Trustee].[Comments],
		NULL as [SQLLogin],
		NULL as [NTLogin],
		NULL as [Locked],
		1 as [State],
		4 as [Type]
	FROM         
		[Role] INNER JOIN [adfvwTrustee] as [Trustee] ON [Role].[ID] = [Trustee].[ID]
	WHERE
		[Role].[IsGroup] = 1
	ORDER BY
		1
	RETURN 0
GO

GRANT EXEC ON adfTrusteeBrowse TO PUBLIC
GO
