IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserLicenseGet')
	BEGIN
		PRINT 'Dropping Procedure adfUserLicenseGet'
		DROP  Procedure  adfUserLicenseGet
	END

GO

PRINT 'Creating Procedure adfUserLicenseGet'
GO
/******************************************************************************
**		File: 
**		Name: adfUserLicenseGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
*******************************************************************************/
CREATE PROCEDURE adfUserLicenseGet
AS
	
	SET NOCOUNT ON

	SELECT 
		[User].[ID],
		[User].[ProductKey],
		[User].[SerialNumber],
		[User].[IsPermanent],
		[User].[InitialDate],
		[User].[ValidationData]
	FROM
		[User]
	WHERE
		[User].[ID] = dbo.adfGetCurrentUserID()
		
	RETURN 0
GO

GRANT EXEC ON adfUserLicenseGet TO PUBLIC
GO


IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserLicenseGetV2')
	BEGIN
		PRINT 'Dropping Procedure adfUserLicenseGetV2'
		DROP  Procedure  adfUserLicenseGetV2
	END

GO

PRINT 'Creating Procedure adfUserLicenseGetV2'
GO
/******************************************************************************
**		File: 
**		Name: adfUserLicenseGetV2
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		17.08.10	SPV				  InitialDate  string 
**									  Daylight
*******************************************************************************/
CREATE PROCEDURE adfUserLicenseGetV2
AS
	
	SET NOCOUNT ON

	SELECT 
		[User].[ID],
		[User].[ProductKey],
		[User].[SerialNumber],
		[User].[IsPermanent],
		CONVERT(varchar(50), [InitialDate], 126) as [InitialDate],
		[User].[ValidationData]
	FROM
		[User]
	WHERE
		[User].[ID] = dbo.adfGetCurrentUserID()
		
	RETURN 0
GO

GRANT EXEC ON adfUserLicenseGetV2 TO PUBLIC
GO
