DECLARE
	@value TVariant,
	@b bit
EXEC adfParameterGet @Name='MustRecalculateTasksAndProjects', @Group='Install', @Value = @value OUTPUT
SET @b = ISNULL(CAST(@value as bit), 0)
IF @b = 1
BEGIN
	EXEC sp_executesql N'ALTER TABLE [Project] DISABLE TRIGGER ALL'
	EXEC sp_executesql N'ALTER TABLE [Task] DISABLE TRIGGER ALL'
			
	IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[dbo].[pjm6trTaskIU]'))
		EXEC sp_executesql N'ALTER TABLE [Task] ENABLE TRIGGER pjm6trTaskIU'
	ELSE
		RAISERROR(' [dbo].[pjm6trTaskIU]  ', 16, -1)
		
	EXEC sp_executesql N'
	WITH [Budget] ([TaskID], [Budget]) AS
	(
		SELECT
			[TaskAssignment].[TaskID],
			SUM([TaskAssignment].[Work] * [Assignment].[StandardRate] / 60.0)
		FROM
			[TaskAssignment]
			INNER JOIN [Assignment]
				ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
		GROUP BY
			[TaskAssignment].[TaskID]
	)
	UPDATE
		[Task]
	SET
		[Budget] = ISNULL([Budget].[Budget], 0)
	FROM
		[Task]
		INNER JOIN [Budget]
			ON [Budget].[TaskID] = [Task].[ID]
	WHERE
		[MsTaskID] IS NULL'

	EXEC sp_executesql N'UPDATE [Project] SET [State] = [State]'

	EXEC sp_executesql N'ALTER TABLE [Task] ENABLE TRIGGER ALL'
	EXEC sp_executesql N'ALTER TABLE [Project] ENABLE TRIGGER ALL'
	SET @b = 0
	EXEC adfParameterSet 'MustRecalculateTasksAndProjects', 'Install', @b
END