IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Case') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	DELETE 
		[DocumentUserState]
	FROM
		[DocumentUserState]
		LEFT OUTER JOIN [Document]
			ON [Document].[Class] = [DocumentUserState].[DocumentClass] AND
				[Document].[ID] = [DocumentUserState].[DocumentID]
	WHERE
		[Document].[Class] IS NULL AND [Document].[ID] IS NULL
END
GO

DELETE 
	[Transition]
FROM
	[Transition]
	LEFT OUTER JOIN [Document]
		ON [Document].[Class] = [Transition].[Class] AND
			[Document].[ID] = [Transition].[DocumentID]
WHERE
	[Document].[Class] IS NULL AND [Document].[ID] IS NULL
GO

IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'TaskRequestCompleted')
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('TaskRequestCompleted', ' ')
GO
IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'TaskRequestCanceled')	
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('TaskRequestCanceled', ' ')
GO	
IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'TaskRequestPostponed')
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('TaskRequestPostponed', ' ')
GO
IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'TaskRequestAppointed')
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('TaskRequestAppointed', ' ')
ELSE
	UPDATE [MailItemEventType] SET [FileAs] = ' ' WHERE [EventType] = 'TaskRequestAppointed'
GO
IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'TaskRequestExcluded')
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('TaskRequestExcluded', '  ')
GO
IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'TaskRequestDeclined')
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('TaskRequestDeclined', ' ')
GO
IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'TaskRequestAccepted')
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('TaskRequestAccepted', ' ')
GO
IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'TaskRequestSupervisorDismissed')
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('TaskRequestSupervisorDismissed', '  ')
GO
IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'TaskRequestSupervisorAssigned')
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('TaskRequestSupervisorAssigned', '  ')
GO
IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'TaskRequestCompletionRate')
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('TaskRequestCompletionRate', ' ')
GO
IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'TaskRequestStartTime')
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('TaskRequestStartTime', '  ')
GO
IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'TaskRequestDueTime')	
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('TaskRequestDueTime', '  ')	
GO
IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'MeetingRequestExcluded')	
	INSERT INTO [MailItemEventType] ([EventType], [FileAs]) VALUES ('MeetingRequestExcluded', '  ')	
GO


IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'TaskRequestCompleted')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('TaskRequestCompleted', 'en', 'Task Request Complete')
GO
IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'TaskRequestCanceled')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('TaskRequestCanceled', 'en', 'Task Request Cancel')
GO
IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'TaskRequestPostponed')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('TaskRequestPostponed', 'en', 'Task Request Postpone')
GO
IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'TaskRequestAppointed')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('TaskRequestAppointed', 'en', 'Task Request Assignment')
ELSE
	UPDATE [MailItemEventTypeGlobal] SET [FileAs] = 'Task Request assignment',[Language] = 'en' WHERE [EventType] = 'TaskRequestAppointed'
GO
IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'TaskRequestExcluded')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('TaskRequestExcluded', 'en', 'Task Request Exclusion')
GO
IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'TaskRequestDeclined')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('TaskRequestDeclined', 'en', 'Task Request Decline')
GO
IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'TaskRequestAccepted')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('TaskRequestAccepted', 'en', 'Task Request Accept')
GO
IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'TaskRequestSupervisorDismissed')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('TaskRequestSupervisorDismissed', 'en', 'Task Request Supervisor Dismissal')
GO
IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'TaskRequestSupervisorAssigned')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('TaskRequestSupervisorAssigned', 'en', 'Task Request Supervisor Assignment')
GO
IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'TaskRequestCompletionRate')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('TaskRequestCompletionRate', 'en', 'Task Request Completion Rate Change')
GO
IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'TaskRequestStartTime')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('TaskRequestStartTime', 'en', 'Task Request Start Time')
GO
IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'TaskRequestDueTime')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('TaskRequestDueTime', 'en', 'Task Request Due Time')
GO
IF NOT EXISTS (SELECT * FROM [MailItemEventTypeGlobal] WHERE [EventType] = 'MeetingRequestExcluded')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs]) VALUES ('MeetingRequestExcluded', 'en', 'Meeting Request Exclusion')
GO

DECLARE @Class TClass
SET @Class = dbo.adfGetClassByName('Adf.EmailType')

--SET IDENTITY_INSERT [EmailType] ON

--IF NOT EXISTS (SELECT * FROM [DocumentGlobal] WHERE [Class] = @Class and [Language] = 'ru' and [ID] = 5)
--	INSERT INTO [DocumentGlobal] ([Class], [ID], [Language], [FileAs]) VALUES (@Class, 5, 'ru', '')
--IF NOT EXISTS (SELECT * FROM [DocumentGlobal] WHERE [Class] = @Class and [Language] = 'en' and [ID] = 5)
--	INSERT INTO [DocumentGlobal] ([Class], [ID], [Language], [FileAs]) VALUES (@Class, 5, 'en', 'Skype')
--IF NOT EXISTS (SELECT * FROM [EmailType] WHERE [ID] = 5)
--	INSERT INTO [EmailType] ([ID], [State], [Flag], [FileAs]) VALUES (5, 100, 0, '')

--SET IDENTITY_INSERT [EmailType] OFF
--GO
	

UPDATE
	[F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53]
SET
	[Group] = 'CommonBusiness'
WHERE
	[Group] = 'CommmonBusiness' AND
	NOT EXISTS (
		SELECT * 
		FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] AS p 
		WHERE
			p.[Group] = 'CommonBusiness' AND
			p.[Name] = [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53].[Name]
		)
	
GO

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'CommonBusiness' AND [Name]='ApplyVAT')
BEGIN
	DECLARE @true bit
	SET @true = 1
	EXEC adfParameterSet 'ApplyVAT', 'CommonBusiness', @true 
END
GO

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'Pjm6' AND [Name]='UncheckTimeEntrySentToApproval')
BEGIN
	DECLARE @false bit
	SET @false = 0
	EXEC adfParameterSet 'UncheckTimeEntrySentToApproval', 'Pjm6', @false
END
GO

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'Pjm5' AND [Name]='WordTemplatesDirectory')
BEGIN
	EXEC adfParameterSet 'WordTemplatesDirectory', 'Pjm5', null
END
GO

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'Pjm5' AND [Name]='AdvancedTimeExpensesForm')
BEGIN
	DECLARE @false bit
	SET @false = 0
	EXEC adfParameterSet 'AdvancedTimeExpensesForm', 'Pjm5', @false
END
GO

IF EXISTS(SELECT * FROM [Right] WHERE [Name] = 'AccessToPublicFolders')
BEGIN
    UPDATE 
		[Right] 
	SET 
		[Name] = 'AccessToFolders' 
	WHERE 
		[Name] = 'AccessToPublicFolders'
END
GO

UPDATE 
	[ReminderType]
SET 
	[DefaultState] = 1
GO

IF EXISTS (SELECT [Rate] FROM [CurrencyRate] WHERE [Rate] = 0)
BEGIN
	UPDATE [CurrencyRate]
	SET [Rate] = 1
	WHERE [Rate] = 0
END
GO

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'Pjm6' AND [Name]='EnabledTasks')
BEGIN
	DECLARE @flag bit
	SET @flag = 0
	IF EXISTS (SELECT * FROM [Task] WHERE [State] = 2)
	BEGIN
		SET @flag = 1
	END
	EXEC adfParameterSet 'EnabledTasks', 'Pjm6', @flag
END
GO

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'Pjm6' AND [Name]='EnabledServiceRequest')
BEGIN
	DECLARE @flag bit
	SET @flag = 0
	IF EXISTS (SELECT * FROM [ServiceRequest] WHERE [State] = 2)
	BEGIN
		SET @flag = 1
	END
	EXEC adfParameterSet 'EnabledServiceRequest', 'Pjm6', @flag
END
GO

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'CommonBusiness' AND [Name]='PaymentCurrencyPoint')
BEGIN
	DECLARE @paymentDate bit
	SET @paymentDate = 1
	EXEC adfParameterSet 'PaymentCurrencyPoint', 'CommonBusiness', @paymentDate 
END
GO

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'Pjm6' AND [Name]='GroupingAdvanceCalculations')
BEGIN
	DECLARE @flag int
	SET @flag = 0
	EXEC adfParameterSet 'GroupingAdvanceCalculations', 'Pjm6', @flag
END
GO

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'CommonBusiness' AND [Name]='StatementCurrencyPoint')
BEGIN
	DECLARE @flag int
	SET @flag = 0
	EXEC adfParameterSet 'StatementCurrencyPoint', 'CommonBusiness', @flag
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'XmlParameters') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [XmlParameters] (
		Name                 TName				NOT NULL,
		Value				 XML				NULL,
		Created              TSysDateTime       NOT NULL DEFAULT GETDATE(),
		CreatedBy            TUserID            NOT NULL,
		Modified             TSysDateTime       NOT NULL DEFAULT GETDATE(),
		ModifiedBy           TUserID            NOT NULL
		constraint XmlParametersPK primary key  (Name)
	)
END
ELSE
BEGIN
	IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS pk, INFORMATION_SCHEMA.KEY_COLUMN_USAGE c WHERE pk.TABLE_NAME = 'XmlParameters' AND CONSTRAINT_TYPE = 'PRIMARY KEY' AND c.TABLE_NAME = pk.TABLE_NAME AND c.CONSTRAINT_NAME = pk.CONSTRAINT_NAME)
	BEGIN
		ALTER TABLE XmlParameters ADD CONSTRAINT XmlParametersPK primary key (Name)
	END
END
GO