DECLARE
	@true bit,
	@false bit
SELECT @true = 1, @false = 0

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'Pjm6' AND [Name]='ExchangeContactSyncMode')
	EXEC adfParameterSet 'ExchangeContactSyncMode', 'Pjm6', 0
IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'Pjm6' AND [Name]='ExchangeSyncContacts')
	EXEC adfParameterSet 'ExchangeSyncContacts', 'Pjm6', @false
IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'Pjm6' AND [Name]='ExchangeSyncCalendars')
	EXEC adfParameterSet 'ExchangeSyncCalendars', 'Pjm6', @false
IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'Pjm6' AND [Name]='ExchangeSyncMeetingRequests')
	EXEC adfParameterSet 'ExchangeSyncMeetingRequests', 'Pjm6', @false
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'ExchangeSync') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: ExchangeSync                                          */
/*==============================================================*/
CREATE TABLE ExchangeSync
(
	UserID			TIdentifier		NOT NULL,
	DocumentClass	TClass			NOT NULL,
	DocumentID		TIdentifier		NOT NULL,
	Date			TDate			NOT NULL	DEFAULT GETDATE(),
	ExchangeID		TGuid			NULL,			
	CONSTRAINT ExchangeSyncPK PRIMARY KEY (UserID, DocumentClass, DocumentID)
)
GO

--DELETE [ExchangeSync]
--WHERE
--	NOT EXISTS
--	(
--		SELECT * FROM [UserContact]
--		WHERE
--			[UserContact].[UserID] = [ExchangeSync].[UserID] AND 
--			[UserContact].[BusinessCardClass] = [ExchangeSync].[DocumentClass] AND
--			[UserContact].[BusinessCardID] = [ExchangeSync].[DocumentID]
--	)
--GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'ExchangeDocumentSync') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: ExchangeDocumentSync                                  */
/*==============================================================*/
create table ExchangeDocumentSync (
   DocumentClass        TClass               not null,
   DocumentID           TIdentifier          not null,
   UserID               TIdentifier          not null,
   constraint ExchangeDocumentSyncPK primary key  (DocumentClass, DocumentID, UserID)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'ExchangeAttributesForSync') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: ExchangeAttributesForSync                             */
/*==============================================================*/
create table ExchangeAttributesForSync (
   DocumentID           TIdentifier          not null,
   DocumentClass        TClass               not null,
   UserID               TIdentifier          not null,
   constraint ExchangeAttributesForSyncPK primary key  (DocumentID, DocumentClass, UserID)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'ExchangeNewImportDocument') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: ExchangeNewImportDocument                             */
/*==============================================================*/
create table ExchangeNewImportDocument (
   DocumentClass        TClass               not null,
   DocumentID           TIdentifier          not null,
   UserID               TIdentifier          not null,
   [Date]				TDate				 not null,
   constraint ExchangeNewImportDocumentPK primary key  (DocumentClass, DocumentID, UserID)
)
go

