﻿
if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[fnGetEmployeeByEmail]') AND xtype IN (N'FN', N'IF', N'TF'))
begin
	print 'Dropping function fnGetEmployeeByEmail'
	drop function [exch].[fnGetEmployeeByEmail]
end
GO

print 'Creating function fnGetEmployeeByEmail'
go

create function [exch].[fnGetEmployeeByEmail](@Email THref, @CompanyID TIdentifier)
returns int
as
begin
	declare @employeeId int;

	select
		@employeeId = max([Employee].[ID])
	from
		[dbo].[Employee] inner join [dbo].[Email]
			on ([Employee].[ID] = [Email].[BusinessCardID] and [Employee].[Class] = [Email].[BusinessCardClass])
	where
		(@CompanyID is null or [Employee].[CompanyID] = @CompanyID)
	and
		[Email].[Email] = @Email
	and
		[State] = 1
	group by
		[Employee].[ID]
	having
		count(*) = 1;

	return @employeeId;
end;


go