﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[CleanUpSyncData]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure CleanUpSyncData'
	drop procedure [exch].[CleanUpSyncData]
end
go

print 'Creating procedure CleanUpSyncData'
go

create procedure [exch].[CleanUpSyncData]
as
begin
	set nocount on;

	if dbo.adfHasAccessRightByName('CleanUpSyncData') = 0
	begin
		raiserror('#accessdenied', 18, -1)
		return 1;
	end

	exec [dbo].[adfParameterSet] 'CleanUpSyncData', 'ExchangeSync', 1;

	return 0;
end
go

grant execute on [exch].[CleanUpSyncData] to [public]
go

