﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[ExchangeLinkTearOff]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure ExchangeLinkTearOff'
	drop procedure [exch].[ExchangeLinkTearOff]
end
go

print 'Creating procedure ExchangeLinkTearOff'
go

create procedure [exch].[ExchangeLinkTearOff] @userID TIdentifier, @class TName, @documentID TIdentifier, @exchangeID varchar(max)
with execute as 'pjmexchangesync'
as
begin
	set nocount on;

	declare @documentClass TClass;

	if @exchangeID is not null
	begin
		select 	
			@documentClass = [DocumentClass],
			@documentID = [DocumentID]
		from
			[exch].[ExchangeLink]
		where
			[ExchangeID] = @exchangeID and [UserID] = @userID;
	end
	else
	begin
		set @documentClass = dbo.adfGetClassByName(@Class);
	end


	begin transaction

	delete [exch].[ExchangeLink] 
	where
		[UserID] = @userID and [DocumentClass] = @documentClass and [DocumentID] = @documentId;

	if @@error != 0
	begin
		rollback transaction;
		return 1;
	end

	delete [dbo].[ExchangeDocumentSync]
	where
		[UserID] = @userID and [DocumentClass] = @documentClass and [DocumentID] = @documentId;

	if @@error != 0
	begin
		rollback transaction;
		return 1;
	end

	commit transaction;

	return 0;
end

GO


grant execute on [exch].[ExchangeLinkTearOff] to [projectmateservice];
go
