IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5AddressAsString]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5AddressAsString'
		DROP FUNCTION [dbo].[fnPjm5AddressAsString]
	END

GO

PRINT 'Creating function fnPjm5AddressAsString'
GO
/******************************************************************************
**		File: 
**		Name: AddressAsString
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5AddressAsString
	(
	@Street				TName,
	@City				TCity,
	@Region				TName,
	@PostalCode			TPostalCode,
	@Country			TName
	)
RETURNS TName
AS
BEGIN
	DECLARE
		@result TName
	/*SET @result = ISNULL(@Street, '')
	IF @City IS NOT NULL
		SET @result = '.' + @City + ', ' + @result
	IF @Region IS NOT NULL
		SET @result = @Region + ', ' + @result
	IF @Country IS NOT NULL
		SET @result = @Country + ', ' + @result
	IF @PostalCode IS NOT NULL
		SET @result = @PostalCode + ', ' + @result
	IF @result = '' 
		SET @result = NULL	*/
		
	SET @result = ISNULL(@PostalCode, '')
	IF @Country IS NOT NULL
		BEGIN 
		IF @result != '' 
			SET @result = @result + ', '
		SET @result = @result + @Country
		END
	IF @Region IS NOT NULL 
		BEGIN
		IF @result != '' 
			SET @result = @result + ', '
		SET @result = @result + @Region	
		END
	IF @City IS NOT NULL 
		BEGIN
		IF @result != '' 
			SET @result = @result + ', '
		SET @result = @result + '.' + char(160) + @City --   
		END		
	IF @Street IS NOT NULL 
		BEGIN
		IF @result != '' 
			SET @result = @result + ', '
		SET @result = @result + @Street	
		END	
	IF @result = '' 
		SET @result = NULL	

	RETURN @result
END
GO

GRANT EXEC ON fnPjm5AddressAsString TO PUBLIC
GO
