IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6NumberGetDefaultPeriodType]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6NumberGetDefaultPeriodType'
		DROP FUNCTION [dbo].[fnPjm6NumberGetDefaultPeriodType]
	END

GO

PRINT 'Creating function fnPjm6NumberGetDefaultPeriodType'
GO
/******************************************************************************
**		File: NumberGetDefaultPeriodType
**		Name: fnPjm6NumberGetDefaultPeriodType
**		Desc:       
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	-------			-------------------------------------------
**		20.07.11	SPV				first version
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6NumberGetDefaultPeriodType
(
	@TemplateClass TClass,
	@ApplyLevel tinyint
)
RETURNS tinyint
AS
BEGIN
	DECLARE
		@Employee TClass,
		@Invoice TClass,
		@Statement TClass,
		@Facture TClass,
		@Project TClass,
		@Contract TClass,
		@CreditMemo TClass,
		@ServiceRequest TClass,
		@Calculation TClass,
		@Result tinyint
		
	SELECT
		@Employee = dbo.adfGetClassByName('Adf.Employee'),
		@Invoice = dbo.adfGetClassByName('Pjm5.Invoice'),
		@Statement = dbo.adfGetClassByName('Pjm5.Statement'),
		@Facture = dbo.adfGetClassByName('Pjm5.Facture'),
		@Project = dbo.adfGetClassByName('Pjm5.Project'),
		@Contract = dbo.adfGetClassByName('Pjm5.Contract'),
		@CreditMemo = dbo.adfGetClassByName('Pjm5.CreditMemo'),
		@ServiceRequest = dbo.adfGetClassByName('Pjm5.ServiceRequest'),
		@Calculation = dbo.adfGetClassByName('Pjm5.Calculation')
	
	IF	@TemplateClass IN (@Invoice, @Statement, @Facture, @ServiceRequest, @Calculation, @CreditMemo) AND
		@ApplyLevel = 0 --    
	BEGIN
		SET @Result = 1 --   
	END
	ELSE
	BEGIN
		SET @Result = 0 -- 
	END
	
	RETURN(@Result)
END
GO

GRANT EXEC ON fnPjm6NumberGetDefaultPeriodType TO PUBLIC
GO