IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetAvailableProjectsForTimeBrowse]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetAvailableProjectsForTimeBrowse'
		DROP FUNCTION [dbo].[fnPjm6GetAvailableProjectsForTimeBrowse]
	END

GO

PRINT 'Creating function fnpjm6GetAvailableProjectsForTimeBrowse'
GO
/******************************************************************************
**		File:	fnPjm6GetAvailableProjectsForTimeBrowse.sql
**		Name: 	fnPjm6GetAvailableProjectsForTimeBrowse
**		Desc:	       
**				  ,        
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	10.03.09	ENB			 
**
**		27.03.09	ENB			     
**								 ,     
**								view,      .
**
**		04.05.09	ENB			    ViewAllProjects
**
**		26.08.10	SPV			     ( -1)
**
**		14.10.11	PAM			   
**		03.04.13	SOV			    . - 
**								     " "
**		13.05.13	SOV			    . -  . -
**		27.08.13	SOV			  ,      
**		05.09.13	SOV			  . -    -;
**								  ,      
*******************************************************************************/
CREATE FUNCTION fnPjm6GetAvailableProjectsForTimeBrowse (
	@ProjectSelector	int,
	@ActiveProjectID	TIdentifier,
	@NotActiveProjectID TIdentifier
)

RETURNS @Projects TABLE ([ID] INT PRIMARY KEY, [CustomerCompanyID] TIdentifier,
	[ViewFinance] INT NOT NULL DEFAULT 0, [ProjectTypeID] TIdentifier, [CostCenterID] int, 
	[ViewBillableHour] bit DEFAULT 0) --          , 
									  --       

AS 
BEGIN

	DECLARE 
		@ViewAllFinance TBool,
		@ViewFinance TBool,
		@ViewAllProjects TBool,
		@CanBeManagerAssistant TBool,
		@ManageProject TBool,
		@Assistant TBool,
		@CurrentEmployeeID TIdentifier

	SELECT 
		@ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID ('ViewAllFinance')),
		@ViewFinance = dbo.adfHasAccessRight(dbo.adfGetRightID ('ViewFinance')),
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID( 'ViewAllProjects')),
		@ManageProject = dbo.adfHasAccessRight(dbo.adfGetRightID ('ManageProject')),
		@Assistant = dbo.adfHasAccessRight(dbo.adfGetRightID ('Assistant')),
		@CanBeManagerAssistant = dbo.adfHasAccessRight(dbo.adfGetRightID ('CanBeProjectManagerAssistant')),
		@CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()

--   
	IF (@ViewAllProjects = 1 AND @Assistant = 1) OR @ViewAllFinance = 1
	BEGIN
		INSERT INTO @Projects ([ID], [ViewFinance], [CustomerCompanyID], [ProjectTypeID], [CostCenterID])
		SELECT
			[Project].[ID], 0, [Project].[CustomerCompanyID], [Project].[ProjectTypeID], [Project].[CostCenterID]
		FROM
			[Project]
		WHERE
			(@ProjectSelector = 0) 
				OR
			(@ProjectSelector = 1 AND
				( 
					(@ActiveProjectID IS NULL AND [Project].[State] = 2) OR
					(@ActiveProjectID IS NOT NULL AND [Project].[ID] = @ActiveProjectID)
				)
			) 
				OR
			(@ProjectSelector = 2 AND 
				(
					(@NotActiveProjectID IS NULL AND [Project].[State] != 2) OR
					(@NotActiveProjectID IS NOT NULL AND [Project].[ID] = @NotActiveProjectID)
				)
			)
		--    (      )
		IF @ProjectSelector = 0
			INSERT INTO @Projects ([ID], [ViewFinance], [CustomerCompanyID], [ProjectTypeID])
			VALUES (-1, 0, NUll, NUll)
	END
	ELSE BEGIN 
	
	--  ,    
		INSERT INTO @Projects ([ID], [ViewFinance], [CustomerCompanyID], [ProjectTypeID], [CostCenterID], [ViewBillableHour])
		SELECT [Project].[ID], 0, [Project].[CustomerCompanyID], [Project].[ProjectTypeID], [Project].[CostCenterID],
			CASE WHEN [AP].[Administrator] = 1 OR [AP].[Approver] = 1 THEN 1
				ELSE 0  
			END 
		FROM   [Project]
			INNER JOIN (	
				SELECT
					[Assignment].[ProjectID],
					[Assignment].[Administrator],
					[Assignment].[Approver]
				FROM
					[Assignment] 
				WHERE 	
					[Assignment].[ID] IN (
						SELECT [AssignmentEntry].[AssignmentID]
						FROM   [AssignmentEntry]
						WHERE  
							[AssignmentEntry].[EmployeeID] = @CurrentEmployeeID
					) AND
				   ([Assignment].[State] = 1)
				) AS AP
			ON [Project].[ID] = [AP].[ProjectID] 
			AND	
			((@ProjectSelector = 0) 
				OR
			(@ProjectSelector = 1 AND
				( 
					(@ActiveProjectID IS NULL AND [Project].[State] = 2) OR
					(@ActiveProjectID IS NOT NULL AND [Project].[ID] = @ActiveProjectID)
				)
			) 
				OR
			(@ProjectSelector = 2 AND 
				(
					(@NotActiveProjectID IS NULL AND [Project].[State] != 2) OR
					(@NotActiveProjectID IS NOT NULL AND [Project].[ID] = @NotActiveProjectID)
				)
			))

		--   ,   . -,     , 
		--  ,    
		IF @CanBeManagerAssistant = 1 BEGIN
			INSERT INTO @Projects ([ID], [ViewFinance], [CustomerCompanyID], [ProjectTypeID], [CostCenterID], [ViewBillableHour])
			SELECT
				[Project].[ID], 0, [Project].[CustomerCompanyID], [Project].[ProjectTypeID], [Project].[CostCenterID], 1
			FROM
				[Project]
			WHERE
				(
					[Project].[ID] NOT IN (SELECT [ID] FROM @Projects)
				)	
					AND
				(
					[Project].[ManagerAssistantEmployeeID] = @CurrentEmployeeID
				)
					AND	
				((@ProjectSelector = 0) 
					OR
				(@ProjectSelector = 1 AND
					( 
						(@ActiveProjectID IS NULL AND [Project].[State] = 2) OR
						(@ActiveProjectID IS NOT NULL AND [Project].[ID] = @ActiveProjectID)
					)
				) 
					OR
				(@ProjectSelector = 2 AND 
					(
						(@NotActiveProjectID IS NULL AND [Project].[State] != 2) OR
						(@NotActiveProjectID IS NOT NULL AND [Project].[ID] = @NotActiveProjectID)
					)
				))
		END

	--   ,   ,     , 
	--  ,    
		IF @ManageProject = 1 BEGIN
			INSERT INTO @Projects ([ID], [ViewFinance], [CustomerCompanyID], [CostCenterID], [ProjectTypeID])
			SELECT
				[Project].[ID], 1, [Project].[CustomerCompanyID], [Project].[CostCenterID], [Project].[ProjectTypeID]
			FROM
				[Project]
			WHERE
				(
					[Project].[ID] NOT IN (SELECT [ID] FROM @Projects)
				)	
					AND
				(
					[Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				)
					AND	
				((@ProjectSelector = 0) 
					OR
				(@ProjectSelector = 1 AND
					( 
						(@ActiveProjectID IS NULL AND [Project].[State] = 2) OR
						(@ActiveProjectID IS NOT NULL AND [Project].[ID] = @ActiveProjectID)
					)
				) 
					OR
				(@ProjectSelector = 2 AND 
					(
						(@NotActiveProjectID IS NULL AND [Project].[State] != 2) OR
						(@NotActiveProjectID IS NOT NULL AND [Project].[ID] = @NotActiveProjectID)
					)
				))
		END	

		--   ,   . ,     , 
		--  ,    
		IF @ViewFinance = 1 BEGIN
			INSERT INTO @Projects ([ID], [ViewFinance], [CustomerCompanyID], [ProjectTypeID], [CostCenterID])
			SELECT
				[Project].[ID], 1, [Project].[CustomerCompanyID], [Project].[ProjectTypeID], [CostCenterID]
			FROM
				[Project]
			WHERE
				(
					[Project].[ID] NOT IN (SELECT [ID] FROM @Projects)
				)	
					AND
				(
					[Project].[FinanceManagerEmployeeID] = @CurrentEmployeeID
				)
					AND	
				((@ProjectSelector = 0) 
					OR
				(@ProjectSelector = 1 AND
					( 
						(@ActiveProjectID IS NULL AND [Project].[State] = 2) OR
						(@ActiveProjectID IS NOT NULL AND [Project].[ID] = @ActiveProjectID)
					)
				) 
					OR
				(@ProjectSelector = 2 AND 
					(
						(@NotActiveProjectID IS NULL AND [Project].[State] != 2) OR
						(@NotActiveProjectID IS NOT NULL AND [Project].[ID] = @NotActiveProjectID)
					)
				))
		END
	END
	
--	     
	IF @ViewAllFinance = 1 
	--   
		UPDATE @Projects SET [ViewFinance] = 1
	
	ELSE BEGIN  

	--    	
	--   ,   , . - 
		UPDATE @Projects SET [ViewFinance] = 1
		WHERE ID IN (
			SELECT
				[ID]
			FROM
				[Project] 
			WHERE
				([Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID AND @ManageProject = 1) OR
				([Project].[FinanceManagerEmployeeID] = @CurrentEmployeeID AND @ViewFinance = 1)
		)

	--        
		IF dbo.adfHasAccessRight(dbo.adfGetRightID ('ViewFinance')) = 1 BEGIN
			UPDATE @Projects SET [ViewFinance] = 1
			WHERE ID IN (
				SELECT
					[Assignment].[ProjectID]
				FROM
					[Assignment] 
				WHERE 	
					[Assignment].[ID] IN (
						SELECT [AssignmentEntry].[AssignmentID]
						FROM   [AssignmentEntry]
						WHERE  
							[AssignmentEntry].[EmployeeID] = @CurrentEmployeeID
					) AND
					[Assignment].[FinanceManagement] = 1 AND
				    [Assignment].[State] = 1
				)
		END

	--    	
	--   ,   . - 
	IF ( @CanBeManagerAssistant = 1)
	BEGIN
		UPDATE @Projects SET [ViewBillableHour] = 1
		WHERE ID IN (
			SELECT
				[ID]
			FROM
				[Project] 
			WHERE
				[Project].[ManagerAssistantEmployeeID] = @CurrentEmployeeID)
	END

		--          
		UPDATE @Projects SET [ViewBillableHour] = 1
		WHERE ID IN (
			SELECT
				[Assignment].[ProjectID]
			FROM
				[Assignment] 
			WHERE 	
				[Assignment].[ID] IN (
					SELECT [AssignmentEntry].[AssignmentID]
					FROM   [AssignmentEntry]
					WHERE  
						[AssignmentEntry].[EmployeeID] = @CurrentEmployeeID						
				) AND
				[Assignment].[State] = 1 AND ([Assignment].[Approver] = 1 OR [Assignment].[Administrator] = 1)
			)
	END

	RETURN
END
	
GO
