IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetAvailableProjectsForTimeEntryGet]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetAvailableProjectsForTimeEntryGet'
		DROP FUNCTION [dbo].[fnPjm6GetAvailableProjectsForTimeEntryGet]
	END

GO

PRINT 'Creating function fnPjm6GetAvailableProjectsForTimeEntryGet'
GO
/******************************************************************************
**		File:	fnPjm6GetAvailableProjectsForTimeBrowse.sql
**		Name: 	fnPjm6GetAvailableProjectsForTimeBrowse
**		Desc:	
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**		01.04.13	SOV			 ,    . -
*******************************************************************************/
CREATE FUNCTION fnPjm6GetAvailableProjectsForTimeEntryGet (
	@EmployeeID int, @ProjectID int
)
RETURNS @Projects TABLE ([ID] INT PRIMARY KEY)

AS 
	BEGIN
		DECLARE @LastProjects TABLE ([ID] TIdentifier)
		DECLARE @FreqProjects TABLE ([ID] TIdentifier)
		DECLARE
			@ProjectClass TClass,
			@UserID TIdentifier
		
		
		SET @ProjectClass = dbo.adfGetClassByName('Pjm5.Project')
		SELECT @UserID = [UserID] FROM [Employee] WHERE [ID] = @EmployeeID
		
		INSERT INTO @LastProjects ([ID])
		SELECT [DocumentID] FROM [LastDocument]
		WHERE [DocumentClass] = @ProjectClass AND [EmployeeID] = @EmployeeID
		
		INSERT INTO @FreqProjects
		SELECT [ProjectID] FROM [CalendarProject] WHERE [UserID] = @UserID
		
		INSERT INTO @Projects([ID])
		SELECT
			[Project].[ID]
		FROM 
			[Project]
		WHERE
			[State] = 2 AND
			(
				[ProjectManagerEmployeeID] = @EmployeeID OR  
				dbo.fnPjm5IsProjectMember([Project].[ID], @EmployeeID) = 1 OR
				dbo.fnPjm7IsManagerAssistant([Project].[ID], @EmployeeID) = 1 OR
				dbo.fnPjm5IsAssistant() = 1
			) AND --
			(
				(
					@ProjectID = -1 AND [Project].[ID] IN (SELECT [ID] FROM @LastProjects)
					
				) OR --   
				(
					@ProjectID = -2 AND
					dbo.fnPjm5IsProjectMember([Project].[ID], @EmployeeID) = 1
				) OR --   
				(
					@ProjectID = -3 AND
					[ProjectManagerEmployeeID] = @EmployeeID
				) OR --  
				(
					@ProjectID = -4 AND [Project].[ID] IN (SELECT [ID] FROM @FreqProjects)
				) OR -- 
				(
					@ProjectID = 0
				) OR
				(@ProjectID not in (0, -1, -2, -3, -4))
			)
		RETURN

	END
	
GO
