IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm6GetDurationFormatted') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetDurationFormatted'
		DROP FUNCTION [dbo].fnPjm6GetDurationFormatted
	END

GO

PRINT 'Creating Procedure fnPjm6GetDurationFormatted'
GO
/******************************************************************************
**		File:	fnPjm6GetDurationFormatted.sql
**		Name: 	fnPjm6GetDurationFormatted
**		Desc:	returns formatted time interval
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	10.11.09		PAM		first version
*******************************************************************************/

CREATE FUNCTION fnPjm6GetDurationFormatted(@duration TCount)
RETURNS varchar(64)
BEGIN
	DECLARE
		@Language TCode,
		@SecondsStr		varchar(4),
		@MinutesStr		varchar(4),
		@HourStr		varchar(4),
		@HoursStr		varchar(5),
		@SecDif			int,
		@MinDif			int,
		@HoursDif		int,
			 
		@Result varchar(64)

	SET @Result = ''
	SET @HoursDif = 0
	SET @MinDif = 0
	SET @SecDif = 0
	SET @language = dbo.adfGetLanguage()
	IF(@Language = 'en')
	BEGIN
		SET @SecondsStr = 'sec.'
		SET @MinutesStr = 'min.'
		SET @HourStr = 'hour'
		SET @HoursStr = 'hours'
	END
	ELSE IF(@Language = 'ru')
	BEGIN
		SET @SecondsStr = '.'
		SET @MinutesStr = '.'
		SET @HourStr = ''
		SET @HoursStr = '.'
	END	

	SET @MinDif = @duration / 60
	SET @HoursDif = @MinDif / 60
	
	IF(@HoursDif > 0)
	BEGIN
		SET @Result = CAST(@HoursDif AS varchar) + ' '
		IF(@HoursDif = 1)
			SET @Result = @Result + @HoursDif
		ELSE
			SET @Result = @Result + @HoursDif
	END
	
	IF(@MinDif > 0)
	BEGIN
		IF(@Result = '')
			SET @Result = CAST(@MinDif AS varchar) + ' ' + @MinutesStr
		ELSE
			SET @Result = @Result + ' ' + CAST(@MinDif AS varchar) + ' ' + @MinutesStr
		
	END
	SET @SecDif = @duration - (60 * @MinDif) - (120 * @HoursDif)
	IF(@SecDif > 0)
	BEGIN
		IF(@Result = '')
			SET @Result = CAST(@SecDif AS varchar) + ' ' + @SecondsStr
		ELSE
			SET @Result = @Result + ' ' + CAST(@SecDif AS varchar) + ' ' + @SecondsStr
	END
	
	IF(@SecDif <= 0 AND @MinDif <= 0 AND @HoursDif <= 0)
		SET @Result = '0 ' + @SecondsStr
	
	RETURN @Result
END
GO
