﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm7GetMonthName]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7GetMonthName'
		DROP FUNCTION [dbo].[fnPjm7GetMonthName]
	END

GO

PRINT 'Creating function fnPjm7GetMonthName'
GO
/******************************************************************************
**		File: fnPjm7GetMonthName.sql
**		Name: fnPjm7GetMonthName
**		Desc: Функция возвращает название месяца на одном из языков
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: anton.paramonov
**		Date: 24.04.2012 17:05
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm7GetMonthName
(
      @Month int,
	  @LangCode TCode3,
	  @Declination TBool
)

RETURNS nvarchar(20)

AS
BEGIN

DECLARE
	@MonthName nvarchar(20)


IF(@LangCode = 'en')
BEGIN
	SET @MonthName = CASE @Month
						WHEN 1 THEN 'January'
						WHEN 2 THEN 'February'
						WHEN 3 THEN 'March'
						WHEN 4 THEN 'April'
						WHEN 5 THEN 'May'
						WHEN 6 THEN 'June'
						WHEN 7 THEN 'July'
						WHEN 8 THEN 'August'
						WHEN 9 THEN 'September'
						WHEN 10 THEN 'October'
						WHEN 11 THEN 'November'
						WHEN 12 THEN 'December'
					END
END
ELSE IF(@LangCode = 'ru')
BEGIN

		SET @MonthName = CASE
						WHEN @Month = 1 AND @Declination = 0 THEN 'Январь'
						WHEN @Month = 2 AND @Declination = 0 THEN 'Февраль'
						WHEN @Month = 3 AND @Declination = 0 THEN 'Март'
						WHEN @Month = 4 AND @Declination = 0 THEN 'Апрель'
						WHEN @Month = 5 AND @Declination = 0 THEN 'Май'
						WHEN @Month = 6 AND @Declination = 0 THEN 'Июнь'
						WHEN @Month = 7 AND @Declination = 0 THEN 'Июль'
						WHEN @Month = 8 AND @Declination = 0 THEN 'Август'
						WHEN @Month = 9 AND @Declination = 0 THEN 'Сентябрь'
						WHEN @Month = 10 AND @Declination = 0 THEN 'Октябрь'
						WHEN @Month = 11 AND @Declination = 0 THEN 'Ноябрь'
						WHEN @Month = 12 AND @Declination = 0 THEN 'Декабрь'
						WHEN @Month = 1 AND @Declination = 1 THEN 'Января'
						WHEN @Month = 2 AND @Declination = 1 THEN 'Февраля'
						WHEN @Month = 3 AND @Declination = 1 THEN 'Марта'
						WHEN @Month = 4 AND @Declination = 1 THEN 'Апреля'
						WHEN @Month = 5 AND @Declination = 1 THEN 'Мая'
						WHEN @Month = 6 AND @Declination = 1 THEN 'Июня'
						WHEN @Month = 7 AND @Declination = 1 THEN 'Июля'
						WHEN @Month = 8 AND @Declination = 1 THEN 'Августа'
						WHEN @Month = 9 AND @Declination = 1 THEN 'Сентября'
						WHEN @Month = 10 AND @Declination = 1 THEN 'Октября'
						WHEN @Month = 11 AND @Declination = 1 THEN 'Ноября'
						WHEN @Month = 12 AND @Declination = 1 THEN 'Декабря'
					END
END

RETURN @MonthName

END