IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetEmployeeRate]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetEmployeeRate'
		DROP FUNCTION [dbo].[fnPjm5GetEmployeeRate]
	END

GO

PRINT 'Creating function fnPjm5GetEmployeeRate'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetEmployeeRate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    28.01.10		SYV				  @WithDeactivate   
**									 
**	  03.03.10		SYV				   ServiceAssignment
*******************************************************************************/
CREATE FUNCTION fnPjm5GetEmployeeRate(@EmployeeID TIdentifier, @ProjectID TIdentifier, @Overtime TBool, @ServiceAssignmentID TIdentifier = NULL, @WithDeactivate TBool)
RETURNS TMoney
AS
BEGIN
	DECLARE 
		@Rate TMoney,
		@AlwaysUseRate TBool
		
	IF(@WithDeactivate = 1)
	BEGIN	
		SELECT TOP(1)
			@Rate = (CASE WHEN @Overtime != 0 THEN [OvertimeRate] ELSE [StandardRate] END),
			@AlwaysUseRate = [AlwaysUseRate]
		FROM
			[vwAssignment]
		WHERE
			[ProjectID] = @ProjectID AND [EmployeeID] = @EmployeeID
		ORDER BY [Modified] DESC
	END
	ELSE
	BEGIN
		SELECT
			@Rate = (CASE WHEN @Overtime != 0 THEN [OvertimeRate] ELSE [StandardRate] END),
			@AlwaysUseRate = [AlwaysUseRate]
		FROM
			[vwAssignment]
		WHERE
			[ProjectID] = @ProjectID AND [EmployeeID] = @EmployeeID AND [State]=1
	END
	
	IF @ServiceAssignmentID IS NOT NULL
	BEGIN
		DECLARE
			@Price TMoney,
			@RateMultiplier TAmount
			
		SELECT
			@Price = [Price],
			@RateMultiplier = [RateMultiplier]
		FROM 
			[ServiceAssignment]		
		WHERE
			[ID] = @ServiceAssignmentID
		AND
			[PaymentTermID] = 3
		
		IF @AlwaysUseRate = 0
		BEGIN	
			IF @Price IS NOT NULL	
				SET @Rate = @Price
		END
		IF @RateMultiplier IS NOT NULL
			SET @Rate = ROUND(@Rate * @RateMultiplier, 2)
	END
	
	RETURN @Rate
END
GO

