﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm7ExchangeGetModifiedDateForTimeEntry]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7ExchangeGetModifiedDateForTimeEntry'
		DROP FUNCTION [dbo].[fnPjm7ExchangeGetModifiedDateForTimeEntry]
	END

GO

PRINT 'Creating function fnPjm7ExchangeGetModifiedDateForTimeEntry'
GO
/******************************************************************************
**		File: fnPjm7ExchangeGetModifiedDateForTimeEntry.sql
**		Name: fnPjm7ExchangeGetModifiedDateForTimeEntry
**		Desc: Функция возвращает
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: anton.paramonov	
**		Date: 20.04.12 15:45
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm7ExchangeGetModifiedDateForTimeEntry
	(@TimeEntryID TIdentifier, @ReminderModifiedDate TDate, @UserReminderModifiedDate TDate)
RETURNS TDate
AS
BEGIN
	DECLARE 
		@TimeEntryClass TClass,
		@TransitionTemplateModifiedDate	TDate

		SET @TimeEntryClass = dbo.adfGetClassByName('Pjm5.TimeEntry')

	SET @TransitionTemplateModifiedDate = 
		(SELECT MAX([Transition].[Created]) 
			FROM 
				[Transition]
				INNER JOIN [TransitionTemplate]
					ON [TransitionTemplate].[ID] = [Transition].[TransitionTemplateID]
			WHERE 
				[Transition].[Class] = @TimeEntryClass 
				AND 
				[Transition].[DocumentID] = @TimeEntryID
				AND
				(
					[TransitionTemplate].[FromState] IS NULL AND [TransitionTemplate].[ToState] = 1
					OR
					[TransitionTemplate].[FromState] = 1 AND [TransitionTemplate].[ToState] = 1
					OR
					[TransitionTemplate].[FromState] = 5 AND [TransitionTemplate].[ToState] = 1
					OR
					[TransitionTemplate].[FromState] = 2 AND [TransitionTemplate].[ToState] = 2
					OR
					[TransitionTemplate].[FromState] = 3 AND [TransitionTemplate].[ToState] = 3
				)
		)
	RETURN dbo.fnPjm7MaxDate3(@TransitionTemplateModifiedDate, @ReminderModifiedDate, @UserReminderModifiedDate)
END
GO

GRANT EXEC ON fnPjm7ExchangeGetModifiedDateForTimeEntry TO PUBLIC
GO

