IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5MoneyToString]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5MoneyToString'
		DROP FUNCTION [dbo].[fnPjm5MoneyToString]
	END

GO

PRINT 'Creating function fnPjm5MoneyToString'
GO
/******************************************************************************
**		File: 
**		Name: MoneyToString
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5MoneyToString(
	@Value		TMoney,
	@Currency	TCode = 'RUB',
	@Brackets	int
	)
RETURNS TName
AS
BEGIN
	DECLARE @Result			AS TName
	DECLARE @IntValue		AS BIGINT
	DECLARE @CurValue		AS INTEGER
	DECLARE @Count			AS INTEGER

	SET @IntValue = (ROUND(ABS(@Value) + 0.5, 0) - 1)
	SET @Count = 1

	SET @Result = '  0/100'
	SET @CurValue = (ABS(@Value) - @IntValue) * 100
	/*IF @CurValue = 0 
		SELECT 
			@Result = CASE UPPER(@Currency)
				WHEN 'RUB' THEN ' 00 .'
				ELSE ''
			END*/
			
	IF @CurValue = 0
		SELECT 
			@Result = CASE UPPER(@Currency)
				WHEN 'RUB' THEN '  0/100'
				ELSE '  ' + CAST(@CurValue AS varchar(1)) + '/100'
			END		
			
	IF @CurValue > 0 AND @CurValue < 10
		SELECT 
			@Result = CASE UPPER(@Currency)
				WHEN 'RUB' THEN '   0' + CAST(@CurValue AS varchar(1)) + '/100'
				ELSE '  ' + CAST(@CurValue AS varchar(1)) + '/100'
			END

	IF @CurValue >= 10
		SELECT 
			@Result = CASE UPPER(@Currency)
				WHEN 'RUB' THEN '  ' + CAST(@CurValue AS varchar(2)) + '/100'
				ELSE '  ' + CAST(@CurValue AS varchar(2)) + '/100'
			END
	 

	IF @Brackets = 1
	BEGIN
	SELECT 
		@Result = CASE UPPER(@Currency)
			WHEN 'RUB' THEN @Result + ') ' + dbo.fnPjm5ThreeDigitName(@IntValue, '', '', '')
			WHEN 'USD' THEN @Result + ') ' + dbo.fnPjm5ThreeDigitName(@IntValue, ' ', ' ', ' ')
			WHEN 'EUR' THEN @Result + ') ' + dbo.fnPjm5ThreeDigitName(@IntValue, '', '', '')
			ELSE @Result + ' ' + dbo.fnPjm5ThreeDigitName(@IntValue, @Currency, @Currency, @Currency)
		END
	END
	ELSE
	BEGIN
	SELECT 
		@Result = CASE UPPER(@Currency)
			WHEN 'RUB' THEN @Result + ' ' + dbo.fnPjm5ThreeDigitName(@IntValue, '', '', '')
			WHEN 'USD' THEN @Result + ' ' + dbo.fnPjm5ThreeDigitName(@IntValue, ' ', ' ', ' ')
			WHEN 'EUR' THEN @Result + ' ' + dbo.fnPjm5ThreeDigitName(@IntValue, '', '', '')
			ELSE @Result + ' ' + dbo.fnPjm5ThreeDigitName(@IntValue, @Currency, @Currency, @Currency)
		END
	END
		
	SET @CurValue = @IntValue % 1000
	SET @IntValue = @IntValue / 1000
	IF @IntValue = 0 OR @CurValue <> 0
		SET @Result = ' ' + dbo.fnPjm5ThreeDigitToString(@CurValue, 0) + @Result

	WHILE @IntValue > 0
	BEGIN
		SET @CurValue = @IntValue % 1000
		SET @IntValue = @IntValue / 1000
		
		IF (@CurValue <> 0)
			IF @Count = 1
				SET @Result = ' ' + dbo.fnPjm5ThreeDigitToString(@CurValue, 1) + ' ' + dbo.fnPjm5ThreeDigitName(@CurValue, '', '', '') + @Result
			ELSE IF @Count = 2
				SET @Result = ' ' + dbo.fnPjm5ThreeDigitToString(@CurValue, 0) + ' ' + dbo.fnPjm5ThreeDigitName(@CurValue, '', '', '') + @Result
			ELSE IF @Count = 3
				SET @Result = ' ' + dbo.fnPjm5ThreeDigitToString(@CurValue, 0) + ' ' + dbo.fnPjm5ThreeDigitName(@CurValue, '', '', '') + @Result
			ELSE IF @Count = 4
				SET @Result = ' ' + dbo.fnPjm5ThreeDigitToString(@CurValue, 0) + ' ' + dbo.fnPjm5ThreeDigitName(@CurValue, '', '', '') + @Result
			ELSE	
				SET @Result = ' ' + dbo.fnPjm5ThreeDigitToString(@CurValue, 0) + ' overflow' + @Result
		SET @Count = @Count + 1
	END
	
	IF @Value < 0 
		SET @Result = '' + @Result

	SET @Result = LTRIM(RTRIM(@Result))
	SET @Result = UPPER(LEFT(@Result, 1)) + RIGHT(@Result, LEN(@Result) -1)
	IF @Brackets = 1
	BEGIN
	SET @Result = '(' + @Result
	END
	RETURN @Result
END
GO

GRANT EXEC ON fnPjm5MoneyToString TO PUBLIC
GO
    