IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetCalculationDiscount]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetCalculationDiscount'
		DROP FUNCTION [dbo].[fnPjm6GetCalculationDiscount]
	END

GO

PRINT 'Creating function fnPjm6GetCalculationDiscount'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6GetCalculationDiscount
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: yuriy.soldatkin
**		Date: 19.04.2011
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6GetCalculationDiscount(@ID TIdentifier, @InProjectCurrency TBool)
RETURNS TMoney
AS
BEGIN
	DECLARE @DiscountType TIdentifier,
			@Discount TAmount,
			@Cost TMoney,
			@DiscountView TBool

	SELECT
		@DiscountType = [DiscountType],
		@DiscountView = [DiscountView],
		@Discount = CASE WHEN @InProjectCurrency = 1
							THEN [DiscountPC]
						ELSE [Discount]
					END
	FROM 
		[Calculation] 
	WHERE 
		[ID] = @ID
	
	IF @DiscountType != 1 OR @DiscountView = 0
		RETURN @Discount
	
	SET @Cost = dbo.fnPjm6GetCalculationCost(@ID, @InProjectCurrency)

	IF(@Cost < @Discount)
		RETURN @Cost

	RETURN @Discount
END
GO

GRANT EXEC ON fnPjm6GetCalculationDiscount TO PUBLIC
GO
