﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnReportTimeSellAnalysisByEmployeesCalculateComputedValues]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnReportTimeSellAnalysisByEmployeesCalculateComputedValues'
		DROP FUNCTION [dbo].[fnReportTimeSellAnalysisByEmployeesCalculateComputedValues]
	END
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportTimeSellAnalysisByEmployeesCalculateComputedValues')
	BEGIN
		PRINT 'Dropping Procedure ReportTimeSellAnalysisByEmployeesCalculateComputedValues'
		DROP  Procedure  ReportTimeSellAnalysisByEmployeesCalculateComputedValues
	END
GO

PRINT 'Creating Procedure ReportTimeSellAnalysisByEmployeesCalculateComputedValues'
GO

/******************************************************************************
**		File: ReportTimeSellAnalysisByEmployeesCalculateComputedValues.sql
**		Name: ReportTimeSellAnalysisByEmployeesCalculateComputedValues
**
**              
**		Return values:
**			Рассчитанные значения отклонения, среднего, средней ставки
**			по утилизации, реализации и выручке из входных параметров 
**		Called by:   
**              ReportTimeSellAnalysisByEmployees
**		Parameters:
**		Input							Output
**      ----------						-----------
**		
**		
**		Auth: Sergey Pelevin
**		Date: 28.07.14 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		
*******************************************************************************/
CREATE PROCEDURE ReportTimeSellAnalysisByEmployeesCalculateComputedValues
	@UtilizationPlanned decimal(18,2),
	@UtilizationReal decimal(18,2),
	@RealizationPlanned decimal(18,2),
	@RealizationReal decimal(18,2),
	@RealizationPositiveDeviation decimal(18,2),
	@RevenuePlanned decimal(18,2),
	@RevenueReal decimal(18,2),	
	
	@UtilizationDeviation decimal(18,2) OUTPUT,
	@UtilizationDeviationPercent decimal(18,2) OUTPUT,
	@RealizationDeviation decimal(18,2) OUTPUT,
	@RealizationDeviationPercent decimal(18,2) OUTPUT,	
	@RevenueDeviation decimal(18,2) OUTPUT,
	@RevenueDeviationPercent decimal(18,2) OUTPUT
AS
BEGIN
	SELECT		
		@UtilizationDeviation = @UtilizationReal - @UtilizationPlanned,
		@UtilizationDeviationPercent = ROUND(((@UtilizationReal - @UtilizationPlanned)/@UtilizationPlanned)*100,2),

		@RealizationDeviation = @RealizationReal - @RealizationPlanned,
		@RealizationDeviationPercent = ROUND(((@RealizationReal - @RealizationPlanned)/@RealizationPlanned)*100,2),		

		@RevenueDeviation = @RevenueReal - @RevenuePlanned,
		@RevenueDeviationPercent = ROUND(((@RevenueReal - @RevenuePlanned)/@RevenuePlanned)*100,2)

	RETURN 0
END

GO

GRANT EXEC ON ReportTimeSellAnalysisByEmployeesCalculateComputedValues TO PUBLIC

GO