IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm5AssignmentBrowseSelectorDialog')
	BEGIN
		PRINT 'Dropping Procedure pjm5AssignmentBrowseSelectorDialog'
		DROP  Procedure  pjm5AssignmentBrowseSelectorDialog
	END

GO

PRINT 'Creating Procedure pjm5AssignmentBrowseSelectorDialog'
GO
/******************************************************************************
**		File: 
**		Name: pjm5AssignmentBrowseSelectorDialog
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		09.08.11	SYV				
*******************************************************************************/
CREATE Procedure pjm5AssignmentBrowseSelectorDialog
	@FileAs TName,
	@QualificationID TIdentifier,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE @hasAccess INT

	SELECT
		@hasAccess = dbo.adfHasAccessRight(dbo.adfGetRightId('ResolveIssue'))

	IF @hasAccess = 1
	BEGIN
		SELECT
			[Assignment].[Class],
			[Assignment].[ID],
			[Assignment].[State],
			[Assignment].[FileAs],
			[Qualification].[FileAs] as [Qualification]
		FROM
			[vwAssignment] AS [Assignment] 
			LEFT OUTER JOIN [Qualification]
				ON ([Assignment].[QualificationID] = [Qualification].[ID])
			LEFT OUTER JOIN [Employee]
				ON ([Assignment].[EmployeeID] = [Employee].[ID])
		WHERE
			[Assignment].[ProjectID] = @ProjectID-- AND @hasAccess = 1
		AND
			[Assignment].[State] = 1
		AND
			((@QualificationID IS NULL) OR (@QualificationID IS NOT NULL AND [Assignment].[QualificationID] = @QualificationID))
		AND
			((@FileAs IS NULL) OR (@FileAs IS NOT NULL AND [Assignment].[FileAs] LIKE @FileAs))
	END

	RETURN 0
GO

GRANT EXEC ON pjm5AssignmentBrowseSelectorDialog TO PUBLIC
GO
