﻿IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6trBudgetUpdate')
	BEGIN
		PRINT 'Dropping Trigger pjm6trBudgetUpdate'
		DROP  Trigger pjm6trBudgetUpdate
	END
GO

/******************************************************************************
**		File: trBudgetUpdate
**		Name: pjm6trBudgetUpdate
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: Anton.Paramonov
**		Date: 02/02/2011 12:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm6trBudgetUpdate'
GO
CREATE TRIGGER pjm6trBudgetUpdate ON [Budget] FOR UPDATE
AS
	IF @@rowcount = 0 
		RETURN
	IF EXISTS(
		SELECT *
		FROM
			[inserted]
			INNER JOIN [deleted]
				ON [deleted].[ID] = [inserted].[ID] 
		WHERE
			([deleted].[PlanningActivityForWork] != [inserted].[PlanningActivityForWork] OR
			[deleted].[PlanningEmployeeForWork] != [inserted].[PlanningEmployeeForWork] OR
			[deleted].[PlanningQualificationForWork] != [inserted].[PlanningQualificationForWork] OR
			[deleted].[PlanningRateForWork] != [inserted].[PlanningRateForWork] OR
			[deleted].[PlanningDateForWork] != [inserted].[PlanningDateForWork] OR
			[deleted].[PlanningExpenseTypeForExpense] != [inserted].[PlanningExpenseTypeForExpense] OR
			[deleted].[PlanningPriceForExpense] != [inserted].[PlanningPriceForExpense] OR
			[deleted].[PlanningDateForExpense] != [inserted].[PlanningDateForExpense] OR
			[deleted].[PlanningEmployeeForExpense] != [inserted].[PlanningEmployeeForExpense] OR
			[deleted].[WorkBudgetBottomEqualsPlan] != [inserted].[WorkBudgetBottomEqualsPlan] OR
			[deleted].[WorkBudgetHighEqualsPlan] != [inserted].[WorkBudgetHighEqualsPlan] OR
			[deleted].[ExpenseBudgetBottomEqualsPlan] != [inserted].[ExpenseBudgetBottomEqualsPlan] OR
			[deleted].[ExpenseBudgetHighEqualsPlan] != [inserted].[ExpenseBudgetHighEqualsPlan]	OR	
			[deleted].[WorkBudgetBottom] != [inserted].[WorkBudgetBottom] OR
			[deleted].[WorkBudgetHigh] != [inserted].[WorkBudgetHigh] OR
			[deleted].[ExpenseBudgetBottom] != [inserted].[ExpenseBudgetBottom] OR
			[deleted].[ExpenseBudgetHigh] != [inserted].[ExpenseBudgetHigh] OR
			[deleted].[TimeEntrySendingForApprovalAccount] != [inserted].[TimeEntrySendingForApprovalAccount] OR
			[deleted].[ExpenseSendingForApprovalAccount] != [inserted].[ExpenseSendingForApprovalAccount]
			) AND
			[inserted].[State] IN (2,3)
		)
	BEGIN
			RAISERROR('#TransitionTemplateCouldNotBeFound', 16, -1)
			ROLLBACK TRANSACTION
	END

	IF EXISTS(
		SELECT *
		FROM
			[inserted]
			INNER JOIN [deleted]
				ON [deleted].[ID] = [inserted].[ID] 
		WHERE
			[deleted].[CurrencyCode] != [inserted].[CurrencyCode] AND
			[inserted].[State] IN (4,5)
		)
	BEGIN
			IF(
				EXISTS (SELECT * FROM [BudgetLineWork] INNER JOIN [inserted] ON [BudgetLineWork].[BudgetID] = [inserted].[ID]) OR
				EXISTS (SELECT * FROM [BudgetLineExpense] INNER JOIN [inserted] ON [BudgetLineExpense].[BudgetID] = [inserted].[ID]) OR
				EXISTS (SELECT * FROM [ProjectTemplate] INNER JOIN [inserted] ON [ProjectTemplate].[BudgetTemplateID] = [inserted].[ID])
			)
		BEGIN
			RAISERROR('#CannotChangeBudgetTemplateCurrency', 16, -1)
			ROLLBACK TRANSACTION
		END
	END

	IF EXISTS(
		SELECT *
		FROM
			[inserted]
			INNER JOIN [deleted]
				ON [deleted].[ID] = [inserted].[ID] 
		WHERE
			[deleted].[VATIsIncluded] != [inserted].[VATIsIncluded] AND
			[inserted].[State] IN (4,5)
		)
	BEGIN
			IF(
				EXISTS (SELECT * FROM [BudgetLineWork] INNER JOIN [inserted] ON [BudgetLineWork].[BudgetID] = [inserted].[ID])
			)
		BEGIN
			RAISERROR('#CannotChangeBudgetTemplateParamVATIsIncluded', 16, -1)
			ROLLBACK TRANSACTION
		END
	END
	RETURN
GO