﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7EmployeeNormDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7EmployeeNormDelete'
		DROP PROCEDURE [dbo].[pjm7EmployeeNormDelete]
	END
GO

PRINT 'Creating procedure pjm7EmployeeNormDelete'
GO

/******************************************************************************
**		File: pjm7EmployeeNormDelete.sql
**		Name: pjm7EmployeeNormDelete
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Sergey Pelevin
**		Date: 20.06.14
*******************************************************************************
**		Date:		Author:		Description:
**		--------	--------	-------------------------------------------
**		21.07.14	SAP			Переработка процедуры (из-за создания документа "Норматив сотрудника")
*******************************************************************************/
CREATE PROCEDURE [dbo].[pjm7EmployeeNormDelete]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	BEGIN TRANSACTION

	DELETE
	FROM
		[EmployeeNormEntry]
	WHERE 
		[ID] = @ID	

		IF @@error <> 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON [pjm7EmployeeNormDelete] TO PUBLIC
GO
