IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ExchangeSyncStateGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ExchangeSyncStateGet'
		DROP PROCEDURE [dbo].[pjm7ExchangeSyncStateGet]
	END
GO

PRINT 'Creating procedure pjm7ExchangeSyncStateGet'
GO

/******************************************************************************
**		File: ExchangeSyncStateGet.sql
**		Name: pjm7ExchangeSyncStateGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 26.12.2011 16:30:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm7ExchangeSyncStateGet
	@DocumentID		TIdentifier,
	@DocumentClass	TClass,
	@EmployeeID		TIdentifier = NULL
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentUserID	TIdentifier
		
	IF @EmployeeID IS NULL	
		SET @CurrentUserID = dbo.adfGetCurrentUserID()
	ELSE
		SET @CurrentUserID = (SELECT [UserID] FROM [Employee] WHERE [ID] = @EmployeeID)
	
	IF EXISTS(SELECT *FROM [ExchangeDocumentSync] WHERE [DocumentClass] = @DocumentClass AND
		[DocumentID] = @DocumentID AND [UserID] = @CurrentUserID)
		SELECT 'true' AS 'syncState'
	ELSE
		SELECT 'false' AS 'syncState'
	RETURN 0
GO

GRANT EXECUTE ON pjm7ExchangeSyncStateGet TO PUBLIC
GO