IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseApproveBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseApproveBrowse'
		DROP PROCEDURE [dbo].[pjm5ExpenseApproveBrowse]
	END
GO

PRINT 'Creating procedure pjm5ExpenseApproveBrowse'
GO

/******************************************************************************
**		File: pjm5ExpenseApproveBrowse.sql
**		Name: pjm5ExpenseApproveBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		02.11.12	SAP				  " "
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ExpenseApproveBrowse]
	@DateSelector	INT,
	@PeriodStart	datetime,
	@PeriodEnd		datetime,
	@EmployeeID TIdentifier,
	@ProjectSelector INT,
	@ActiveProjectID TIdentifier
AS
	SET NOCOUNT ON
	SET DATEFIRST 1
	DECLARE 
		@date datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier
		
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)

	IF @DateSelector = 1 -- last seven days
		SELECT
			--@PeriodEnd = DATEADD(day, 1, @date),
			@PeriodEnd = GETDATE(),
			@PeriodStart = DATEADD(day, -6, @date)

	IF @DateSelector = 2 -- current month
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @date, 112) AS datetime),
			@PeriodStart = DATEADD(day, 1-DATEPART(day, @PeriodStart), @PeriodStart),
			@PeriodEnd = GETDATE()
			--@PeriodEnd = DATEADD(month, 1, @PeriodStart)

	IF @DateSelector = 3 -- last month
		SELECT
			@PeriodEnd = DATEADD(day, 1 - DATEPART(day, @date), @date),
			@PeriodStart = DATEADD(month, -1, @PeriodEnd)
			
	IF @DateSelector = 4 -- arbitrary period
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime),
			@PeriodEnd = CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime),
			@PeriodEnd = DATEADD(day, 1, @PeriodEnd)
			
	SELECT
		[Expense].[Class],
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Flag],
		[Expense].[FileAs],
		[Expense].[ProjectID],
		[Expense].[TaskID],
		[Expense].[EmployeeID],
		[Expense].[ExpenseCodeID],
		[Expense].[Date],
		[Expense].[Amount],
		[Expense].[Billable],
		[Expense].[Price],
		[Expense].[FromCurrencyCode],
		[Expense].[ToCurrencyCode],
		[Expense].[CurrencyRate],
		[Expense].[VATRate],
		[Expense].[VAT],
		[Expense].[Comments],
		[Expense].[Created],
		[Expense].[CreatedBy],
		[Expense].[Modified],
		[Expense].[ModifiedBy],
		[Expense].[Timestamp],
		[Expense].[SumExpense],
		[Expense].[SumProjectCurrency],
		[Expense].[TotalSumExpense],
		[Expense].[TotalSumProjectCurrency],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID],
		CASE
			WHEN [Expense].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentClassName] FROM adfGetDocumentIdentity([Expense].[DocumentID], [Expense].[DocumentClass]))
				ELSE (SELECT dbo.adfGetDocumentClassNameByTable('Task'))
		END AS [DocumentClassName],
		CASE
			WHEN [Expense].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([Expense].[DocumentID], [Expense].[DocumentClass]))
				ELSE (SELECT [Task].[FileAs] FROM [Task] WHERE [Task].[ID] = [Expense].[TaskID])
		END AS [DocumentName],
		[CostCenter].[FileAs] AS [CostCenterName]
	FROM
		[pjm5vwExpense] AS [Expense] 
		INNER JOIN [Project]
			ON [Project].[ID] = [Expense].[ProjectID]
		LEFT JOIN [CostCenter]
			ON [CostCenter].[ID] = [Project].[CostCenterID]
	WHERE
		(
			dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR
			dbo.fnPjm5IsProjectEnhancementMember([Project].[ID], @CurrentEmployeeID) = 1
		)
		 AND
		(@EmployeeID IS NULL OR [Expense].[EmployeeID] = @EmployeeID) AND 
		(
		(@ProjectSelector = 0 AND [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID) OR
			(@ProjectSelector = 1) OR
			(
				@ProjectSelector = 2 AND 
				(
					(@ActiveProjectID IS NULL AND [Project].[State] = 2) OR
					(@ActiveProjectID IS NOT NULL AND [Project].[ID] = @ActiveProjectID)
				)
			)
		) AND
		(
			@DateSelector = 0 OR
			[Expense].[Date] BETWEEN @PeriodStart AND @PeriodEnd
		) AND
		(
			[Expense].[State] = 2
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ExpenseApproveBrowse] TO PUBLIC
GO 