IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseSelectorDialog'
		DROP PROCEDURE [dbo].[pjm5ExpenseSelectorDialog]
	END
GO

PRINT 'Creating procedure pjm5ExpenseSelectorDialog'
GO

/******************************************************************************
**		File: pjm5ExpenseSelectorDialog.sql
**		Name: pjm5ExpenseSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ExpenseSelectorDialog]
	@ProjectID		INT,
	@PeriodStart	datetime,
	@PeriodEnd		datetime,
	@Employee		TName,
	@DocumentClass	TClass
AS
	SET NOCOUNT ON
	DECLARE
		@invoiceClass TClass,
		@statementClass TClass
	SET @invoiceClass =dbo.adfGetClassByName('Pjm5.Invoice')
	SET @statementClass =dbo.adfGetClassByName('Pjm5.Statement')

	SELECT
		[Expense].[Class],
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Flag],
		[Expense].[FileAs],
		[Expense].[ProjectID],
		[Expense].[TaskID],
		[Expense].[ExpenseCodeID],
		[Expense].[Date],
		[Expense].[Amount],
		[Expense].[Billable],
		[Expense].[Price],
		[Expense].[FromCurrencyCode],
		[Expense].[ToCurrencyCode],
		[Expense].[CurrencyRate],
		[Expense].[VATRate],
		[Expense].[Comments],
		[Expense].[Created],
		[Expense].[CreatedBy],
		[Expense].[Modified],
		[Expense].[ModifiedBy],
		[Expense].[Timestamp],
		[Expense].[SumExpense],
		[Expense].[SumProjectCurrency],
		[Expense].[TotalSumExpense],
		[Expense].[TotalSumProjectCurrency],
		[Employee].[FileAs] AS [EmployeeName]
	FROM
		[pjm5vwExpense] AS [Expense]
		INNER JOIN [Project]
			ON [Project].[ID] = [Expense].[ProjectID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [Expense].[EmployeeID]
	WHERE
		[Project].[ID] = @ProjectID AND
		CAST(CONVERT(varchar(8), [Expense].[Date], 112) AS DATETIME) BETWEEN @PeriodStart AND @PeriodEnd AND 
		[Expense].[Billable] = 1 AND
		[Expense].[State] IN (3, 6) AND
		(@Employee IS NULL OR [Employee].[FileAs] LIKE @Employee) AND
		NOT EXISTS(
			SELECT * 
			FROM 
				[CalculationLine] 
				INNER JOIN [Calculation]
					ON [Calculation].[ID] = [CalculationLine].[CalculationID]
			WHERE 
				[Calculation].[State] != 4 AND
				[CalculationLine].[DocumentClass] = [Expense].[Class] AND [CalculationLine].[DocumentID] = [Expense].[ID]
		) AND
		(
			(@DocumentClass = @invoiceClass AND 
				NOT EXISTS(
					SELECT * 
					FROM 
						[InvoiceLine] 
						INNER JOIN [Invoice]
							ON [Invoice].[ID] = [InvoiceLine].[InvoiceID]
					WHERE 
						[Invoice].[State] != 3 AND
						[InvoiceLine].[DocumentClass] = [Expense].[Class] AND [InvoiceLine].[DocumentID] = [Expense].[ID]))
			OR
			(@DocumentClass = @statementClass AND 
				NOT EXISTS(
					SELECT * 
					FROM 
						[StatementLine] 
						INNER JOIN [Statement]
							ON [Statement].[ID] = [StatementLine].[StatementID]
					WHERE 
						[Statement].[State] != 4 AND
						[StatementLine].[DocumentClass] = [Expense].[Class] AND [StatementLine].[DocumentID] = [Expense].[ID])
			)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ExpenseSelectorDialog] TO PUBLIC
GO

