IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ChangeExpenseBillability]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ChangeExpenseBillability'
		DROP PROCEDURE [dbo].[pjm5ChangeExpenseBillability]
	END
GO

PRINT 'Creating procedure pjm5ChangeExpenseBillability'
GO

/******************************************************************************
**		File: pjm5ChangeExpenseBillability.sql
**		Name: pjm5ChangeExpenseBillability
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ChangeExpenseBillability
	@ID TIdentifier
AS
	DECLARE
		@EmployeeID TIdentifier, 
		@ProjectID TIdentifier,
		@Billable TBool
		
	SELECT 
		@ProjectID = [ProjectID],
		@EmployeeID = [EmployeeID],
		@Billable = [Billable]
	FROM [Expense] 
	WHERE [ID] = @ID
	
	IF dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, @EmployeeID) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	BEGIN TRANSACTION
	UPDATE
		[Expense]
	SET
		[Billable] = CASE @Billable WHEN 0 THEN 1 ELSE 0 END
	WHERE
		[ID] = @ID

	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5ChangeExpenseBillability TO PUBLIC
GO
 