IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureUpdate'
		DROP PROCEDURE [dbo].[pjm5FactureUpdate]
	END
GO

PRINT 'Creating procedure pjm5FactureUpdate'
GO

/******************************************************************************
**		File: pjm5FactureUpdate.sql
**		Name: pjm5FactureUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		25.03.13	SOV				 OpenXml  Xml.
**		25.02.14	SAP				       
*******************************************************************************/
CREATE PROCEDURE pjm5FactureUpdate
	@Xml XML
AS
	
	SET NOCOUNT ON
	DECLARE
		@ID TIdentifier,
		@FileAs TName,
		@Date TDate,
		@Number TCode,

		@ProjectID TIdentifier,
		@CurrencyCode TCode,
		@CurrencyRate TAmount,
		@FactureCurrencyRate TAmount,
		@Scale TCount,

		@SupplierCompanyID TIdentifier,
		@SupplierAddress TNotes,
		@SupplierINN TName,
		@SupplierKPP TCode,
		@CustomerCompanyID TIdentifier,
		@CustomerAddress TNotes,
		@CustomerINN TName,
		@CustomerKPP TCode,
		@Sender TNotes,
		@Recipient TNotes,
		@DocumentNumber TName,
		@DocumentDate TDate,
		@Chief TName,
		@Accountant TName,
		@Comments TNotes,
		@Advance TBool,
		@ExchangeBanned TBool,
		
		@value TVariant

	SELECT 
		@ID = [XMLTable].value('ID[1]', 'int'),
		@FileAs = ISNULL([XMLTable].value('FileAs[1]', 'varchar(512)'), '  '),
		@Date = CONVERT(datetime, [XMLTable].value('Date[1]', 'varchar(19)')),
		@Number = ISNULL([XMLTable].value('Number[1]', 'varchar(32)'), ''),

		@ProjectID = [XMLTable].value('ProjectID[1]', 'int'),
		@CurrencyCode = [XMLTable].value('CurrencyCode[1]', 'varchar(3)'),
		@CurrencyRate = [XMLTable].value('CurrencyRate[1]', 'decimal(18,4)'),
		@Scale = ISNULL([XMLTable].value('Scale[1]', 'int'), 2),

		@SupplierCompanyID = [XMLTable].value('SupplierCompanyID[1]', 'int'),
		@SupplierAddress = [XMLTable].value('SupplierAddress[1]', 'varchar(512)'),
		@SupplierINN = [XMLTable].value('SupplierINN[1]', 'varchar(512)'),
		@SupplierKPP = [XMLTable].value('SupplierKPP[1]', 'varchar(512)'),
		@CustomerCompanyID = [XMLTable].value('CustomerCompanyID[1]', 'int'),
		@CustomerAddress = [XMLTable].value('CustomerAddress[1]', 'varchar(512)'),
		@CustomerINN = [XMLTable].value('CustomerINN[1]', 'varchar(512)'),
		@CustomerKPP = [XMLTable].value('CustomerKPP[1]', 'varchar(512)'),
		@Sender = [XMLTable].value('Sender[1]', 'varchar(512)'),
		@Recipient = [XMLTable].value('Recipient[1]', 'varchar(512)'),
		@DocumentNumber = [XMLTable].value('DocumentNumber[1]', 'varchar(512)'),
		@DocumentDate = [XMLTable].value('DocumentDate[1]', 'varchar(19)'),
		@Chief = [XMLTable].value('Chief[1]', 'varchar(512)'),
		@Accountant = [XMLTable].value('Accountant[1]', 'varchar(512)'),
		@Comments = [XMLTable].value('Comments[1]', 'nvarchar(max)'),
		@Advance = CASE [XMLTable].value('Advance[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END,
		@FactureCurrencyRate = [Facture].[CurrencyRate],
		@ExchangeBanned = CASE [XMLTable].value('ExchangeBanned[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END
	FROM
		@Xml.nodes('/pjm5FactureGet/Facture') AS List(XmlTable)
		INNER JOIN [Facture]
			ON [Facture].[ID] = [XMLTable].value('ID[1]', 'int')

	--     -
	DECLARE @ApprovedRatesUpdated TBool
	SELECT
		@ApprovedRatesUpdated = CASE WHEN
			[State] = 2 AND
			(
				ISNULL([CurrencyRate], -100) = ISNULL(@CurrencyRate, -100) OR
				ISNULL([CurrencyCode], -100) = ISNULL(@CurrencyCode, -100)
			)
		THEN 1 ELSE 0 END
	FROM
		[Facture]
	WHERE
		[ID] = @ID

	IF @ApprovedRatesUpdated = 1
	BEGIN
		RAISERROR('#TransitionTemplateCouldNotBeFound', 16, -1)
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DECLARE @payments TABLE([PaymentID] int)
	INSERT INTO @payments 
	SELECT 
		[XmlTable].value('PaymentID[1]', 'int') 
	FROM 
		@Xml.nodes('/pjm5FactureGet/Payment') AS List(XmlTable)

	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllInvoices')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END		

	DECLARE @PaymentClass TClass, @FactureClass TClass
	SET @FactureClass = dbo.adfGetClassByName('Pjm5.Facture')
	SET @PaymentClass = dbo.adfGetClassByName('Adf.Payment')
	
	DECLARE @OnlyCustomFields TBool
	SELECT
		@OnlyCustomFields = CASE WHEN
			[Facture].[ExchangeBanned] != @ExchangeBanned AND
			ISNULL([Facture].[FileAs], -100) = ISNULL(@FileAs, -100) AND
			ISNULL([Facture].[Date], -100) = ISNULL(@Date, -100) AND
			ISNULL([Facture].[Number], -100) = ISNULL(@Number, -100) AND
			ISNULL([Facture].[ProjectID], -100) = ISNULL(@ProjectID, -100) AND
			ISNULL([Facture].[CurrencyCode], -100) = ISNULL(@CurrencyCode, -100) AND
			ISNULL([Facture].[CurrencyRate], -100) = ISNULL(@CurrencyRate, -100) AND
			ISNULL([Facture].[Scale], -100) = ISNULL(@Scale, -100) AND
			ISNULL([Facture].[SupplierCompanyID], -100) = ISNULL(@SupplierCompanyID, -100) AND
			ISNULL([Facture].[SupplierAddress], -100) = ISNULL(@SupplierAddress, -100) AND
			ISNULL([Facture].[SupplierINN], -100) = ISNULL(@SupplierINN, -100) AND
			ISNULL([Facture].[SupplierKPP], -100) = ISNULL(@SupplierKPP, -100) AND
			ISNULL([Facture].[CustomerCompanyID], -100) = ISNULL(@CustomerCompanyID, -100) AND
			ISNULL([Facture].[CustomerAddress], -100) = ISNULL(@CustomerAddress, -100) AND
			ISNULL([Facture].[CustomerINN], -100) = ISNULL(@CustomerINN, -100) AND
			ISNULL([Facture].[CustomerKPP], -100) = ISNULL(@CustomerKPP, -100) AND
			ISNULL([Facture].[Sender], -100) = ISNULL(@Sender, -100) AND
			ISNULL([Facture].[Recipient], -100) = ISNULL(@Recipient, -100) AND
			ISNULL([Facture].[DocumentNumber], -100) = ISNULL(@DocumentNumber, -100) AND
			ISNULL([Facture].[DocumentDate], -100) = ISNULL(@DocumentDate, -100) AND
			ISNULL([Facture].[Chief], -100) = ISNULL(@Chief, -100) AND
			ISNULL([Facture].[Accountant], -100) = ISNULL(@Accountant, -100) AND
			ISNULL([Facture].[Comments], -100) = ISNULL(@Comments, -100) AND
			ISNULL([Facture].[Advance], -100) = ISNULL(@Advance, -100)
		THEN 1 ELSE 0 END
	FROM
		[Facture]
	WHERE
		[Facture].[ID] = @ID
	
	
	IF @OnlyCustomFields = 1
	BEGIN
		UPDATE
			[Facture]
		SET
			[Facture].[ExchangeBanned] = @ExchangeBanned
		WHERE
			[Facture].[ID] = @ID
		
		EXEC pjm5FactureGet @ID
		RETURN 0
	END
	
	BEGIN TRANSACTION
	UPDATE 
		[Facture]
	SET
		[Facture].[FileAs] = @FileAs,
		[Facture].[Date] = @Date,
		[Facture].[Number] = @Number,
		[Facture].[ProjectID] = @ProjectID,
		[Facture].[CurrencyCode] = @CurrencyCode,
		[Facture].[CurrencyRate] = @CurrencyRate,
		[Facture].[Scale] = @Scale,
		[Facture].[SupplierCompanyID] = @SupplierCompanyID,
		[Facture].[SupplierAddress] = @SupplierAddress,
		[Facture].[SupplierINN] = @SupplierINN,
		[Facture].[SupplierKPP] = @SupplierKPP,
		[Facture].[CustomerCompanyID] = @CustomerCompanyID,
		[Facture].[CustomerAddress] = @CustomerAddress,
		[Facture].[CustomerINN] = @CustomerINN,
		[Facture].[CustomerKPP] = @CustomerKPP,
		[Facture].[Sender] = @Sender,
		[Facture].[Recipient] = @Recipient,
		[Facture].[DocumentNumber] = @DocumentNumber,
		[Facture].[DocumentDate] = @DocumentDate,
		[Facture].[Chief] = @Chief,
		[Facture].[Accountant] = @Accountant,
		[Facture].[Comments] = @Comments,
		[Facture].[Advance] = @Advance,
		[Facture].[Modified] = DEFAULT,
		[Facture].[ModifiedBy] = DEFAULT
	WHERE
		[Facture].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @OnlyCustomFields = 0
	BEGIN
		UPDATE
			[Facture]
		SET
			[Facture].[ExchangeBanned] = @ExchangeBanned
		WHERE
			[Facture].[ID] = @ID
	END
	
	DELETE FROM [Attachment]
	FROM
		[Attachment]
		INNER JOIN [FacturePayment]
			ON ([Attachment].[DocumentClass] = @PaymentClass AND [Attachment].[DocumentID] = [FacturePayment].[PaymentID] AND
				[Attachment].[LinkDocumentClass] = @FactureClass AND [Attachment].[LinkDocumentID] = [FacturePayment].[FactureID])
	WHERE 
		[LinkDocumentID] = @ID AND 
		[AttachmentTypeID] = 3
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [FacturePayment] WHERE [FactureID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END


	INSERT INTO [FacturePayment]([FactureID], [PaymentID]) SELECT @ID, [PaymentID] FROM @payments
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	SELECT
		@PaymentClass, [PaymentID], '-',
		@FactureClass, [FactureID], 3	
	FROM
		[FacturePayment]
	WHERE
		[FactureID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	IF ISNULL(@FactureCurrencyRate, 0) != ISNULL(@CurrencyRate , 0)
	BEGIN
		DECLARE @lines TABLE (
		   ID int,
		   DocumentID int null,
		   VATIsIncluded bit null,
		   VATRate decimal(18,4) null,
		   Amount decimal(18,4) null,
		   OriginalPricePC money null,
		   PricePC money null,
		   ExcisePC money null,
		   TotalPC money null,
		   VATPC money null,
		   TotalWithVATPC money null,
		   OriginalPrice money null,
		   Price money null,
		   Total money null,
		   Excise money null,
		   VAT money null,
		   TotalWithVAT money null,
		   BasePrice int,
		   modified bit)
		INSERT INTO @lines (ID,DocumentID,VATIsIncluded,VATRate,Amount,OriginalPricePC,PricePC,ExcisePC,TotalPC,VATPC,TotalWithVATPC,OriginalPrice,Price,Total,Excise,VAT,TotalWithVAT,BasePrice,modified)
		SELECT ID,DocumentID,VATIsIncluded,VATRate,Amount,OriginalPricePC,PricePC,ExcisePC,TotalPC,VATPC,TotalWithVATPC,OriginalPrice,Price,Total,Excise,VAT,TotalWithVAT,BasePrice,0 
		FROM [FactureLine] WHERE FactureID = @ID
		
		IF @CurrencyRate = 1
		BEGIN
			UPDATE @lines
			SET 
				OriginalPricePC = OriginalPrice,
				PricePC = Price,
				TotalPC = Total,
				ExcisePC = Excise,
				VATPC = VAT,
				TotalWithVATPC = TotalWithVAT,
				modified = 1
			WHERE
				BasePrice = 2

			UPDATE @lines
			SET 
				OriginalPrice = OriginalPricePC,
				Price = PricePC,
				Total = TotalPC,
				Excise = ExcisePC,
				VAT = VATPC,
				TotalWithVAT = TotalWithVATPC,
				modified = 1
			WHERE
				BasePrice = 1
		END
		ELSE
		BEGIN
			UPDATE @lines
			SET 
				OriginalPricePC = ROUND(OriginalPrice / @CurrencyRate, @Scale),
				PricePC = ROUND(CASE VATIsIncluded
							WHEN 0 THEN  OriginalPrice / @CurrencyRate
							ELSE ROUND((Amount * OriginalPrice / (1 + VATRate)) / @CurrencyRate, @Scale) / Amount
						END, @Scale),
				TotalPC = ROUND(CASE VATIsIncluded
							WHEN 0 THEN  Amount * OriginalPrice / @CurrencyRate
							ELSE (Amount * OriginalPrice / (1 + VATRate)) / @CurrencyRate
						END, @Scale),
				ExcisePC = ROUND(Excise / @CurrencyRate, @Scale),
				VATPC = ROUND(CASE VATIsIncluded
							WHEN 1 THEN  Amount * OriginalPrice / @CurrencyRate
							ELSE (Amount * OriginalPrice * (1 + VATRate)) / @CurrencyRate
						END, @Scale) -
						ROUND(CASE VATIsIncluded
							WHEN 0 THEN  Amount * OriginalPrice / @CurrencyRate
							ELSE (Amount * OriginalPrice / (1 + VATRate)) / @CurrencyRate
						END, @Scale),
				TotalWithVATPC = ROUND(CASE VATIsIncluded
							WHEN 1 THEN  Amount * OriginalPrice / @CurrencyRate
							ELSE (Amount * OriginalPrice * (1 + VATRate)) / @CurrencyRate
						END, @Scale),
				modified = 1
			WHERE
				BasePrice = 2
				
			UPDATE @lines
			SET 
				OriginalPrice = ROUND(OriginalPricePC * @CurrencyRate, @Scale),
				Price = ROUND(CASE VATIsIncluded
							WHEN 0 THEN  OriginalPricePC * @CurrencyRate
							ELSE ROUND((Amount * OriginalPricePC / (1 + VATRate)) * @CurrencyRate, @Scale) / Amount
						END, @Scale),
				Total = ROUND(CASE VATIsIncluded
							WHEN 0 THEN  Amount * OriginalPricePC * @CurrencyRate
							ELSE ROUND((Amount * OriginalPricePC / (1 + VATRate)) * @CurrencyRate, @Scale)
						END, @Scale),
				Excise = ROUND(ExcisePC * @CurrencyRate, @Scale),
				VAT = ROUND(CASE VATIsIncluded
							WHEN 1 THEN  Amount * OriginalPricePC * @CurrencyRate
							ELSE ROUND((Amount * OriginalPricePC * (1 + VATRate)) * @CurrencyRate, @Scale)
						END, @Scale) -
						ROUND(CASE VATIsIncluded
							WHEN 0 THEN  Amount * OriginalPricePC * @CurrencyRate
							ELSE ROUND((Amount * OriginalPricePC / (1 + VATRate)) * @CurrencyRate, @Scale)
						END, @Scale),
				TotalWithVAT = ROUND(CASE VATIsIncluded
							WHEN 1 THEN  Amount * OriginalPricePC * @CurrencyRate
							ELSE ROUND((Amount * OriginalPricePC * (1 + VATRate)) * @CurrencyRate, @Scale)
						END, @Scale),
				modified = 1
			WHERE
				BasePrice = 1
		END


		DECLARE	
			@tmpID int,
			@tmpTotalWithVATPC money,			
			@tmpAmount TAmount,
			@tmpVATRate TPercent

		DECLARE cur CURSOR FAST_FORWARD FOR
		SELECT
			[L].[ID],
			[L].[TotalWithVATPC],			
			[L].[Amount],
			[L].[VATRate]
		FROM @lines AS [L]
		

		OPEN [cur]
		FETCH NEXT FROM [cur] INTO @tmpID, @tmpTotalWithVATPC, @tmpAmount, @tmpVATRate
		WHILE @@fetch_status = 0
		BEGIN

			DECLARE	@TVWPC money,
					@TVW money,
					@Ttl money,
					@V money,
					@PVW money,
					@P money

			--IF @CurrencyCode != @NationalCurrencyCode
			--	SET @CurrencyRate = 1 / @CurrencyRate

			SET @TVWPC = @tmpTotalWithVATPC
			SET @TVW = ROUND(@TVWPC * @CurrencyRate, 2)
			SET @V = ROUND(@TVW * @tmpVATRate / (1 + @tmpVATRate), 2)
			SET @Ttl = @TVW - @V
			SET @PVW = ROUND(@TVW / @tmpAmount, 2)
			SET @P = ROUND(@Ttl / @tmpAmount, 2)

			UPDATE @lines
			SET	[Price] = @P,
				[Total] = @Ttl,
				[VAT] = @V,
				[TotalWithVAT] = @TVW
			WHERE [ID] = @tmpID




			FETCH NEXT FROM [cur] INTO @tmpID, @tmpTotalWithVATPC, @tmpAmount, @tmpVATRate
		END
		CLOSE [cur]
		DEALLOCATE [cur]


		UPDATE
			[FactureLine]
		SET
			OriginalPricePC = l.OriginalPricePC,
			PricePC = l.PricePC,
			TotalPC = l.TotalPC,
			ExcisePC = l.ExcisePC,
			VATPC = l.VATPC,
			TotalWithVATPC = l.TotalWithVATPC,
			OriginalPrice = l.OriginalPrice,
			Price = l.Price,
			Total = l.Total,
			Excise = l.Excise,
			VAT = l.VAT,
			TotalWithVAT = l.TotalWithVAT
		FROM
			[FactureLine]
			INNER JOIN @lines l
				ON l.[ID] = [FactureLine].[ID]
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END


	COMMIT TRANSACTION
	EXEC pjm5FactureGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5FactureUpdate TO PUBLIC
GO
 