 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceFind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5InvoiceFind'
		DROP PROCEDURE [dbo].[pjm5InvoiceFind]
	END
GO

PRINT 'Creating procedure pjm5InvoiceFind'
GO

/******************************************************************************
**		File: pjm5InvoiceFind.sql
**		Name: pjm5InvoiceFind
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		08.08.12	SOV				     [Invoice].[FileAs]
**		05.04.13	SOV				   . -
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceFind]
	@Text nvarchar(256), -- NULL -  , 
	@TextField int, -- 0 - FileAs, -- 1 - FileAs, Comments
	@State int, -- NULL - 
	@Flag tinyint, -- NULL -  , 0-7 
	@UserOption int,
	@TimeField int, -- 0 - , 1 - Created, 2 - Modified
	@StartTime datetime,
	@EndTime datetime,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @UserID TIdentifier, @EmployeeID TIdentifier, @ViewAllProjects TBool
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))

	SELECT
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],
		[Invoice].[Comments],
		[Invoice].[ProjectID],
		[Invoice].[Flag],
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy]
	FROM
		[Invoice] INNER JOIN dbo.fnPjm5GetAvailableProjects() as [P]
			ON ([Invoice].[ProjectID] = [P].[ID])
	WHERE
		(
			@ViewAllProjects = 1 OR 
			dbo.fnPjm5IsProjectManager([Invoice].[ProjectID], @EmployeeID) = 1 OR
			dbo.fnPjm7IsFinanceManager([Invoice].[ProjectID], @EmployeeID) = 1
		) AND
		(
			@ProjectID IS NULL OR (@ProjectID IS NOT NULL AND [Invoice].[ProjectID] = @ProjectID)
		)
		AND
		(
			@Text IS NULL
			OR
			(@TextField = 0 AND [Invoice].[FileAs] LIKE '%' + @Text + '%')
			OR
			(@TextField = 1 AND ([Invoice].[FileAs] LIKE '%' + @Text + '%' OR [Invoice].[Comments] LIKE '%' + @Text + '%'))
			OR
			(@TextField = 2 AND ([Invoice].[Number] LIKE '%' + @Text + '%' OR [Invoice].[FileAs] LIKE '%' + @Text + '%' OR [Invoice].[Comments] LIKE '%' + @Text + '%'))			
		)
		AND
		(
			@State IS NULL
			OR
			(@State IS NOT NULL AND [Invoice].[State] = @State)
		)		
		AND
		(
			@Flag IS NULL
			OR
			(@Flag IS NOT NULL AND [Invoice].[Flag] = @Flag)
		)
		AND
		(
			@UserOption IS NULL
			OR
			(@UserOption = 0 AND dbo.fnPjm5IsProjectManager([Invoice].[ProjectID], @EmployeeID) = 1)
			OR
			(@UserOption = 1 AND ([Invoice].[CreatedBy] = @UserID OR [Invoice].[ModifiedBy] = @UserID))
			OR
			(@UserOption = 2 AND [Invoice].[CreatedBy] = @UserID)
			OR
			(@UserOption = 3 AND [Invoice].[ModifiedBy] = @UserID)
		)
		AND
		(
			@TimeField = 0
			OR
			(@TimeField = 1 AND [Invoice].[Created] BETWEEN @StartTime AND @EndTime)
			OR
			(@TimeField = 2 AND [Invoice].[Modified] BETWEEN @StartTime AND @EndTime)
		)
	ORDER BY
		[Invoice].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5InvoiceFind] TO PUBLIC
GO 