IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderSizeGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderSizeGet'
		DROP PROCEDURE [dbo].[pjm5FolderSizeGet]
	END
GO

PRINT 'Creating procedure pjm5FolderSizeGet'
GO

/******************************************************************************
**		File: pjm5FolderSizeGet.sql
**		Name: pjm5FolderSizeGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		28.07.11	SPV				   0.
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderSizeGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	;
	WITH FolderTable([FolderID], [ID], [Level]) AS (
		SELECT 
			[FolderID], [ID], 0 AS [Level] 
		FROM
			[Folder] 
		WHERE [ID] = @ID
		UNION ALL
		SELECT 
			f.[FolderID], f.[ID], [Level] + 1
		FROM
			[Folder] f
			INNER JOIN [FolderTable]
				ON f.[FolderID] = [FolderTable].[ID]
	)
	SELECT 
		@ID AS [ID] ,
		CAST(ISNULL(SUM(CASE WHEN [FolderTable].[Level] = 0 AND [DocumentItem].[LatestVersion] >= [DocumentVersion].[Version] THEN [DocumentVersion].[DataLength] ELSE 0.0 END), 0.0) AS BIGINT) AS [Size],
		CAST(ISNULL(SUM(CASE WHEN [DocumentItem].[LatestVersion] >= [DocumentVersion].[Version] THEN [DocumentVersion].[DataLength] ELSE 0.0 END), 0.0) AS BIGINT) AS [TotalSize]
	FROM 
		[FolderTable]
		LEFT OUTER JOIN [DocumentItem]
			ON [DocumentItem].[FolderID] = [FolderTable].[ID]
		LEFT OUTER JOIN [DocumentVersion]
			ON [DocumentVersion].[DocumentItemID] = [DocumentItem].[ID]
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FolderSizeGet] TO PUBLIC
GO

 