IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderUpdate'
		DROP PROCEDURE [dbo].[pjm5FolderUpdate]
	END
GO

PRINT 'Creating procedure pjm5FolderUpdate'
GO

/******************************************************************************
**		File: pjm5FolderUpdate.sql
**		Name: pjm5FolderUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderUpdate]
	@ID TIdentifier,
	@FileAs TName
AS
	SET NOCOUNT ON
	DECLARE @ParentID TIdentifier, @PrevFileAs TName
	SELECT 
		@ParentID = [FolderID],
		@PrevFileAs = [FileAs]
	FROM 
		[Folder] 
	WHERE 
		[ID] = @ID
	
	IF @PrevFileAs != @FileAs
	BEGIN
		
		IF EXISTS (SELECT * FROM [Folder] WHERE ISNULL([FolderID], -1) = ISNULL(@ParentID, -1) AND [FileAs] = @FileAs AND [ID] != @ID)
		BEGIN
			RAISERROR('#folderalreadyexists', 18, -1)
			RETURN 1
		END

		UPDATE 
			[Folder]
		SET 
			[FileAs] = @FileAs,
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		WHERE
			[ID] = @ID
		
		EXEC pjm5FolderRenameNotification @ID, @PrevFileAs
	END

	EXEC pjm5FolderGet @ID
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FolderUpdate] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderUpdateProperties]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderUpdateProperties'
		DROP PROCEDURE [dbo].[pjm5FolderUpdateProperties]
	END
GO

PRINT 'Creating procedure pjm5FolderUpdateProperties'
GO

/******************************************************************************
**		File: pjm5FolderUpdateProperties.sql
**		Name: pjm5FolderUpdateProperties
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderUpdateProperties]
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@VersionControl TBool,
	@PublicationControl TBool,
	@Parameters xml
AS
	SET NOCOUNT ON
	DECLARE @ParentID TIdentifier
	SELECT @ParentID = [FolderID] FROM [Folder] WHERE [ID] = @ID
	IF EXISTS (SELECT * FROM [Folder] WHERE ISNULL([FolderID], -1) = ISNULL(@ParentID, -1) AND [FileAs] = @FileAs AND [ID] != @ID)
	BEGIN
		RAISERROR('#folderalreadyexists', 18, -1)
		RETURN 1
	END

	UPDATE 
		[Folder]
	SET 
		[Code] = CASE WHEN [ID] = 1 THEN [Code] ELSE @Code END,
		[FileAs] = CASE WHEN [ID] = 1 THEN [FileAs] ELSE @FileAs END,
		[VersionControl] = @VersionControl,
		[PublicationControl] = @PublicationControl,
		[Parameters] = @Parameters,
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	WHERE
		[ID] = @ID

	EXEC pjm5FolderGet @ID
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FolderUpdateProperties] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderFileNameTemplateUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderFileNameTemplateUpdate'
		DROP PROCEDURE [dbo].[pjm5FolderFileNameTemplateUpdate]
	END
GO

PRINT 'Creating procedure pjm5FolderFileNameTemplateUpdate'
GO

/******************************************************************************
**		File: pjm5FolderFileNameTemplateUpdate.sql
**		Name: pjm5FolderFileNameTemplateUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderFileNameTemplateUpdate]
	@FolderID TIdentifier,
	@Template TName,
	@ApplyToSubfolders TBool
AS
	SET NOCOUNT ON
	BEGIN TRANSACTION
	IF @ApplyToSubfolders = 0
	BEGIN
		UPDATE
			[Folder]
		SET
			[FileTemplate] = @Template
		WHERE
			[ID] = @FolderID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
		WITH [Folders] ([FolderID], [ID]) AS
		(
			SELECT [FolderID], [ID] FROM [Folder] WHERE [ID] = @FolderID
			UNION ALL
			SELECT [Folder].[FolderID], [Folder].[ID]
			FROM
				[Folder]
				INNER JOIN [Folders]
					ON [Folders].[ID] = [Folder].[FolderID]
		)
		UPDATE
			[Folder]
		SET
			[FileTemplate] = @Template
		FROM
			[Folder]
			INNER JOIN [Folders]
				ON [Folders].[ID] = [Folder].[ID]

		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FolderFileNameTemplateUpdate] TO PUBLIC
GO

 
 