 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5InvoiceCreate'
		DROP PROCEDURE [dbo].[pjm5InvoiceCreate]
	END
GO

PRINT 'Creating procedure pjm5InvoiceCreate'
GO

/******************************************************************************
**		File: pjm5InvoiceCreate.sql
**		Name: pjm5InvoiceCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		26.03.13	SOV				 OpenXml  Xml
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceCreate]
	@Xml XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@ProjectID TIdentifier,
			@ApplyVAT bit,
			@VATRate TPercent,
			@ProjectType TIdentifier,
			@InvoiceExpirationPeriod TCount,
			@InvoiceExpirationPeriodType TIdentifier,
			@ProjectCurrencyCode TCode3,
			@CurrencyCode TCode3,
			@value TVariant,
			@CurrencyRate TMoney,
			@BaseCurrencyRate TMoney,
			@ReminderState TState,
			@ReminderInterval TTimeSpan,
			@ReminderPublishState TState,
			@ReminderPublishTime TDateTime,
			@ReminderPublishInterval TTimeSpan,
			@Date TDate,
			@DueDate TDate,
			@rv int,
			@InvoiceClass TClass,
			@UserID TIdentifier,
			@Scale TCount
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('98b8f49e-202e-4b46-8074-421734078da6')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	--   Number   FileAs
	SELECT
		@ProjectID = [XmlTable].value('ProjectID[1]', 'int'),
		@CurrencyCode = [XmlTable].value('CurrencyCode[1]', 'char(3)'),
		@CurrencyRate = [XmlTable].value('CurrencyRate[1]', 'decimal(18, 4)'),
		@BaseCurrencyRate = [XmlTable].value('BaseCurrencyRate[1]', 'decimal(18, 4)'),
		@ApplyVAT = [Project].[ApplyVAT],
		@VATRate = 0,
		@ProjectType = [Project].[ProjectTypeID],
		@ProjectCurrencyCode = [Project].[CurrencyCode],
		@InvoiceExpirationPeriod = [Project].[InvoiceExpirationPeriod],
		@InvoiceExpirationPeriodType = [Project].[InvoiceExpirationPeriodType],
		@ReminderPublishState = CASE [XmlTable].value('ReminderPublishState[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END,
		@ReminderPublishTime = CONVERT(datetime, [XmlTable].value('ReminderPublishTime[1]', 'varchar(19)')),
		@Date = CONVERT(datetime, [XmlTable].value('Date[1]', 'nvarchar(19)')),
		@DueDate = (CASE WHEN @InvoiceExpirationPeriodType = 1 
			THEN dbo.fnPjm5AddWorkingDays(@Date, @InvoiceExpirationPeriod)
			ELSE DATEADD(day, @InvoiceExpirationPeriod, @Date)
		END),
		@Scale = [Project].[Scale]
	FROM
		@Xml.nodes('/pjm5InvoiceGet/Invoice') AS List(XmlTable)
		INNER JOIN [Project]
			ON [Project].[ID] = [XmlTable].value('ProjectID[1]', 'int')
			
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllInvoices')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @ProjectType NOT IN (1, 2)
	BEGIN
		RAISERROR('#wrongprojecttype', 18, -1)
		RETURN 1
	END
	
	DECLARE @Class TClass
	SET @Class = dbo.adfGetClassByName('Pjm5.Invoice')
	
	DECLARE @BaseCurrencyCode TCode3
	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))

	IF @BaseCurrencyCode = @ProjectCurrencyCode
		SET @BaseCurrencyRate = 1.0
	IF @ProjectCurrencyCode = @CurrencyCode
		SET @CurrencyRate = 1.0

	DECLARE
		@RecurrenceID TIdentifier,
		@RStartDate TDatetime, 
		@REndDate TDatetime, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount
	SELECT
		@RStartDate = CAST([XmlTable].value('StartDate[1]', 'varchar(19)') as datetime),
		@REndDate = CAST([XmlTable].value('EndDate[1]', 'varchar(19)') as datetime),
		@RRecurrenceType = [XmlTable].value('RecurrenceType[1]', 'int'),
		@ROccurrences = [XmlTable].value('Occurrences[1]', 'int'),
		@RInterval = [XmlTable].value('Interval[1]', 'int'),
		@RDayOfWeekMask = [XmlTable].value('DayOfWeekMask[1]', 'int'),
		@RInstance = [XmlTable].value('Instance[1]', 'int'),
		@RMonthOfYear = [XmlTable].value('MonthOfYear[1]', 'int'),
		@RDayOfMonth = [XmlTable].value('DayOfMonth[1]', 'int')
	FROM
		@Xml.nodes('/pjm5InvoiceGet/RecurrencePattern') AS List(XmlTable)

	BEGIN TRANSACTION
	IF @RRecurrenceType IS NOT NULL
	BEGIN
		INSERT INTO [RecurrencePattern]
			([StartDate], [EndDate], [RecurrenceType], [Occurrences],
			[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
		VALUES
			(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
			@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SET @RecurrenceID = SCOPE_IDENTITY()
	END

	INSERT INTO [Invoice]
		([Flag], [State], [Date], [Number], [FileAs],
		 [SupplierBankAccountID], [ProjectID],
		 [CurrencyRate], [BaseCurrencyRate], [CurrencyCode], 
		 [Comments], [PaymentCurrencyPoint], 
		 [Advance], [DueDate], [InvoiceExpirationPeriodType],
		 [TotalPC], [TotalWithVATPC], [TotalBC], [TotalWithVATBC],
		 [SupplierCompanyID], [CustomerCompanyID],
		 [Scale])
	SELECT
		0,
		@State,
		CONVERT(datetime, [XmlTable].value('Date[1]', 'nvarchar(19)')),
		ISNULL([XmlTable].value('Number[1]', 'varchar(32)'), ''),
		[XmlTable].value('FileAs[1]', 'nvarchar(512)'),
		[XmlTable].value('SupplierBankAccountID[1]', 'int'),
		[XmlTable].value('ProjectID[1]', 'int'),
		@CurrencyRate,
		@BaseCurrencyRate,
		[XmlTable].value('CurrencyCode[1]', 'char(3)'),
		[XmlTable].value('Comments[1]', 'nvarchar(max)'),
		[XmlTable].value('PaymentCurrencyPoint[1]', 'int'),
		(CASE [XmlTable].value('Advance[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END) AS [Advance],
		(CASE WHEN @InvoiceExpirationPeriodType = 1 
			THEN dbo.fnPjm5AddWorkingDays(CONVERT(datetime, [XmlTable].value('Date[1]', 'nvarchar(19)')), @InvoiceExpirationPeriod)
			ELSE DATEADD(day, @InvoiceExpirationPeriod - 1, CONVERT(datetime, [XmlTable].value('Date[1]', 'nvarchar(19)')))
		END),
		@InvoiceExpirationPeriodType,
		0, 0, 0, 0,
		[XmlTable].value('SupplierCompanyID[1]', 'int'), 
		[XmlTable].value('CustomerCompanyID[1]', 'int'),
		@Scale
	FROM
		@Xml.nodes('/pjm5InvoiceGet/Invoice') AS List(XmlTable)
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	IF @RecurrenceID IS NOT NULL
	BEGIN
		UPDATE
			[Document]
		SET
			[RecurrencePatternID] = @RecurrenceID
		WHERE
			[Class] = @Class AND [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	SELECT
		@UserID = dbo.adfGetCurrentUserID(),
		@InvoiceClass = dbo.adfGetClassByName('Pjm5.Invoice'),
		@ReminderPublishState = dbo.fnPjm5GetUserInitialReminderState(@InvoiceClass, 'VA', @UserID),
		@ReminderPublishInterval = dbo.fnPjm5GetReminderInterval(@InvoiceClass, 'VA', @UserID),
		@ReminderState = dbo.fnPjm5GetUserInitialReminderState(@InvoiceClass, 'VP', @UserID),
		@ReminderInterval = dbo.fnPjm5GetReminderInterval(@InvoiceClass, 'VP', @UserID)

	EXEC @rv = pjm7InvoiceReminderCreate @ID, 'VP',
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	EXEC @rv = pjm7InvoiceReminderCreate @ID, 'VA',
		@Date, @ReminderPublishState, @ReminderPublishInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	COMMIT TRANSACTION

	EXEC pjm5InvoiceGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5InvoiceCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceCreateFromWizard]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5InvoiceCreateFromWizard'
	DROP PROCEDURE [dbo].[pjm5InvoiceCreateFromWizard]
END
GO
