 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5InvoiceDelete'
		DROP PROCEDURE [dbo].[pjm5InvoiceDelete]
	END
GO

PRINT 'Creating procedure pjm5InvoiceDelete'
GO

/******************************************************************************
**		File: pjm5InvoiceDelete.sql
**		Name: pjm5InvoiceDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.07.10	MAN				      
*******************************************************************************/
CREATE PROCEDURE pjm5InvoiceDelete
	@ID TIdentifier,
	@Forced TBool
AS
	SET NOCOUNT ON
	IF EXISTS(SELECT * FROM [AdvanceInvoice] WHERE [AdvanceInvoiceID] = @ID)
	BEGIN
		RAISERROR('#CannotDeleteAdvanceInvoice', 18, -1)
		RETURN 1
	END

	IF EXISTS(SELECT * FROM [PaymentDetail] WHERE [InvoiceID] = @ID)
	BEGIN
		RAISERROR('#CannotDeletePayedInvoice', 18, -1)
		RETURN 1
	END
	
	DECLARE @ProjectID TIdentifier
	SELECT @ProjectID = [ProjectID] FROM [Invoice] WHERE [ID] = @ID
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllInvoices')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0 AND
		dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF EXISTS(SELECT * FROM [SuperTimer] 
					WHERE [SuperTimer].[DocumentClass] = dbo.adfGetClassByName('Pjm5.Invoice') AND [SuperTimer].[DocumentID] = @ID AND 
					([SuperTimer].[State] in (1,2) OR ([SuperTimer].[State] = 3 AND [SuperTimer].[Persistent] = 1)))
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithActiveTimer', 18, -1)
		RETURN 1
	END		

	BEGIN TRANSACTION
	DELETE FROM [AdvanceInvoice] WHERE [InvoiceID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [InvoiceLine] WHERE [InvoiceID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [RemovedDocument] ( [DocumentID], [DocumentClass], [DocumentNumber], [DocumentDate], [Date])
	SELECT
		[Invoice].[ID],
		[Invoice].[Class],
		[Invoice].[Number],
		[Invoice].[Date],
		GETDATE()
	FROM
		[Invoice]
	WHERE
		[Invoice].[ID] = @ID
	
	DELETE FROM [Invoice] WHERE [Invoice].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm5InvoiceDelete TO PUBLIC
GO
