IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmProjectAll')
	BEGIN
		PRINT 'Dropping Procedure lmProjectAll'
		DROP  Procedure  lmProjectAll
	END

GO

PRINT 'Creating Procedure lmProjectAll'
GO
/******************************************************************************
**		File: 
**		Name: lmProjectAll
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		10.07.13	SOV				    ,  - . -
**									  . -
**		06.05.14	GNV				        
									 ViewAllProjects   
*******************************************************************************/
CREATE Procedure lmProjectAll
AS
	SET NOCOUNT ON

	DECLARE @EmployeeID INT, @hasAccess BIT
	SET @hasAccess = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))
	IF @hasAccess = 1
		SELECT
			[ID],
			[Number] as [Code],
			[FileAs] as [Name],
			[State],
			[ProjectManagerEmployeeID] AS [ManagerID]
		FROM
			[Project]
	ELSE
	BEGIN
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		SELECT DISTINCT
			[Project].[ID],
			[Project].[Number] as [Code],
			[Project].[FileAs] as [Name],
			[Project].[State],
			[Project].[ProjectManagerEmployeeID] AS [ManagerID]
		FROM
			[Project] INNER JOIN [vwAssignment]
				ON [Project].[ID] = [vwAssignment].[ProjectID] AND
					([vwAssignment].[EmployeeID] = @EmployeeID AND
					[vwAssignment].[State] = 1 OR [Project].[ProjectManagerEmployeeID] = @EmployeeID OR
					[Project].[ManagerAssistantEmployeeID] = @EmployeeID OR
					[Project].[FinanceManagerEmployeeID] = @EmployeeID) OR
					[Project].[State] = 5
	END	
	
	RETURN 0
GO

GRANT EXEC ON lmProjectAll TO PUBLIC
GO
 