IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trMeetingResourceDelete')
	BEGIN
		PRINT 'Dropping Trigger pjm5trMeetingResourceDelete'
		DROP  Trigger pjm5trMeetingResourceDelete
	END
	
PRINT 'Creating Trigger pjm5trMeetingResourceInsert'
GO
CREATE TRIGGER pjm5trMeetingResourceDelete ON [MeetingResource] FOR DELETE
AS
IF @@rowcount = 0 
	RETURN

SET NOCOUNT ON


DECLARE curDeleted CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR SELECT [MeetingRequestID], [ResourceID] FROM [deleted]
OPEN curDeleted

DECLARE @MeetingRequestID TIdentifier, @ResourceID TIdentifier, @MeetingRequestState TState,
		@result int

FETCH NEXT FROM curDeleted INTO @MeetingRequestID, @ResourceID
WHILE @@FETCH_STATUS = 0
BEGIN
	SELECT @MeetingRequestState = [State] FROM [MeetingRequest] WHERE [ID] = @MeetingRequestID
	IF @MeetingRequestState = 2 --  
	BEGIN
		EXEC @result = pjm5ResourceFree @ResourceID, @MeetingRequestID
		IF @@ERROR != 0 OR @result != 0
		BEGIN
			ROLLBACK TRANSACTION
			CLOSE curDeleted
			DEALLOCATE curDeleted
			RETURN 
		END
	END
	FETCH NEXT FROM curDeleted INTO @MeetingRequestID, @ResourceID
END

CLOSE curDeleted
DEALLOCATE curDeleted

RETURN
GO  
