
 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MsAssignmentsGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MsAssignmentsGet'
		DROP PROCEDURE [dbo].[pjm6MsAssignmentsGet]
	END
GO

PRINT 'Creating procedure pjm6MsAssignmentsGet'
GO


CREATE PROCEDURE [pjm6MsAssignmentsGet] 
				@MsTaskID TIdentifier
AS
	
	SET NOCOUNT ON

	DECLARE @TaskID TIdentifier
	SELECT @TaskID = [ID] FROM [Task] WHERE [MsTaskID] = @MsTaskID
	
	SELECT 
		[MsAssignment].[ID],
		[MsAssignment].[UniqueID],
		[MsAssignment].[Guid],
		[MsAssignment].[ProjectID],
		[MsAssignment].[TaskID],
		[MsAssignment].[Work],
		[MsAssignment].[OvertimeWork],
		[TaskAssignment].[RemainingWork],
		[TaskAssignment].[RemainingOvertimeWork],
		ISNULL((SELECT SUM([BusyEntry].[ActualWork] + ISNULL([BusyEntry].[ActualOvertimeWork],0)) FROM [BusyEntry] 
			WHERE [BusyEntry].[TaskID] = [TaskAssignment].[TaskID] 
				AND [BusyEntry].[AssignmentID] = [TaskAssignment].[AssignmentID]
				) / 60.0 , 0) 			as [ActualWork],
		ISNULL((SELECT SUM(ISNULL([BusyEntry].[ActualOvertimeWork],0)) FROM [BusyEntry] 
			WHERE [BusyEntry].[TaskID] = [TaskAssignment].[TaskID] 
				AND [BusyEntry].[AssignmentID] = [TaskAssignment].[AssignmentID]
				) / 60.0 , 0) 			as [ActualOvertimeWork],
		[Task].[State] AS [TaskState],
		[Task].[PercentComplete]*100 as [PercentComplete]
	FROM 
		[MsAssignment]
			INNER JOIN [vwAssignment] as [Assignment]
				ON [Assignment].[MsResourceID] = [MsAssignment].[ResourceID]
			INNER JOIN [TaskAssignment]
				ON [Assignment].[ID] = [TaskAssignment].[AssignmentID]
			INNER JOIN [Task]
				ON [Task].[ID] = [TaskAssignment].[TaskID]
	WHERE
		[MsAssignment].[TaskID] = @MsTaskID 
		AND [TaskAssignment].[TaskID] = @TaskID
		--AND [Assignment].[State] != 2
		AND [TaskAssignment].[MsAvailable] = 1

RETURN 0
GO

GRANT EXECUTE ON [pjm6MsAssignmentsGet] TO PUBLIC
GO 