IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MsResourceUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MsResourceUpdate'
		DROP PROCEDURE [dbo].[pjm6MsResourceUpdate]
	END
GO

PRINT 'Creating procedure pjm6MsResourceUpdate'
GO

SET QUOTED_IDENTIFIER ON
GO
/******************************************************************************
**		File: pjm6MsResourceUpdate.sql
**		Name: pjm6MsResourceUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 20.06.2006 19:57
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6MsResourceUpdate] @Xml XML
AS
	
	SET NOCOUNT ON

	DECLARE @ID TIdentifier,
			@MsProjectID TIdentifier,
			@Guid TGuid,
			@ProjectGuid TGuid,
			@QualificationID TIdentifier,
			@ProjectID TIdentifier,
			@EmployeeID TIdentifier,
			@AssignmentID TIdentifier,
			@StandardRate TMoney,
			@OvertimeRate TMoney
	
	SELECT 
		@MsProjectID = T.c.value('ProjectID[1]', 'int'),
		@ProjectGuid = T.c.value('ProjectGuid[1]', 'uniqueidentifier'),
		@Guid = T.c.value('Guid[1]', 'uniqueidentifier')
	FROM 
		@Xml.nodes('Resource') T(c);

	SELECT @ID = [ID] FROM [MsResource] WHERE [Guid] = @Guid AND [ProjectID] = @MsProjectID
	SELECT @ProjectID  = [ID] FROM [Project] WHERE [MsProjectID] = @MsProjectID
	
	BEGIN TRANSACTION
	
	IF @ID IS NULL
	BEGIN
		INSERT INTO [MsResource]
			   ([ProjectID], [UniqueID], [Guid], [Code], [Name], [Notes], [Initials], [Type],
			   [StandardRate], [OvertimeRate], 
			   [Work], [Cost], [CostPerUse], [OvertimeWork], [OvertimeCost],
			   [ActualWork], [ActualCost], [ActualOvertimeWork], [ActualOvertimeCost],
			   [RemainingWork], [RemainingCost], [RemainingOvertimeWork], [RemainingOvertimeCost],
			   [PercentWorkComplete])
		SELECT 
			@MsProjectID,
			T.c.value('UniqueID[1]', 'int'),
			T.c.value('Guid[1]', 'uniqueidentifier'),
			T.c.value('Code[1]', 'nvarchar(32)'),
			T.c.value('Name[1]', 'nvarchar(256)'),
			T.c.value('Notes[1]', 'nvarchar(max)'),
			T.c.value('Initials[1]', 'nvarchar(256)'),
			T.c.value('Type[1]', 'int'),
			T.c.value('StandardRate[1]', 'money'),
			T.c.value('OvertimeRate[1]', 'money'),
			T.c.value('Work[1]', 'double precision'),
			T.c.value('Cost[1]', 'double precision'),
			T.c.value('CostPerUse[1]', 'double precision'),
			T.c.value('OvertimeWork[1]', 'double precision'),
			T.c.value('OvertimeCost[1]', 'double precision'),
			T.c.value('ActualWork[1]', 'double precision'),
			T.c.value('ActualCost[1]', 'double precision'),
			T.c.value('ActualOvertimeWork[1]', 'double precision'),
			T.c.value('ActualOvertimeCost[1]', 'double precision'),
			T.c.value('RemainingWork[1]', 'double precision'),
			T.c.value('RemainingCost[1]', 'double precision'),
			T.c.value('RemainingOvertimeWork[1]', 'double precision'),
			T.c.value('RemainingOvertimeCost[1]', 'double precision'),
			T.c.value('PercentWorkComplete[1]', 'decimal(18,4)')
		FROM 
			@Xml.nodes('Resource') T(c);
			
		SET @ID = SCOPE_IDENTITY();
		DECLARE @Name TName,
				@Notes TNotes,
				@EmployeeFileAs TName
		
		SELECT 
			@Name = T.c.value('Name[1]', 'nvarchar(256)'),
			@StandardRate = T.c.value('StandardRate[1]', 'money'),
			@OvertimeRate = T.c.value('OvertimeRate[1]', 'money'),
			@Notes  = T.c.value('Notes[1]', 'nvarchar(max)')
		FROM 
			@Xml.nodes('Resource') T(c);
		
		
		SELECT	
			@QualificationID = COALESCE([EmployeeName].[QualificationID], [EmployeeCode].[QualificationID]),
			@EmployeeID = COALESCE([EmployeeName].[ID], [EmployeeCode].[ID]),
			@EmployeeFileAs = COALESCE([EmployeeName].[FileAs], [EmployeeCode].[FileAs])
		FROM
			[MsResource]
				LEFT OUTER JOIN [Employee] AS [EmployeeName]
					ON [EmployeeName].[FileAs] = [MsResource].[Name] 
						AND [EmployeeName].[State] != 2
				LEFT OUTER JOIN [Employee] AS [EmployeeCode]
					ON [EmployeeCode].[Initials] = [MsResource].[Initials]
						AND [EmployeeCode].[State] != 2
		WHERE
			[MsResource].[ID] = @ID
			
		IF EXISTS (
			SELECT 
				*
			FROM
				[vwAssignment] AS [Assignment]
			WHERE
				[Assignment].[ProjectID]  = @ProjectID AND
				[Assignment].[EmployeeID]  = @EmployeeID AND
				[Assignment].[State] = 1 AND
				[Assignment].[ID] != @ID
			)
			SET @EmployeeID = NULL
		
		IF @EmployeeID IS NULL
		BEGIN
			SELECT 
				@QualificationID = COALESCE([QFileAs].[ID], [QCode].[ID], [QInitialsCode].[ID], [QInitialsFileAs].[ID])
			FROM
				[MsResource]
					LEFT OUTER JOIN [Qualification] AS [QFileAs]
						ON [QFileAs].[FileAs] = [MsResource].[Name]
							AND [QFileAs].[State] != 2
					LEFT OUTER JOIN [Qualification] AS [QCode]
						ON [QCode].[Code] = [MsResource].[Name]
							AND [QCode].[State] != 2
					LEFT OUTER JOIN [Qualification] AS [QInitialsCode]
						ON [QInitialsCode].[Code] = [MsResource].[Initials]
							AND [QInitialsCode].[State] != 2
					LEFT OUTER JOIN [Qualification] AS [QInitialsFileAs]
						ON [QInitialsFileAs].[FileAs] = [MsResource].[Initials]
							AND [QInitialsFileAs].[State] != 2
			WHERE
				[MsResource].[ID] = @ID
		END
		
		INSERT INTO [Assignment]
           (
            [MsResourceID], [State], [Flag], [FileAs], [ProjectID], [QualificationID], [StandardRate],
			[OvertimeRate], [Approver], [Administrator], [AlwaysUseRate], [RateVisible],
			[ReceiveTaskStatusReports], [ReceiveIssueStatusReports], [Comments], [EqualEmployeeFileAs]
			)
		VALUES
			(
			@ID, 1, 0, @Name, @ProjectID, @QualificationID, @StandardRate,
			@OvertimeRate, 0, 0, 1, 0,
			0, 0, @Notes, CASE WHEN @EmployeeID IS NULL OR @EmployeeFileAs = @Name THEN 1 ELSE 0 END
			)
			
		IF @@ERROR != 0
		BEGIN	
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		IF @EmployeeID IS NOT NULL
		BEGIN
			SELECT 
				@AssignmentID = [Assignment].[ID]
			FROM 
				[Assignment]
			WHERE 
				[Assignment].[MsResourceID] = @ID

			INSERT INTO [AssignmentEntry]
			(
			[EmployeeID], [AssignmentID], [ValidFrom]
			)
			VALUES
			(
			@EmployeeID, @AssignmentID, CAST('17530101' AS datetime)
			)
			
			IF @@ERROR != 0
			BEGIN	
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	ELSE
	BEGIN
		UPDATE [MsResource]
		SET
			[UniqueID] = T.c.value('UniqueID[1]', 'int'),
			[Code] = T.c.value('Code[1]', 'nvarchar(32)'),
			[Name] = T.c.value('Name[1]', 'nvarchar(256)'),
			[Notes] = T.c.value('Notes[1]', 'nvarchar(max)'),
			[Initials] = T.c.value('Initials[1]', 'nvarchar(256)'),
			[Type] = T.c.value('Type[1]', 'int'),
			[StandardRate] = T.c.value('StandardRate[1]', 'money'),
			[OvertimeRate] = T.c.value('OvertimeRate[1]', 'money'),
			[Work] = T.c.value('Work[1]', 'double precision'),
			[Cost] = T.c.value('Cost[1]', 'double precision'),
			[CostPerUse] = T.c.value('Cost[1]', 'double precision'),
			[OvertimeWork] = T.c.value('OvertimeWork[1]', 'double precision'),
			[OvertimeCost] = T.c.value('OvertimeCost[1]', 'double precision'),
			[ActualWork] = T.c.value('ActualWork[1]', 'double precision'),
			[ActualCost] = T.c.value('ActualCost[1]', 'double precision'),
			[ActualOvertimeWork] = T.c.value('ActualOvertimeWork[1]', 'double precision'),
			[ActualOvertimeCost] = T.c.value('ActualOvertimeCost[1]', 'double precision'),
			[RemainingWork] = T.c.value('RemainingWork[1]', 'double precision'),
			[RemainingCost] = T.c.value('RemainingCost[1]', 'double precision'),
			[RemainingOvertimeWork] = T.c.value('RemainingOvertimeWork[1]', 'double precision'),
			[RemainingOvertimeCost] = T.c.value('RemainingOvertimeCost[1]', 'double precision'),
			[PercentWorkComplete] = T.c.value('PercentWorkComplete[1]', 'decimal(18,4)')
		FROM 
			[MsResource] INNER JOIN @Xml.nodes('Resource') T(c)
				ON [MsResource].[ID] = @ID
		IF @@ERROR != 0
		BEGIN	
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		DECLARE
			@prevStandardRate TMoney,
			@prevOvertimeRate TMoney,
			@State TState
		
		SELECT 
			@AssignmentID = [Assignment].[ID],
			@StandardRate = [MsResource].[StandardRate],
			@prevStandardRate = [Assignment].[StandardRate],
			@OvertimeRate = [MsResource].[OvertimeRate],
			@prevOvertimeRate = [Assignment].[OvertimeRate],
			@State = [Assignment].[State]
		FROM 
			[MsResource]
				INNER JOIN [Assignment]
					ON [Assignment].[MsResourceID] = [MsResource].[ID]
			WHERE 
			[MsResource].[ID] = @ID
		
		
		UPDATE [Assignment]
		SET 
			[Assignment].[StandardRate] = [MsResource].[StandardRate],
			[Assignment].[OvertimeRate] = [MsResource].[OvertimeRate],
			[Assignment].[Comments] = [MsResource].[Notes]
		FROM 
			[MsResource]
		WHERE 
			[Assignment].[ID] = @AssignmentID AND
			[MsResource].[ID] = @ID

		IF @@ERROR != 0
		BEGIN	
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		
		IF @State != 3 AND (@StandardRate != @prevStandardRate OR @OvertimeRate != @prevOvertimeRate)
		BEGIN
		-- TODO:  ,    UPDATE
			UPDATE [TimeEntry]
			SET
				[Rate] = (CASE WHEN [Overtime] = 1 THEN @OvertimeRate ELSE @StandardRate END)
			WHERE
				 [AssignmentID] = @AssignmentID
			AND
				[State] IN (1, 2, 5)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		
	END	

	SELECT @ID
	
	COMMIT TRANSACTION		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6MsResourceUpdate] TO PUBLIC
GO
    