IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MsTaskUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MsTaskUpdate'
		DROP PROCEDURE [dbo].[pjm6MsTaskUpdate]
	END
GO

PRINT 'Creating procedure pjm6MsTaskUpdate'
GO

SET QUOTED_IDENTIFIER ON
GO
/******************************************************************************
**		File: pjm6MsTaskUpdate.sql
**		Name: pjm6MsTaskUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 20.06.2006 19:57
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6MsTaskUpdate] @Xml XML
AS
	
	SET NOCOUNT ON

	DECLARE @ID TIdentifier,
			@MsProjectID TIdentifier,
			@MsParentID TIdentifier,
			@Guid TGuid,
			@ProjectGuid TGuid,
			@ParentGuid TGuid,
			@ParentID TIdentifier,
			@State TState,
			@TaskID TIdentifier,
			@ProjectState TIdentifier,
			@rv int
	
	SELECT 
		@MsProjectID = T.c.value('ProjectID[1]', 'int'),
		@ProjectGuid = T.c.value('ProjectGuid[1]', 'uniqueidentifier'),
		@Guid = T.c.value('Guid[1]', 'uniqueidentifier'),
		@ParentGuid = T.c.value('ParentGuid[1]', 'uniqueidentifier')
	FROM 
		@Xml.nodes('Task') T(c);

	
	SELECT @ID = [ID] FROM [MsTask] WHERE [Guid] = @Guid AND [ProjectID] = @MsProjectID
	SELECT @MsParentID = [ID] FROM [MsTask] WHERE [Guid] = @ParentGuid AND [ProjectID] = @MsProjectID
	
	BEGIN TRANSACTION
	
	IF @ID IS NULL
	BEGIN
		INSERT INTO [MsTask]
			   ([ProjectID], [ParentID], [PriorityID], [UniqueID], [Guid], [Name], [Notes],
			   [Start], [Finish], [Duration], [ActualStart], [ActualFinish],
			   [Work], [Cost], [OvertimeWork], [OvertimeCost],
			   [ActualWork], [ActualCost], [ActualDuration], [ActualOvertimeWork], [ActualOvertimeCost],
			   [RemainingWork], [RemainingCost], [RemainingDuration], [RemainingOvertimeWork], [RemainingOvertimeCost],
			   [PercentComplete], [PercentWorkComplete], [Milestone], [Estimated])
		SELECT 
			@MsProjectID,
			@MsParentID,
			T.c.value('PriorityID[1]', 'int'),
			T.c.value('UniqueID[1]', 'int'),
			T.c.value('Guid[1]', 'uniqueidentifier'),
			T.c.value('Name[1]', 'nvarchar(256)'),
			T.c.value('Notes[1]', 'nvarchar(max)'),
			T.c.value('Start[1]', 'datetime'),
			T.c.value('Finish[1]', 'datetime'),
			T.c.value('Duration[1]', 'int'),
			T.c.value('ActualStart[1]', 'datetime'),
			T.c.value('ActualFinish[1]', 'datetime'),
			T.c.value('Work[1]', 'double precision'),
			T.c.value('Cost[1]', 'double precision'),
			T.c.value('OvertimeWork[1]', 'double precision'),
			T.c.value('OvertimeCost[1]', 'double precision'),
			T.c.value('ActualWork[1]', 'double precision'),
			T.c.value('ActualCost[1]', 'double precision'),
			T.c.value('ActualDuration[1]', 'int'),
			T.c.value('ActualOvertimeWork[1]', 'double precision'),
			T.c.value('ActualOvertimeCost[1]', 'double precision'),
			T.c.value('RemainingWork[1]', 'double precision'),
			T.c.value('RemainingCost[1]', 'double precision'),
			T.c.value('RemainingDuration[1]', 'int'),
			T.c.value('RemainingOvertimeWork[1]', 'double precision'),
			T.c.value('RemainingOvertimeCost[1]', 'double precision'),
			T.c.value('PercentComplete[1]', 'decimal(18,4)'),
			T.c.value('PercentWorkComplete[1]', 'decimal(18,4)'),
			T.c.value('Milestone[1]', 'bit'),
			T.c.value('Estimated[1]', 'bit')
		FROM 
			@Xml.nodes('Task') T(c);
			
		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		
			
		SELECT @ID = SCOPE_IDENTITY();
		
		DECLARE 
			@Name TName,
			@ProjectID TIdentifier,
			@PriorityID TIdentifier,
			@Start TDate,
			@Finish TDate,
			@PercentComplete TPercent,
			@Milestone TBool,
			@Notes TNotes,
			@Duration TAmount,
			@Cost TMoney,
			@ManHour TCount
		
		SELECT 
			@ParentID = [Task].[ID]
		FROM
			[Task]
				INNER JOIN [Project]
					ON [Task].[ProjectID] = [Project].[ID]
		WHERE
			[Task].[MsTaskID] = @MsParentID
		
		SELECT
			@Name = [MsTask].[Name],
			@ProjectID = [Project].[ID],
			@PriorityID = 
			CASE WHEN [MsTask].[PriorityID] BETWEEN 0 AND 49 THEN 0 ELSE
				 CASE WHEN [MsTask].[PriorityID] BETWEEN 50 AND 549 THEN 500 ELSE 1000 END END,
			@Start = CAST(CONVERT(varchar(8), [MsTask].[Start], 112) AS datetime),
			@Finish = CAST(CONVERT(varchar(8), [MSTask].[Finish], 112) AS datetime),
			@PercentComplete = [MsTask].[PercentComplete]/100,
			@Milestone = [MsTask].[Milestone],
			@Notes = [MsTask].[Notes],
			@Duration = CAST([MsTask].[Duration] AS decimal(18,4))/CAST([MsProject].[HoursPerDay] AS decimal(18,4))/60.0, --dbo.fnPjm5GetWorkingDays([MsTask].[Start],[MsTask].[Finish])*24*60,
			@ManHour = [MsTask].[Work],
			@Cost = [MsTask].[Cost],
			@ProjectState = [Project].[State]
		FROM [MsTask]
			INNER JOIN [Project]
			ON [Project].[MsProjectID] = [Mstask].[ProjectID]
			INNER JOIN [MsProject]
			ON [MsTask].[ProjectID] = [MsProject].[ID]
		WHERE [MsTask].[ID] = @ID
		INSERT INTO [Task]
           (
            [MsTaskID],[State],[Flag],[FileAs],[ProjectID],[PriorityID],[ParentID]
           ,[StartDate],[DueDate],[Duration],[ManHour],[Budget],[PercentComplete],[Milestone],[SendStatusReport],[Comments])
		VALUES
			(
			@ID,8,0,@Name,@ProjectID,@PriorityID,@ParentID,
			@Start,@Finish,@Duration,@ManHour,@Cost,@PercentComplete,@Milestone,0,@Notes
			)
		
		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		SELECT @TaskID = SCOPE_IDENTITY()
	
		DECLARE
			@ReminderState TState,
			@ReminderTime TDateTime,
			@ReminderInterval TTimeSpan,
			@UserID TIdentifier,
			@Class TClass

		SET @UserID = dbo.adfGetCurrentUserID()
		SET @Class = dbo.adfGetClassByName('Pjm5.Task')

		SELECT
			@ReminderState = ISNULL([InitialState], CAST(0 as int))
		FROM 
			[ReminderSetting]
		WHERE
			[UserID] = @UserID
			AND [Subtype] = 'TD'

		SET @ReminderTime = DATEADD(minute, 
					-dbo.fnPjm5GetReminderInterval(@Class, 'TD', @UserID), @Finish)
		SET @ReminderState  = ISNULL(@ReminderState, CAST(0 as int))

		SET @ReminderInterval = DATEDIFF(minute, @ReminderTime, @Finish)
		EXEC @rv = pjm7TaskReminderCreate @TaskID,
			@Finish, @ReminderState, @ReminderInterval
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
		
		IF @ProjectState = 2
		BEGIN
			exec @rv = pjm5TaskChangeState @TaskID, 2
		END
		IF @rv !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
		UPDATE [MsTask]
		SET
			[UniqueID] = T.c.value('UniqueID[1]', 'int'),
			[PriorityID] = T.c.value('PriorityID[1]', 'int'),
			[Name] = T.c.value('Name[1]', 'nvarchar(256)'),
			[Notes] = T.c.value('Notes[1]', 'nvarchar(max)'),
			[Start] = T.c.value('Start[1]', 'datetime'),
			[Finish] = T.c.value('Finish[1]', 'datetime'),
			[Duration] = T.c.value('Duration[1]', 'int'),
			[ActualStart] = T.c.value('ActualStart[1]', 'datetime'),
			[ActualFinish] = T.c.value('ActualFinish[1]', 'datetime'),
			[Work] = T.c.value('Work[1]', 'double precision'),
			[Cost] = T.c.value('Cost[1]', 'double precision'),
			[OvertimeWork] = T.c.value('OvertimeWork[1]', 'double precision'),
			[OvertimeCost] = T.c.value('OvertimeCost[1]', 'double precision'),
			[ActualWork] = T.c.value('ActualWork[1]', 'double precision'),
			[ActualCost] = T.c.value('ActualCost[1]', 'double precision'),
			[ActualDuration] = T.c.value('ActualDuration[1]', 'int'),
			[ActualOvertimeWork] = T.c.value('ActualOvertimeWork[1]', 'double precision'),
			[ActualOvertimeCost] = T.c.value('ActualOvertimeCost[1]', 'double precision'),
			[RemainingWork] = T.c.value('RemainingWork[1]', 'double precision'),
			[RemainingCost] = T.c.value('RemainingCost[1]', 'double precision'),
			[RemainingDuration] = T.c.value('RemainingDuration[1]', 'int'),
			[RemainingOvertimeWork] = T.c.value('RemainingOvertimeWork[1]', 'double precision'),
			[RemainingOvertimeCost] = T.c.value('RemainingOvertimeCost[1]', 'double precision'),
			[PercentComplete] = T.c.value('PercentComplete[1]', 'decimal(18,4)'),
			[PercentWorkComplete] = T.c.value('PercentWorkComplete[1]', 'decimal(18,4)'),
			[Milestone] = T.c.value('Milestone[1]', 'bit'),
			[Estimated] = T.c.value('Estimated[1]', 'bit')
		FROM 
			[MsTask] INNER JOIN @Xml.nodes('Task') T(c)
				ON [MsTask].[ID] = @ID
		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END	
		
		SELECT 
			@ParentID = [Task].[ID]
		FROM
			[Task]
		WHERE
			[Task].[MsTaskID] = @MsParentID
		
		DECLARE 
				@MsPercentComplete TPercent
				
		SELECT 
			@State = [Task].[State],
			@MsPercentComplete = [MsTask].[PercentComplete],
			@TaskID = [Task].[ID]
		FROM
			[Task]
				INNER JOIN [MsTask]
					ON [Task].[MsTaskID] = [MsTask].[ID]
		WHERE
			[Task].[MsTaskID] = @ID
			
	
		IF(@State = 6 OR (@State = 3 AND @MsPercentComplete != 100))
		BEGIN
			exec @rv = pjm5TaskChangeStateInternal @TaskID, 2
		END
		IF @rv !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END	
			UPDATE [Task]
			SET
				[Task].[FileAs] = [MsTask].[Name],
				[Task].[PriorityID] = 
				CASE WHEN [MsTask].[PriorityID] BETWEEN 0 AND 49 THEN 0 ELSE
						 CASE WHEN [MsTask].[PriorityID] BETWEEN 50 AND 549 THEN 500 ELSE 1000 END END,
				[Task].[StartDate] = CAST(CONVERT(varchar(8), [MsTask].[Start], 112) AS datetime),
				[Task].[DueDate] = CAST(CONVERT(varchar(8), [MsTask].[Finish], 112) AS datetime),
				[Task].[Duration] = CAST([MsTask].[Duration] AS decimal(18,4))/[MsProject].[HoursPerDay]/60, --dbo.fnPjm5GetWorkingDays([MsTask].[Start],[MsTask].[Finish])*24*60,
				[Task].[PercentComplete] = [MsTask].[PercentWorkComplete]/100,
				[Task].[Milestone] = [MsTask].[Milestone],
				[Task].[Comments] = [MsTask].[Notes],
				[Task].[ManHour] = [MsTask].[Work],
				[Task].[Budget] = [MsTask].[Cost],
				[Task].[ParentID] = @ParentID
			FROM [Task]
				INNER JOIN [MsTask]
					ON [MsTask].[ID] = [Task].[MsTaskID]
				INNER JOIN [MsProject]
					ON [MsTask].[ProjectID] = [MsProject].[ID]
			WHERE [Task].[MsTaskID] = @ID
			
			IF @@ERROR !=0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
	END	
	
	UPDATE [TaskWbs]
	SET
		[Wbs] = T.c.value('WBS[1]', 'nvarchar(256)'),
		[TaskIndex] = T.c.value('ID[1]', 'int')
	FROM 
		[TaskWbs] 
			INNER JOIN @Xml.nodes('Task') T(c)
				ON [TaskWbs].[TaskID] = @TaskID
	IF @@ERROR !=0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END	
	
	SELECT @ID
	
	SELECT [ID] FROM [MsAssignment] WHERE [TaskID] = @ID
		
	
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON [pjm6MsTaskUpdate] TO PUBLIC
GO
   