 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ReminderUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ReminderUpdate'
		DROP PROCEDURE [dbo].[pjm7ReminderUpdate]
	END
GO

PRINT 'Creating procedure pjm7ReminderUpdate'
GO

/******************************************************************************
**		File: pjm7ReminderUpdate.sql
**		Name: pjm7ReminderUpdate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 02.05.2012 11:46:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm7ReminderUpdate]
	@DocumentClass TClass,
	@ReminderSubtype TCode2,
	@DocumentID TIdentifier,
	@ReminderEventTime TDateTime
AS
	SET NOCOUNT ON
	
	IF @DocumentClass IS NULL OR @DocumentID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @@TRANCOUNT = 0
	BEGIN
		RAISERROR('#NotTransactionEnvironment', 18, -1)
		RETURN 1
	END
	
	DECLARE
		@ReminderID TIdentifier
		
	SELECT @ReminderID = [ID]
	FROM [Reminder]
	WHERE [DocumentClass] = @DocumentClass AND
		[Subtype] = @ReminderSubtype AND
		[DocumentID] = @DocumentID
		
	IF @ReminderID IS NULL
		RETURN 0
	
	UPDATE [Reminder] SET 
		[EventTime] = @ReminderEventTime,
		[Modified] = DEFAULT
	WHERE [ID] = @ReminderID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	RETURN 0
GO