/*========================================================*/
/* Database View:                       */
/*========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwRevisionStatement]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwRevisionStatement]
go

create view pjm5vwRevisionStatement
as
	SELECT
		[Statement].[Class] as [DocumentClass],
		[Statement].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Statement].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Statement].[ModifiedBy] as [OwnerUserID]
	FROM
		[Statement]
	WHERE
		[Statement].[State] = 1 AND EXISTS
		(
			SELECT *		
			FROM [Transition]
			INNER JOIN [TransitionTemplate]
				ON [TransitionTemplate].[ID] = [Transition].[TransitionTemplateID]
			WHERE
				[Transition].[Class] = [Statement].[Class] AND
				(([TransitionTemplate].[FromState] = 2 AND
				 [TransitionTemplate].[ToState] = 1) OR
				([TransitionTemplate].[FromState] = 3 AND
				 [TransitionTemplate].[ToState] = 1)) AND
				[Transition].[ID] IN (
					SELECT TOP 1 [ID]
					FROM [Transition]
					WHERE [Class] = [Statement].[Class] AND
					[DocumentID] = [Statement].[ID]
					ORDER BY [Created] DESC
				)
		)	
go

/*==================================================*/
/* Database View:                    */
/*==================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwAcceptStatement]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwAcceptStatement]
go

create view pjm5vwAcceptStatement
as
	SELECT
		[Statement].[Class] as [DocumentClass],
		[Statement].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Statement].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Statement].[ModifiedBy] as [OwnerUserID]
	FROM
		[Statement]
	WHERE
		[Statement].[State] = 2
go

/*==================================================*/
/* Database View:                  */
/*==================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwCancelStatement]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwCancelStatement]
go

create view pjm5vwCancelStatement
as
	SELECT
		[Statement].[Class] as [DocumentClass],
		[Statement].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Statement].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Statement].[ModifiedBy] as [OwnerUserID]
	FROM
		[Statement]
	WHERE
		[Statement].[State] = 4
go

/*==================================================*/
/* Database View:                     */
/*==================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwSignStatement]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwSignStatement]
go

create view pjm5vwSignStatement
as
	SELECT
		[Statement].[Class] as [DocumentClass],
		[Statement].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Statement].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Statement].[ModifiedBy] as [OwnerUserID]
	FROM
		[Statement]
	WHERE
		[Statement].[State] = 3
go

/*========================================================*/
/* Database View:             */
/*========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwReminderStatement]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwReminderStatement]
go

create view pjm5vwReminderStatement
as
	SELECT
		[Statement].[Class] as [DocumentClass],
		[Statement].[ID] as [DocumentID],
		[Statement].[ReturnDate] as [EventTime],
		NULL as [RecipientUserID]
	FROM
		[Statement]

go

grant select on [dbo].[pjm5vwReminderStatement] to [public]
go