/*==============================================================*/
/* Database View:           */
/*==============================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwSendToApproveTimeEntry]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwSendToApproveTimeEntry]
go

create view pjm5vwSendToApproveTimeEntry
as
	SELECT
		[TimeEntry].[Class] as [DocumentClass],
		[TimeEntry].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[TimeEntry].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[TimeEntry].[ModifiedBy] as [OwnerUserID]
	FROM
		[TimeEntry]
	WHERE
		[TimeEntry].[State] = 2
go

/*================================================================================*/
/* Database View:         */
/*================================================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwRecipientSendToApproveTimeEntry]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwRecipientSendToApproveTimeEntry]
go

create view pjm5vwRecipientSendToApproveTimeEntry
as
	SELECT
		NULL as [DocumentClass],
		NULL as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		[Employee].[UserID] as [UserID]
	FROM
		[Project]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [Project].[ProjectManagerEmployeeID]
	WHERE
		[Project].[State] = 2
	UNION ALL
	SELECT
		NULL as [DocumentClass],
		NULL as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		[Employee].[UserID] as [UserID]
	FROM
		[Project]
		INNER JOIN [Assignment]
			ON [Assignment].[ProjectID] = [Project].[ID]
		INNER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
	WHERE
		[Project].[State] = 2 AND [Assignment].[Approver] = 1 AND
		GETDATE() BETWEEN [AssignmentEntry].[ValidFrom] AND ISNULL([AssignmentEntry].[ValidTo], GETDATE())
go

/*==============================================================*/
/* Database View:             */
/*==============================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwSendToWorkTimeEntry]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwSendToWorkTimeEntry]
go

create view pjm5vwSendToWorkTimeEntry
as
	SELECT
		[TimeEntry].[Class] as [DocumentClass],
		[TimeEntry].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[TimeEntry].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		NULL as [Value],
		[TimeEntry].[ModifiedBy] as [OwnerUserID]
	FROM
		[TimeEntry]
		INNER JOIN [Employee]
			ON [TimeEntry].[EmployeeID] = [Employee].[ID]
	WHERE
		[TimeEntry].[State] = 5
go

/*==============================================================*/
/* Database View:                      */
/*==============================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwDenyTimeEntry]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwDenyTimeEntry]
go

create view pjm5vwDenyTimeEntry
as
	SELECT
		[TimeEntry].[Class] as [DocumentClass],
		[TimeEntry].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[TimeEntry].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		NULL as [Value],
		[TimeEntry].[ModifiedBy] as [OwnerUserID]
	FROM
		[TimeEntry]
		INNER JOIN [Employee]
			ON [TimeEntry].[EmployeeID] = [Employee].[ID]
	WHERE
		[TimeEntry].[State] = 4
go 

/*==============================================================*/
/* Database View:          */
/*==============================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwReminderTimeEntry]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwReminderTimeEntry]
go

create view pjm5vwReminderTimeEntry
as
	SELECT
		[TimeEntry].[Class] as [DocumentClass],
		[TimeEntry].[ID] as [DocumentID],
		[Employee].[UserID] as [RecipientUserID],
		[TimeEntry].[StartTime] as [EventTime]
	FROM
		[TimeEntry]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [TimeEntry].[EmployeeID]
go

grant select on [dbo].[pjm5vwReminderTimeEntry] to [public]
go