IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PhoneCallCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PhoneCallCreate'
		DROP PROCEDURE [dbo].[pjm5PhoneCallCreate]
	END
GO

PRINT 'Creating procedure pjm5PhoneCallCreate'
GO

/******************************************************************************
**		File: pjm5PhoneCallCreate.sql
**		Name: pjm5PhoneCallCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		12.03.13	SOV				 OpenXml  Xml  
**		19.03.13	SOV				       @Duration
*******************************************************************************/
CREATE PROCEDURE [pjm5PhoneCallCreate]
	@Xml XML
AS
	DECLARE 
		@State TState,
		@FileAs TName,
		@ActivityTypeID TIdentifier,
		@EmployeeID TIdentifier,
		@ProjectID TIdentifier,
		@TaskID TIdentifier,
		@StartTime TDateTime,
		@Duration TCount,
		@TimeBillable TBool,
		@ExpenseBillable TBool,
		@Overtime TBool,
		@ExpenseCodeID TIdentifier,
		@Amount TCount,
		@Price TMoney,
		@ExpenseCurrencyCode TCode3,
		@ProjectCurrencyCode TCode3,
		@BillableDuration TCount,
		@Rate TMoney,
		@VATRate TPercent,
		@Comments TNotes,
		@PhoneCallCodeID TIdentifier,
		@TimeEntryID TIdentifier,
		@ExpenseID TIdentifier,
		@ID TIdentifier,
		@rv int,
		@MyEmployeeID int,
		@VATIsIncluded TBool,
		@UOMID TIdentifier,
		@value TVariant,
		@DocumentClass TIdentifier,
		@DocumentID TIdentifier,
		
		@PhoneClass TClass,
		@ExpenseClass TClass,
		@TimeEntryClass TClass
	
	SET NOCOUNT ON

	SET @PhoneClass = dbo.adfGetClassByName('Pjm5.PhoneCall')
	SET @ExpenseClass = dbo.adfGetClassByName('Pjm5.Expense')
	SET @TimeEntryClass = dbo.adfGetClassByName('Pjm5.TimeEntry')

	SET @State = dbo.adfwfGetInitialState('b196878b-db17-446f-bbf1-13fccf77acf7')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SELECT
		@FileAs = [XmlTable].value('FileAs[1]', 'nvarchar(256)'), 
		@PhoneCallCodeID = [XmlTable].value('PhoneCallCodeID[1]', 'int'),
		@ActivityTypeID = [XmlTable].value('ActivityTypeID[1]', 'int'),
		@ProjectID = [XmlTable].value('ProjectID[1]', 'int'), 
		@TaskID = [XmlTable].value('TaskID[1]', 'int'), 
		@StartTime = CAST([XmlTable].value('StartTime[1]', 'varchar(19)') as datetime), 
		@Duration = [XmlTable].value('Duration[1]', 'int'), 
		@TimeBillable = CASE WHEN [XmlTable].value('Billable[1]', 'varchar(5)') = 'false' THEN 0 ELSE 1 END, 
		@ExpenseBillable = CASE WHEN [XmlTable].value('ExpenseBillable[1]', 'varchar(5)') = 'false' THEN 0 ELSE 1 END, 
		@Overtime = CASE WHEN [XmlTable].value('Overtime[1]', 'varchar(5)') = 'false' THEN 0 ELSE 1 END, 
		@ProjectCurrencyCode = [Project].[CurrencyCode], 
		@Price = ROUND([PhoneCallRate].[Price], 2), 
		@VATRate = dbo.fnPjm5GetVATRate(),
		@VATIsIncluded = [PhoneCallCode].[VATIsIncluded],
		@Comments = [XmlTable].value('Comments[1]', 'nvarchar(max)'),
		@EmployeeID = [XmlTable].value('EmployeeID[1]', 'int'),
		@DocumentClass = dbo.adfGetClassByName([XmlTable].value('DocumentClass[1]', 'nvarchar(max)')),
		@DocumentID = [XmlTable].value('DocumentID[1]', 'TIdentifier')
	FROM
		@Xml.nodes('/pjm5PhoneCallGet/PhoneCall') AS List(XmlTable)
		INNER JOIN [Project]
			ON [Project].[ID] = [XmlTable].value('ProjectID[1]', 'int')
		INNER JOIN [PhoneCallCode]
			ON [PhoneCallCode].[ID] = [XmlTable].value('PhoneCallCodeID[1]', 'int')
		LEFT OUTER JOIN [PhoneCallRate]
			ON ([PhoneCallRate].[PhoneCallCodeID] = [PhoneCallCode].[ID] AND
				[PhoneCallRate].[CurrencyCode] = [Project].[CurrencyCode])
				
	IF NOT EXISTS(
		SELECT *
		FROM [ProjectExpenseCode]
		WHERE
			[ProjectID] = @ProjectID AND
			[ExpenseCodeID] = 1
		)
	BEGIN
		RAISERROR('#phonecallisnotenabled', 18, -1)
		RETURN 1
	END

	IF @Price IS NULL
	BEGIN
		RAISERROR('#pricenotfound', 18, -1)
		RETURN 1
	END

	DECLARE @language TLanguage
	SET @language = dbo.adfGetLanguage()
	IF @FileAs IS NULL
		SELECT 
			@FileAs = CASE @language
				WHEN 'en' THEN 'Phone call, code '
				ELSE ' ,  '
			END + ISNULL([FileAs], [Code])
		FROM
			[PhoneCallCode]
		WHERE
			[ID] = @PhoneCallCodeID
			
	BEGIN TRANSACTION
	EXEC @rv = pjm5TimeEntryCreateInternal 
		@TimeEntryID OUTPUT, 
		@FileAs, 
		@ActivityTypeID,
		@EmployeeID, 
		@ProjectID,
		@DocumentClass,
		@DocumentID, 
		@TaskID, 
		@StartTime, 
		@Duration, 
		@TimeBillable,
		@Duration,
		@Overtime, 
		NULL,
		@Comments
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	DECLARE @VAT TMoney
	IF @VATIsIncluded = 1
		SET @VAT = ROUND(@Duration * @Price * @VATRate / (1 + @VATRate), 2)
	ELSE
		SET @VAT = ROUND(@Duration * @Price * @VATRate, 2)
		
	EXEC adfParameterGet @Name='MinuteUOMID', @Group='Pjm5', @Value = @value OUTPUT
	SET @UOMID = CAST(@value as int)
	
	EXEC @rv = pjm5ExpenseCreateInternal 
		@ExpenseID OUTPUT, 
		@FileAs,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		1, --@ExpenseCodeID,
		@StartTime,
		@UOMID, --    
		@Duration, --@Amount,
		@ExpenseBillable,
		@Price,
		@ProjectCurrencyCode, --@ExpenseCurrencyCode,
		@ProjectCurrencyCode,
		1, --@CurrencyRate,
		@VATRate,
		@VATIsIncluded, --VatIsIncluded
		@VAT,
		@Comments
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	INSERT INTO [PhoneCall]
		([Flag], [State], [FileAs], [TimeEntryID], [ExpenseID], [PhoneCallCodeID], [Comments])
	VALUES
		(0, @State, @FileAs, @TimeEntryID, @ExpenseID, @PhoneCallCodeID, @Comments)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	VALUES
		(@ExpenseClass, @ExpenseID, '  ',
		@TimeEntryClass, @TimeEntryID, 3)	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	VALUES
		(@TimeEntryClass, @TimeEntryID, '',
		@ExpenseClass, @ExpenseID, 3)	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC pjm5PhoneCallGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5PhoneCallCreate TO PUBLIC
GO
 