 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ClearItemsID')
	BEGIN
		PRINT 'Dropping Procedure ClearItemsID'
		DROP  Procedure  ClearItemsID
	END

GO
 
 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'PjmSyncClearItemsID')
	BEGIN
		PRINT 'Dropping Procedure PjmSyncClearItemsID'
		DROP  Procedure  PjmSyncClearItemsID
	END

GO

PRINT 'Creating Procedure PjmSyncClearItemsID'
GO

--------------------------------------------------------------------------------------
	CREATE Procedure PjmSyncClearItemsID
		@DeviceID varchar(40),
		@Contact BIT,
		@Calendar BIT,
		@Task BIT

	AS
		SET NOCOUNT ON

	SELECT 
		[ExternalLink].[ItemID]	
	FROM 
		[ExternalLink]
			INNER JOIN [Employee]		
			ON [Employee].[Class] = [ExternalLink].[DocumentClass] AND
				[Employee].[ID] = [ExternalLink].[DocumentID]	
	WHERE @Contact = 1 AND @DeviceID = [ExternalLink].[DeviceID]

	UNION

	SELECT 
		[ExternalLink].[ItemID]	
	FROM 
		[ExternalLink]
			INNER JOIN [Company]		
			ON [Company].[Class] = [ExternalLink].[DocumentClass] AND
				[Company].[ID] = [ExternalLink].[DocumentID]	
	WHERE @Contact = 1 AND @DeviceID = [ExternalLink].[DeviceID]
			
	
	UNION	

	SELECT 
		[ExternalLink].[ItemID]	
	FROM 
		[ExternalLink]
			INNER JOIN [MeetingRequest]		
			ON [MeetingRequest].[Class] = [ExternalLink].[DocumentClass] AND
				[MeetingRequest].[ID] = [ExternalLink].[DocumentID]	
	WHERE @Calendar = 1 AND @DeviceID = [ExternalLink].[DeviceID]

	UNION

	SELECT 
		[ExternalLink].[ItemID]	
	FROM 
		[ExternalLink]
			INNER JOIN [TimeEntry]		
			ON [TimeEntry].[Class] = [ExternalLink].[DocumentClass] AND
				[TimeEntry].[ID] = [ExternalLink].[DocumentID]	
	WHERE @Calendar = 1 AND @DeviceID = [ExternalLink].[DeviceID]
			
	UNION
	
	SELECT 
		[ExternalLink].[ItemID]	
	FROM 
		[ExternalLink]
		INNER JOIN [Task]
			ON [Task].[Class] = [ExternalLink].[DocumentClass] AND
				[Task].[ID] = [ExternalLink].[DocumentID]
	WHERE 	@Task = 1 AND @DeviceID = [ExternalLink].[DeviceID] 

	UNION 

	SELECT 
		[ExternalLink].[ItemID]	
	FROM 
		[ExternalLink]		
		INNER JOIN [TaskRequest]
			ON [TaskRequest].[Class] = [ExternalLink].[DocumentClass] AND
				[TaskRequest].[ID] = [ExternalLink].[DocumentID]	
	WHERE @Task = 1 AND @DeviceID = [ExternalLink].[DeviceID]

RETURN 0
GO

GRANT EXEC ON PjmSyncClearItemsID TO PUBLIC
GO
