IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectUpdate'
		DROP PROCEDURE [dbo].[pjm5ProjectUpdate]
	END
GO

PRINT 'Creating procedure pjm5ProjectUpdate'
GO

/******************************************************************************
**		File: pjm5ProjectUpdate.sql
**		Name: pjm5ProjectUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		17.09.09	syv				  BankAccountID
**
**		06.04.10	KOV				      
**									 -   
**		13.11.10	SYV				  [GroupingAdvanceCalculations]
**		24.11.10	SYV				  [StatementCurrencyPoint]
**		18.04.11	SYV				    
**		04.02.13	SAP				  Color
**		22.02.13	SAP				  OPENXML
**		29.03.13	SOV				   . -  . - 
**		01.04.13	SOV				. -     
**		05.04.13	SOV				. -     
**		17.04.13	SOV				  . -   
**		13.06.13	SOV				  -   
**		13.05.14	BAO				    [ProjectStageID]
**		19.05.14	BAO				     
**									  
*******************************************************************************/
CREATE PROCEDURE pjm5ProjectUpdate
	@Xml	XML
AS
	DECLARE
		@ID TIdentifier,
		@AssignmentState TState,
		@CurrencyCode TCode3,
		@ManHour TAmount,
		@Budget TMoney,
		
		@AssignmentID TIdentifier,
		@EmployeeName TName,
		@QualificationID TIdentifier,
		@StandardRate TMoney,
		@OvertimeRate TMoney,
		@rv int,
		
		@ExternalNotificationOpenIssue bit,
		@ExternalNotificationResolveIssue bit,
		@ExternalNotificationPostponeIssue bit,
		@ExternalNotificationCloseIssue bit,
		
		@CustomerCompanyID TIdentifier,
		@InvoicePeriodType TCode,
		@InvoiceDayType TCode,
		@InvoiceNextPaymentDate TDate,
		@StatementPeriodType TCode,
		@StatementDayType TCode,
		@StatementNextPaymentDate TDate,
		@CalculationPeriodType TCode,
		@CalculationDayType TCode,
		@CalculationNextPaymentDate TDate,
		@BankAccountID TIdentifier,
		@ExchangeSystemName TName,
		@IsConsignor bit,
		@ConsignorID TIdentifier,
		@ConsignorClass TClass,
		@ConsignorContract TName,
		@BudgetNextCalculationDate	TDate,
		@BudgetID					TIdentifier,
		@ReminderState					TState,
		@DiscountTypeByTime					TIdentifier,
		@DiscountViewByTime					TBool,
		@DiscountByTime						TMoney,
		
		@DiscountTypeByExpense				TIdentifier,
		@DiscountViewByExpense				TBool,
		@DiscountByExpense					TMoney,
		
		@DiscountTypeByPhone				TIdentifier,
		@DiscountViewByPhone				TBool,
		@DiscountByPhone					TMoney,
		
		@DiscountTypeByServiceRequest		TIdentifier,
		@DiscountViewByServiceRequest		TBool,
		@DiscountByServiceRequest			TMoney,

		@FinanceManagerEmployeeID			TIdentifier,
		@ManagerAssistantEmployeeID			TIdentifier,
		@ProjectManagerEmployeeID			TIdentifier,

		@AddManagerAssistantToParticipants	TBool,
		@AddManagerToParticipants			TBool,
		@GroupByProjects					TBool

	SET NOCOUNT ON
	
	
	SELECT		
		@ID = @Xml.value('(/pjm5ProjectGet/Project/ID)[1]','int'),
		@ManHour = @Xml.value('(/pjm5ProjectGet/Project/ManHour)[1]','decimal(18,4)'), 
		@Budget = @Xml.value('(/pjm5ProjectGet/Project/Budget)[1]','money'),
		@CustomerCompanyID = @Xml.value('(/pjm5ProjectGet/Project/CustomerCompanyID)[1]','int'),
		@ExternalNotificationOpenIssue =
			CASE @Xml.value('(/pjm5ProjectGet/Project/ExternalNotificationOpenIssue)[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			END,
		@ExternalNotificationResolveIssue =
			CASE @Xml.value('(/pjm5ProjectGet/Project/ExternalNotificationResolveIssue)[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			END,
		@ExternalNotificationPostponeIssue =
			CASE @Xml.value('(/pjm5ProjectGet/Project/ExternalNotificationPostponeIssue)[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			END,
		@ExternalNotificationCloseIssue =
			CASE @Xml.value('(/pjm5ProjectGet/Project/ExternalNotificationCloseIssue)[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			END,
		@InvoicePeriodType = @Xml.value('(/pjm5ProjectGet/Project/InvoicePeriodType)[1]','varchar(32)'),
		@InvoiceDayType = @Xml.value('(/pjm5ProjectGet/Project/InvoiceDayType)[1]','varchar(32)'),
		@InvoiceNextPaymentDate = CAST(@Xml.value('(/pjm5ProjectGet/Project/InvoiceNextPaymentDate)[1]','varchar(19)') AS datetime),
		@StatementPeriodType = @Xml.value('(/pjm5ProjectGet/Project/StatementPeriodType)[1]','varchar(32)'),
		@StatementDayType = @Xml.value('(/pjm5ProjectGet/Project/StatementDayType)[1]','varchar(32)'),
		@StatementNextPaymentDate = CAST(@Xml.value('(/pjm5ProjectGet/Project/StatementNextPaymentDate)[1]','varchar(19)') AS datetime),
		@CalculationPeriodType = @Xml.value('(/pjm5ProjectGet/Project/CalculationPeriodType)[1]','varchar(32)'),
		@CalculationDayType = @Xml.value('(/pjm5ProjectGet/Project/CalculationDayType)[1]','varchar(32)'),
		@CalculationNextPaymentDate = CAST(@Xml.value('(/pjm5ProjectGet/Project/CalculationNextPaymentDate)[1]','varchar(19)') AS datetime),
		@BankAccountID = @Xml.value('(/pjm5ProjectGet/Project/BankAccountDefault)[1]','int'),
		@ExchangeSystemName = @Xml.value('(/pjm5ProjectGet/Project/ExchangeSystemName)[1]','varchar(50)'),
		@IsConsignor = 
			CASE @Xml.value('(/pjm5ProjectGet/Project/IsConsignor)[1]','bit') 
				WHEN 'false' THEN 0 
				ELSE 1 
			END,
		@ConsignorID = @Xml.value('(/pjm5ProjectGet/Project/ConsignorID)[1]','int'),
		@ConsignorClass = @Xml.value('(/pjm5ProjectGet/Project/ConsignorClass)[1]','smallint'),
		@ConsignorContract = @Xml.value('(/pjm5ProjectGet/Project/ConsignorContract)[1]','varchar(50)'),
		@BudgetID = @Xml.value('(/pjm5ProjectGet/Project/BudgetID)[1]','int'),
		@BudgetNextCalculationDate = CAST(@Xml.value('(/pjm5ProjectGet/Project/NextCalculationDate)[1]','varchar(19)') AS datetime),
		@ReminderState = 
			CASE @Xml.value('(/pjm5ProjectGet/Project/ReminderState)[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			END,
		@DiscountTypeByTime	= @Xml.value('(/pjm5ProjectGet/Project/DiscountTypeByTime)[1]','int'),
		@DiscountViewByTime	= @Xml.value('(/pjm5ProjectGet/Project/DiscountViewByTime)[1]','bit'),
		@DiscountByTime	= @Xml.value('(/pjm5ProjectGet/Project/DiscountByTime)[1]','decimal(18,4)'),
		
		@DiscountTypeByExpense = @Xml.value('(/pjm5ProjectGet/Project/DiscountTypeByExpense)[1]','int'),
		@DiscountViewByExpense = @Xml.value('(/pjm5ProjectGet/Project/DiscountViewByExpense)[1]','bit'),
		@DiscountByExpense = @Xml.value('(/pjm5ProjectGet/Project/DiscountByExpense)[1]','decimal(18,4)'),
		
		@DiscountTypeByPhone = @Xml.value('(/pjm5ProjectGet/Project/DiscountTypeByPhone)[1]','int'),
		@DiscountViewByPhone = @Xml.value('(/pjm5ProjectGet/Project/DiscountViewByPhone)[1]','bit'),
		@DiscountByPhone = @Xml.value('(/pjm5ProjectGet/Project/DiscountByPhone)[1]','decimal(18,4)'),
		
		@DiscountTypeByServiceRequest = @Xml.value('(/pjm5ProjectGet/Project/DiscountTypeByServiceRequest)[1]','int'),
		@DiscountViewByServiceRequest = @Xml.value('(/pjm5ProjectGet/Project/DiscountViewByServiceRequest)[1]','bit'),
		@DiscountByServiceRequest = @Xml.value('(/pjm5ProjectGet/Project/DiscountByServiceRequest)[1]','decimal(18,4)'),
	
		@FinanceManagerEmployeeID =  @Xml.value('(/pjm5ProjectGet/Project/FinanceManagerEmployeeID)[1]','int'),
		@ManagerAssistantEmployeeID =  @Xml.value('(/pjm5ProjectGet/Project/ManagerAssistantEmployeeID)[1]','int'),
		@ProjectManagerEmployeeID = @Xml.value('(/pjm5ProjectGet/Project/ProjectManagerEmployeeID)[1]','int'),
		@AddManagerAssistantToParticipants = @Xml.value('(/pjm5ProjectGet/Project/AddManagerAssistantToParticipants)[1]','bit'),
		@AddManagerToParticipants = @Xml.value('(/pjm5ProjectGet/Project/AddManagerToParticipants)[1]','bit'),
		@GroupByProjects = @Xml.value('(/pjm5ProjectGet/Project/GroupByProjects)[1]','bit')

	IF EXISTS (SELECT * FROM [Project] WHERE [ID] = @ID AND [State] = 4)
	BEGIN
		RAISERROR('#CannotEditClosedProject', 18, -1)
		RETURN 1
	END

	DECLARE @CurrentEmployeeID int
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5IsProjectManager(@ID, @CurrentEmployeeID) = 0 AND
		dbo.fnPjm7IsManagerAssistant(@ID, @CurrentEmployeeID) = 0 AND
		dbo.fnPjm7IsFinanceManager(@ID, @CurrentEmployeeID) = 0 AND
		(
		dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')) = 0 OR
		dbo.adfHasAccessRight(dbo.adfGetRightID('ManageProject')) = 0
		)
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @Budget IS NOT NULL AND @Budget < 0
	BEGIN
		RAISERROR('#BudgetIsInvalid', 18, -1)
		RETURN 1
	END
	IF @ManHour IS NOT NULL AND @ManHour < 0
	BEGIN
		RAISERROR('#ManHourIsInvalid', 18, -1)
		RETURN 1
	END
	
	--    -  
	--         
	--        ,  
	DECLARE @InvoiceCount int, @StatementCount int, @CalculationCount int, @FactureCount int
	SELECT @InvoiceCount = COUNT([ID]) FROM [Invoice] WHERE [Invoice].[ProjectID] = @ID
	SELECT @StatementCount = COUNT([ID]) FROM [Statement] WHERE [Statement].[ProjectID] = @ID
	--SELECT @CalculationCount = COUNT([ID]) FROM [Calculation] WHERE [Calculation].[ProjectID] = @ID
	SELECT @FactureCount = COUNT([ID]) FROM [Facture] WHERE [Facture].[ProjectID] = @ID
	IF (@InvoiceCount != 0 OR @StatementCount != 0 OR @FactureCount != 0) AND @CustomerCompanyID IS NULL
	BEGIN
		RAISERROR('#ProjectInvoiceOrCalcExists', 18, -1)
		RETURN 1
	END

	DECLARE @CurrentFinanceManagerEmployeeID TIdentifier,
			@CurrentManagerAssistantEmployeeID TIdentifier,
			@CurrentManagerEmployeeID TIdentifier,
			@Error INT

	SELECT
		@CurrentFinanceManagerEmployeeID = [FinanceManagerEmployeeID],
		@CurrentManagerAssistantEmployeeID = [ManagerAssistantEmployeeID],
		@CurrentManagerEmployeeID = [ProjectManagerEmployeeID]
	FROM
		[Project]
	WHERE
		[Project].[ID] = @ID
	
	BEGIN TRANSACTION

	--  . -   - 
	IF (@CurrentFinanceManagerEmployeeID IS NOT NULL AND @FinanceManagerEmployeeID IS NULL) OR
		(@CurrentFinanceManagerEmployeeID IS NULL AND @FinanceManagerEmployeeID IS NOT NULL) OR
		(@CurrentFinanceManagerEmployeeID IS NOT NULL AND @FinanceManagerEmployeeID IS NOT NULL AND
		@CurrentFinanceManagerEmployeeID != @FinanceManagerEmployeeID)
	BEGIN
		EXEC @Error = pjm7ChangeFinanceManager @ProjectID = @ID, @EmployeeID = @FinanceManagerEmployeeID
		
		IF @Error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	IF (@CurrentManagerAssistantEmployeeID IS NOT NULL AND @ManagerAssistantEmployeeID IS NULL) OR
		(@CurrentManagerAssistantEmployeeID IS NULL AND @ManagerAssistantEmployeeID IS NOT NULL) OR
		(@CurrentManagerAssistantEmployeeID IS NOT NULL AND @ManagerAssistantEmployeeID IS NOT NULL AND
		@CurrentManagerAssistantEmployeeID != @ManagerAssistantEmployeeID)
	BEGIN
		SET @AddManagerAssistantToParticipants = ISNULL(@AddManagerAssistantToParticipants, 0)

		EXEC @Error = pjm7ChangeManagerAssistant @ProjectID = @ID, @EmployeeID = @ManagerAssistantEmployeeID,
			@AddToParticipants = @AddManagerAssistantToParticipants
				
		IF @Error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	--   
	IF (@CurrentManagerEmployeeID != @ProjectManagerEmployeeID)
	BEGIN
		SET @AddManagerToParticipants = ISNULL(@AddManagerToParticipants, 0)

		IF EXISTS
		(
			SELECT * FROM [dbo].[vwAssignment] 
			WHERE ([EmployeeID] = @ProjectManagerEmployeeID) AND ([ProjectID] = @ID) AND ([State] = 1)
		)
		SET @AddManagerToParticipants = 0

		EXEC @Error = pjm5ChangeProjectManager @ProjectID = @ID, @EmployeeID = @ProjectManagerEmployeeID,
			@AddToParticipants = @AddManagerToParticipants
				
		IF @Error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	UPDATE
		[PaymentPeriod]
	SET
		[InvoicePeriodType] = @InvoicePeriodType,
		[InvoiceDayType] = @InvoiceDayType,
		[InvoiceNextPaymentDate] = @InvoiceNextPaymentDate,
		[StatementPeriodType] = @StatementPeriodType,
		[StatementDayType] = @StatementDayType,
		[StatementNextPaymentDate] = @StatementNextPaymentDate,
		[CalculationPeriodType] = @CalculationPeriodType,
		[CalculationDayType] = @CalculationDayType,
		[CalculationNextPaymentDate] = @CalculationNextPaymentDate
	WHERE
		[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE [Project]
	SET
		@ID = [XmlTable].[ID],
		@CurrencyCode = [XmlTable].[CurrencyCode],
		[Project].[Date] = [XmlTable].[Date],
		[Project].[Number] = [XmlTable].[Number],
		[Project].[NumerationCode] = [XmlTable].[NumerationCode],
		[Project].[FileAs] = [XmlTable].[FileAs],
		[Project].[ProjectTypeID] = [XmlTable].[ProjectTypeID],
		[Project].[SupplierCompanyID] = [XmlTable].[SupplierCompanyID],
		[Project].[CustomerCompanyID] = [XmlTable].[CustomerCompanyID],
		[Project].[CustomerFinanceManagerID] = [XmlTable].[CustomerFinanceManagerID],
		[Project].[ResponsiblePersonEmployeeID] = [XmlTable].[ResponsiblePersonEmployeeID],
		[Project].[PriorityID] = [XmlTable].[PriorityID],
		[Project].[ProjectLanguageCode] = [XmlTable].[ProjectLanguageCode],
		[Project].[CurrencyCode] = [XmlTable].[CurrencyCode],
		[Project].[CostCenterID] = [XmlTable].[CostCenterID],
		[Project].[ProjectStageID] = [XmlTable].[ProjectStageID],
		[Project].[Budget] = [XmlTable].[Budget],
		[Project].[ContractNumber] = [XmlTable].[ContractNumber],
		[Project].[ContractDate] = [XmlTable].[ContractDate],
		[Project].[ContractEndDate] = [XmlTable].[ContractEndDate],
		[Project].[ContractSubject] = [XmlTable].[ContractSubject],
		[Project].[ApplyVAT] = [XmlTable].[ApplyVAT],
		[Project].[InvoiceExpirationPeriod] = [XmlTable].[InvoiceExpirationPeriod],
		[Project].[InvoiceExpirationPeriodType] = [XmlTable].[InvoiceExpirationPeriodType],
		[Project].[Comments] = [XmlTable].[Comments],
		[Project].[RoundingMode] = [XmlTable].[RoundingMode],
		[Project].[RoundingInterval] = [XmlTable].[RoundingInterval],
		[Project].[Billable] = [XmlTable].[Billable],
		[Project].[WSSDocumentsURL] = [XmlTable].[WSSDocumentsURL],
		[Project].[SupportsRequestManagement] = [XmlTable].[SupportsRequestManagement],
		[Project].[RatesWithVAT] = CASE [XmlTable].[ApplyVAT]
				WHEN 1 THEN [XmlTable].[RatesWithVAT]
				ELSE 0
			END,
		[Project].[PaymentCurrencyPoint] = [XmlTable].[PaymentCurrencyPoint],
		[Project].[InitialBalance] = [XmlTable].[InitialBalance],
		[Project].[BaseInitialBalance] = [XmlTable].[BaseInitialBalance],
		[Project].[InvoiceCurrency] = [XmlTable].[InvoiceCurrency],
		[Project].[StatementCurrency] = [XmlTable].[StatementCurrency],
		[Project].[FactureCurrency] = [XmlTable].[FactureCurrency],
		[Project].[Scale] = [XmlTable].[Scale],
		[Project].[FolderID] = [XmlTable].[FolderID],
		[Project].[Modified] = DEFAULT,
		[Project].[ModifiedBy] = DEFAULT,
		[Project].[EndDate] = [XmlTable].[EndDate],
		[Project].[GroupCalculationLines] = [XmlTable].[GroupCalculationLines],
		[Project].[CheckTaskWorkOverdraft] = [XmlTable].[CheckTaskWorkOverdraft],
		[Project].[ContractComments] = [XmlTable].[ContractComments],
		[Project].[ShowActivityTypes] = [XmlTable].[ShowActivityTypes],
		[Project].[BankAccountID] = [XmlTable].[BankAccountDefault],
		[Project].[ExchangeSystemName] = @ExchangeSystemName,
		[Project].[GroupingAdvanceCalculations] = [XmlTable].[GroupingAdvanceCalculations],
		[Project].[StatementCurrencyPoint] = [XmlTable].[StatementCurrencyPoint],
		[Project].[IsConsignor] = @IsConsignor,
		[Project].[ConsignorID] = @ConsignorID,
		[Project].[ConsignorClass] = @ConsignorClass,
		[Project].[ConsignorContract] = @ConsignorContract,
		[Project].[ShowPrice] = [XmlTable].[ShowPrice],
		[Project].[UseSubProjects] = [XmlTable].[UseSubProjects],
		[Project].[Color] = [XmlTable].[Color],
		[Project].[GroupByProjects] = @GroupByProjects
	FROM
		[Project] INNER JOIN
		(
		SELECT
			T.c.value('ID[1]','int') AS [ID],
			CAST(T.c.value('Date[1]','varchar(19)') as datetime) AS [Date],
			T.c.value('Number[1]','varchar(32)') AS [Number],
			T.c.value('NumerationCode[1]','varchar(32)') AS [NumerationCode],
			T.c.value('FileAs[1]','nvarchar(256)') AS [FileAs],
			T.c.value('ProjectTypeID[1]','int') AS [ProjectTypeID],
			T.c.value('SupplierCompanyID[1]','int') AS [SupplierCompanyID],
			T.c.value('CustomerCompanyID[1]','int') AS [CustomerCompanyID],
			T.c.value('CustomerFinanceManagerID[1]','int') AS [CustomerFinanceManagerID],
			T.c.value('ResponsiblePersonEmployeeID[1]','int') AS [ResponsiblePersonEmployeeID],
			T.c.value('PriorityID[1]','int') AS [PriorityID],
			T.c.value('ProjectLanguageCode[1]','varchar(32)') AS [ProjectLanguageCode],
			T.c.value('CurrencyCode[1]','char(3)') AS [CurrencyCode],
			T.c.value('CostCenterID[1]','int') AS [CostCenterID],
			T.c.value('ProjectStageID[1]', 'int') AS [ProjectStageID],
			T.c.value('Budget[1]','money') AS [Budget],
			T.c.value('ContractNumber[1]','varchar(32)') AS [ContractNumber],
			CAST(T.c.value('ContractDate[1]','varchar(19)') as datetime) as [ContractDate],
			CAST(T.c.value('ContractEndDate[1]','varchar(19)') as datetime) as [ContractEndDate],
			T.c.value('ContractSubject[1]','nvarchar(256)') AS [ContractSubject],
			(CASE T.c.value('ApplyVAT[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) as [ApplyVAT],
			T.c.value('InvoiceExpirationPeriod[1]','int') AS [InvoiceExpirationPeriod],
			T.c.value('InvoiceExpirationPeriodType[1]','int') AS [InvoiceExpirationPeriodType],
			T.c.value('WSSDocumentsURL[1]','varchar(512)') AS [WSSDocumentsURL],
			T.c.value('Comments[1]','nvarchar(max)') AS [Comments],
			T.c.value('RoundingInterval[1]','int') AS [RoundingInterval],
			T.c.value('RoundingMode[1]','int') AS [RoundingMode],
			(CASE  
				WHEN T.c.value('ProjectTypeID[1]','int') IN (1) THEN 1 
				ELSE 0 
				END) AS [Billable],
			(CASE T.c.value('SupportsRequestManagement[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) AS [SupportsRequestManagement],
			(CASE T.c.value('RatesWithVAT[1]','varchar(5)')
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) AS [RatesWithVAT],
			T.c.value('PaymentCurrencyPoint[1]','int') AS [PaymentCurrencyPoint],
			T.c.value('InitialBalance[1]','money') AS [InitialBalance],
			T.c.value('BaseInitialBalance[1]','money') AS [BaseInitialBalance],
			T.c.value('InvoiceCurrency[1]','int') AS [InvoiceCurrency],
			T.c.value('StatementCurrency[1]','int') AS [StatementCurrency],
			T.c.value('FactureCurrency[1]','int') AS [FactureCurrency],
			T.c.value('Scale[1]','int') AS [Scale],
			T.c.value('FolderID[1]','int') AS [FolderID],
			CAST(T.c.value('EndDate[1]','varchar(19)') as datetime) AS [EndDate],
			(CASE T.c.value('GroupCalculationLines[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) AS [GroupCalculationLines],
			(CASE T.c.value('ShowActivityTypes[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) AS [ShowActivityTypes],
			(CASE T.c.value('CheckTaskWorkOverdraft[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) AS [CheckTaskWorkOverdraft],
			T.c.value('ContractComments[1]','nvarchar(max)') AS [ContractComments],
			T.c.value('BankAccountDefault[1]','int') AS [BankAccountDefault],
			T.c.value('GroupingAdvanceCalculations[1]','int') AS [GroupingAdvanceCalculations],
			T.c.value('StatementCurrencyPoint[1]','int') AS [StatementCurrencyPoint],
			(CASE T.c.value('ShowPrice[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) AS [ShowPrice],
			T.c.value('UseSubProjects[1]','bit') AS [UseSubProjects],
			T.c.value('Color[1]','int') AS [Color]
		FROM
			@Xml.nodes('/pjm5ProjectGet/Project') AS T(c)
		WHERE
			T.c IS NOT NULL			
				) as [XmlTable] ON
			([Project].[ID] = [XmlTable].[ID])
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE [ProjectDetail]
	SET
		[DueDate] = CASE 
			WHEN [Project].[MsProjectID] IS NULL THEN [XmlTable].[DueDate]
			ELSE [ProjectDetail].[DueDate]
		END,
		[DiscountTypeByTime] = @DiscountTypeByTime,
		[DiscountViewByTime] = @DiscountViewByTime,
		[DiscountByTime] = @DiscountByTime,
		
		[DiscountTypeByExpense] = @DiscountTypeByExpense,
		[DiscountViewByExpense] = @DiscountViewByExpense,
		[DiscountByExpense] = @DiscountByExpense,
		
		[DiscountTypeByPhone] = @DiscountTypeByPhone,
		[DiscountViewByPhone] = @DiscountViewByPhone,
		[DiscountByPhone] = @DiscountByPhone,
		
		[DiscountTypeByServiceRequest] = @DiscountTypeByServiceRequest,
		[DiscountViewByServiceRequest] = @DiscountViewByServiceRequest,
		[DiscountByServiceRequest] = @DiscountByServiceRequest
	FROM
		[ProjectDetail]
		INNER JOIN [Project] 
			ON [Project].[ID] = [ProjectDetail].[ID]
		INNER JOIN
		(
		SELECT
			T.c.value('ID[1]','int') AS [ID],
			CAST(T.c.value('DueDate[1]','varchar(19)') as datetime) As [DueDate]
		FROM
			@Xml.nodes('/pjm5ProjectGet/Project') AS T(c)
		WHERE
			T.c IS NOT NULL	
		) AS [XmlTable] ON
			[Project].[ID] = [XmlTable].[ID]
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [ProjectActivityType] WHERE [ProjectActivityType].[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [ProjectActivityType]
			([ProjectID], [ActivityTypeID], [Billable], [Actively])
	SELECT
		@ID,
		T.c.value('ID[1]','int') AS [ID],
		(CASE T.c.value('Billable[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		(CASE T.c.value('Actively[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		@Xml.nodes('/pjm5ProjectGet/ProjectActivityType') AS T(c)
	WHERE 
		T.c IS NOT NULL		


	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [ProjectExpenseCode] WHERE [ProjectExpenseCode].[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [ProjectExpenseCode]
			([ProjectID], [ExpenseCodeID], [Billable], [Actively])
	SELECT
		@ID,
		T.c.value('ID[1]','int') AS [ID],
		(CASE T.c.value('Billable[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		(CASE T.c.value('Actively[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		@Xml.nodes('/pjm5ProjectGet/ProjectExpenseCode') AS T(c)
	WHERE 
		T.c IS NOT NULL


	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DECLARE 
		@Now			TDate,
		@CurrentUserID	TIDentifier

	SET @currentUserID = dbo.adfGetCurrentUserID()
	SET @Now = GETDATE()
	IF @BudgetID IS NOT NULL AND (
		EXISTS(
			SELECT *
			FROM 
				[Budget] 
				LEFT OUTER JOIN [Reminder]
					ON ([Reminder].[DocumentClass] = [Budget].[Class] AND
						[Reminder].[DocumentID] = [Budget].[ID] AND
						[Reminder].[Subtype] = 'BC')
				LEFT OUTER JOIN [UserReminder]
					ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
						[UserReminder].[UserID] = @CurrentUserID)
			WHERE 
				[Budget].[ID] = @BudgetID 
				AND 
				(ISNULL([NextCalculationDate], @Now) <> ISNULL(@BudgetNextCalculationDate, @Now)
				OR ISNULL([UserReminder].[State], 0) <> @ReminderState)))
	BEGIN
		UPDATE [Budget]
		SET [NextCalculationDate] = @BudgetNextCalculationDate
		WHERE [ID] = @BudgetID AND [State] IN (1, 2)

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		DECLARE
			@ReminderInterval				TTimeSpan,
			@WorkTimeStart					TCount,
			@value							TVariant

		EXEC adfParameterGet 'WorkTimeStart1', 'Pjm5', @value OUTPUT	
		SET  @WorkTimeStart = CAST(@value AS int)

		SET @ReminderInterval = -@WorkTimeStart
		EXEC @rv = pjm7BudgetReminderCreate @BudgetID,
			@BudgetNextCalculationDate, @ReminderState, @ReminderInterval
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END

	DECLARE 
			@SubscriptionRuleID TIdentifier,
			@UserID TIdentifier,
			@OpenIssueID TIdentifier,
			@ResolveIssueID TIdentifier,
			@PostponeIssueID TIdentifier,
			@CloseIssueID TIdentifier
			
	SELECT
		@UserID = dbo.adfGetCurrentUserID(),
		@OpenIssueID = dbo.fnPjm5GetSubscriptionTypeByCode('ExternalOpenIssue'),
		@ResolveIssueID = dbo.fnPjm5GetSubscriptionTypeByCode('ExternalResolveIssue'),
		@PostponeIssueID = dbo.fnPjm5GetSubscriptionTypeByCode('ExternalPostponeIssue'),
		@CloseIssueID = dbo.fnPjm5GetSubscriptionTypeByCode('ExternalCloseIssue')
	
	EXEC @rv = dbo.pjm5ExternalSubscriptionRuleCreate @SubscriptionRuleID OUTPUT, @ID, @UserID
	IF @rv != 0 OR @SubscriptionRuleID IS NULL
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	IF @ExternalNotificationOpenIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @OpenIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END
	
	IF @ExternalNotificationResolveIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @ResolveIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END
	
	IF @ExternalNotificationPostponeIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @PostponeIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END
	
	IF @ExternalNotificationCloseIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @CloseIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END
	
	COMMIT TRANSACTION


	EXEC pjm5ProjectGet @ID
GO

GRANT EXECUTE ON pjm5ProjectUpdate TO PUBLIC
GO