IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportMRTMHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportMRTMHeader'
		DROP  Procedure  ReportMRTMHeader
	END

GO

PRINT 'Creating Procedure ReportMRTMHeader'
GO
--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/


CREATE Procedure ReportMRTMHeader
	@ProjectID		TIdentifier,
	@MonthStart	    Tdatetime,
	@NextDate		Tdatetime,
	@NotLogged		TString
AS
	SET NOCOUNT ON

	DECLARE
		@UserID			TIdentifier,
		@UserName		TName
		
	SET @UserID = dbo.adfGetCurrentUserID()
		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID

	SELECT
		[Project].[FileAs] AS [Name],
		[Project].[Number] AS [ProjectCode],
		[SupplierCompany].[LegalName] AS [SupplierCompanyName],
		[CostCenter].[FileAs] AS [CostCenter],
		[Company].[LegalName] AS [CompanyName],
		[Employee].[FileAs] AS [ManagerName],
		[Project].[Date] AS [StartDate],
		[Project].[EndDate] AS [EndDate],
		CASE
			WHEN [Project].[EndDate] IS NOT NULL
			THEN dbo.fnPjm5GetWorkingDays(GETDATE(), [Project].[EndDate])
			ELSE NULL
		END AS [Remains],
		CASE
			WHEN [Project].[EndDate] IS NOT NULL
			THEN dbo.fnPjm5GetWorkingDays([Project].[EndDate], GETDATE())
			ELSE NULL
		END AS [Exceed], 
		[Project].[State] AS [State],
		@MonthStart AS [MonthStart],
		@NotLogged AS [NotLogged],
		@UserName AS [UserName]
	FROM 
		[Project]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
		LEFT OUTER JOIN [Company] AS [SupplierCompany]
			ON [Project].[SupplierCompanyID] = [SupplierCompany].[ID]		
		LEFT OUTER JOIN [Employee]
			ON [Project].[ProjectManagerEmployeeID] = [Employee].[ID]
		LEFT OUTER JOIN [CostCenter]
			ON [Project].[CostCenterID] = [CostCenter].[ID]	
	WHERE
		[Project].[ID] = @ProjectID

RETURN 0
GO

GRANT EXEC ON ReportMRTMHeader TO PUBLIC

GO
