IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportPortfolioOfProjectsHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportPortfolioOfProjectsHeader'
		DROP  Procedure  ReportPortfolioOfProjectsHeader
	END

GO

PRINT 'Creating Procedure ReportPortfolioOfProjectsHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportPortfolioOfProjectsHeader
	@CompanyID	TIdentifier,
	@StateSelector	int,
	@ManagerID 	TIdentifier,
	@BillSelector   int,
	@DivisionID		TIdentifier,
	@DivisionSelector		int
AS
	SET NOCOUNT ON
	DECLARE
		@UserID			TIdentifier,
		@CompanyName	TName,
		@DivisionName   TName,
		@ManagerName	TName,
		@UserName		TName
		
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @CompanyName = '()'
	SET @ManagerName = '()'
	SET @DivisionName = CASE @DivisionSelector
         WHEN 0 THEN '()'
         WHEN 1 THEN ' '
	END			
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
	
	SELECT
		@CompanyName = [Company].[FileAs]
	FROM
		[Company]
	WHERE
		[Company].[ID] = @CompanyID	
		
	SELECT
		@ManagerName = [Employee].[FileAs]
	FROM
		[Employee]
	WHERE
		[Employee].[ID] = @ManagerID		
	
	SELECT
		@DivisionName = [Division].[FileAs]
	FROM
		[Division]
	WHERE
		[Division].[ID] = @DivisionID	
	
	SELECT	
		@CompanyName  AS [CompanyName],
		@DivisionName AS [DivisionName],
		@ManagerName AS [ManagerName],
		@StateSelector	AS [StateSelector],
		@BillSelector AS [ProjectType],
		@UserName AS [UserName]	
	
RETURN 0
GO

GRANT EXEC ON ReportPortfolioOfProjectsHeader TO PUBLIC

GO
