IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportTimesheetHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportTimesheetHeader'
		DROP  Procedure  ReportTimesheetHeader
	END

GO

PRINT 'Creating Procedure ReportTimesheetHeader'
GO

/******************************************************************************
**		File: 
**		Name: ReportWRE
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.04.14	BAO				   "HaveTasksFlag
*******************************************************************************/
CREATE Procedure ReportTimesheetHeader
	@EmployeeID		int,
	@WeekStart	    Tdatetime,
	@NextDate		Tdatetime,
	@HaveTasksFlag	bit

AS
	SET DATEFIRST 7
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName,
		@EmployeeName	TName,
		@DimensionID	TIdentifier,
		@CompanyName	TName,
		@value			TVariant,
		@WorkTime		decimal(18,2)
		
	EXEC adfParameterGet 'WorkTime', 'Pjm5', @value OUTPUT  
	SET @WorkTime = CAST(@value AS decimal(18,2))
	SET @WorkTime = @WorkTime / 60.00		
						
	SET @UserID = dbo.adfGetCurrentUserID()
		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
		
	SELECT
		@DimensionID = [Employee].[ID],
		@EmployeeName = [Employee].[FileAs],
		@CompanyName = [Company].[FileAs]
	FROM 
		[Employee]
		LEFT OUTER JOIN [Company]
			ON [Employee].[CompanyID] = [Company].[ID]
	WHERE
		[Employee].[ID] = @EmployeeID 
	
	SELECT
		@EmployeeName AS [Name],
		@DimensionID AS [DimensionID],
		@CompanyName AS [CompanyName],
		@WeekStart AS [WeekStart],
		DATEADD(second, -1, DATEADD(week, 1, @WeekStart)) AS [WeekEnd],
		@UserName AS [UserName],
		dbo.fnPjm5GetWorkingDays(@WeekStart, DATEADD(second, -1, @NextDate)) AS [WorkingDays],
		@WorkTime AS [WorkTime],
		@HaveTasksFlag AS [HaveTasks]

RETURN 0
GO

GRANT EXEC ON ReportTimesheetHeader TO PUBLIC

GO
