IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceAlloc]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceAlloc'
		DROP PROCEDURE [dbo].[pjm5ResourceAlloc]
	END
GO

PRINT 'Creating procedure pjm5ResourceAlloc'
GO

/******************************************************************************
**		File: pjm5ResourceAlloc.sql
**		Name: pjm5ResourceAlloc
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 06/02/2006 15:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceAlloc
	@ResourceID TIdentifier,
	@MeetingRequestID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @FileAs TName, @StartTime TDateTime, @Duration TCount, @PriorityID TIdentifier, @EmployeeID TIdentifier,
			@Color TColor, @ProjectID TIdentifier, @ResourceRequestID TIdentifier
	SELECT 
		@FileAs = [FileAs], 
		@StartTime = [StartTime],
		@Duration = [Duration],
		@PriorityID = [PriorityID],
		@EmployeeID = [OriginatorEmployeeID],
		@ProjectID = [ProjectID],
		@Color = [Color]
	FROM 
		[MeetingRequest] WHERE [ID] = @MeetingRequestID
	
	DECLARE @result INT
	IF EXISTS(SELECT * FROM [ResourceRequest] WHERE [ResourceID] = @ResourceID AND [MeetingRequestID] = @MeetingRequestID)
	BEGIN
		SELECT 
			@ResourceRequestID = [ID] 
		FROM 
			[ResourceRequest] 
		WHERE 
			[ResourceID] = @ResourceID AND [MeetingRequestID] = @MeetingRequestID

		IF EXISTS(SELECT * FROM [ResourceRequest] WHERE [ID] = @ResourceRequestID AND [State] = 3)
		BEGIN
			UPDATE [ResourceRequest] 
			SET
				[State] = 5 -- canceled
			WHERE
				[ID] = @ResourceRequestID
			IF @@ERROR != 0
				RETURN 1
		END
					
		UPDATE [ResourceRequest]
		SET
			[FileAs] = @FileAs,
			[StartTime] = @StartTime,
			[Duration] = @Duration,
			[ProjectID] = @ProjectID,
			[EmployeeID] = @EmployeeID,
			[PriorityID] = @PriorityID,
			[Color] = @Color,
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		WHERE
			[ID] = @ResourceRequestID
		IF @@ERROR != 0
			RETURN 1
	END
	ELSE
	BEGIN
		INSERT INTO [ResourceRequest]
			([State], [Flag], [FileAs], [StartTime], [Duration], [ProjectID], [EmployeeID], [ResourceID], [PriorityID],
			[Color], [MeetingRequestID])
		VALUES
			(1, 0, @FileAs, @StartTime, @Duration, @ProjectID, @EmployeeID, @ResourceID, @PriorityID, 
			@Color, @MeetingRequestID)
		IF @@ERROR != 0
			RETURN 1				
		SET @ResourceRequestID = SCOPE_IDENTITY()
	END
		
	EXEC @result = pjm5ResourceRequestChangeState @ResourceRequestID, 2
	IF @@ERROR != 0 OR @result != 0
		RETURN 1				

	RETURN 0
GO

   