IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceAssignmentBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceAssignmentBrowse'
		DROP PROCEDURE [dbo].[pjm5ServiceAssignmentBrowse]
	END
GO

PRINT 'Creating procedure pjm5ServiceAssignmentBrowse'
GO

/******************************************************************************
**		File: pjm5ServiceAssignmentBrowse.sql
**		Name: pjm5ServiceAssignmentBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 01/27/2005 15:57:09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		04.04.13	SOV				    . - 
**									     " "
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceAssignmentBrowse]
	@StateSelector	INT,
	@ProjectID		TIdentifier = NULL
AS
	SET NOCOUNT ON
	
	DECLARE @VAT TPercent
	SET @VAT = dbo.fnPjm5GetVATRate()

	DECLARE @IsFinanceEnable	bit,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@ViewFinance TBool,
		@IsPM TBool,
		@FinanceManagement TBool,
		@IsFinanceManager TBool
		
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	
	SET @ViewFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance'))
	SET @IsPM = dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID)
	SET @FinanceManagement = dbo.fnPjm7HasPossibilityToProjectFinanceManagement(@ProjectID, @CurrentEmployeeID)
	SET @IsFinanceManager = dbo.fnPjm7IsFinanceManager(@ProjectID, @CurrentEmployeeID)

	SELECT  @IsFinanceEnable = CASE
				WHEN @IsPM = 1 OR @IsFinanceManager = 1 THEN 1
				WHEN @ViewFinance = 1 AND @FinanceManagement = 1 THEN 1
				ELSE @ViewAllFinance
			END

	SELECT
		[ServiceAssignment].[Class],
		[ServiceAssignment].[ID],
		[ServiceAssignment].[State],
		[ServiceAssignment].[Flag],
		[Service].[Code],
		[ServiceAssignment].[FileAs],
		[Service].[PaymentTermID],
		[ServiceAssignment].[ProjectID],
		[ServiceAssignment].[ServiceID],
		CASE @IsFinanceEnable
			WHEN 1 THEN [ServiceAssignment].[RateMultiplier]
			ELSE -1
		END AS [RateMultiplier],
		CASE @IsFinanceEnable
			WHEN 1 THEN [ServiceAssignment].[Price]
			ELSE -1
		END AS [Price],
		@VAT AS [VATRate],
		[ServiceAssignment].[VATIsIncluded],
		CASE @IsFinanceEnable
			WHEN 1 THEN 
				CASE [ServiceAssignment].[VATIsIncluded]
					WHEN 0 THEN [ServiceAssignment].[Price] 
					ELSE [ServiceAssignment].[Price] / (1 + @VAT)
				END
			ELSE -1
		END AS [Sum],
		CASE @IsFinanceEnable
			WHEN 1 THEN 
				CASE [ServiceAssignment].[VATIsIncluded]
					WHEN 0 THEN [ServiceAssignment].[Price] * @VAT 
					ELSE [ServiceAssignment].[Price] * @VAT / (1 + @VAT)
				END
			ELSE -1
		END AS [VAT],
		CASE @IsFinanceEnable
			WHEN 1 THEN 
				CASE [ServiceAssignment].[VATIsIncluded]
					WHEN 0 THEN [ServiceAssignment].[Price] * (1 + @VAT) 
					ELSE [ServiceAssignment].[Price]
				END
			ELSE -1
		END AS [SumWithVAT],
		[Project].[CurrencyCode],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[ServiceAssignment].[Comments],
		[ServiceAssignment].[Created],
		[ServiceAssignment].[CreatedBy],
		[ServiceAssignment].[Modified],
		[ServiceAssignment].[ModifiedBy],
		[ServiceAssignment].[Timestamp],
		[ServiceAssignment].[ServiceTypeID],
		[ServiceAssignment].[Budget],
		[ServiceAssignment].[ActualBudget],
		[ServiceAssignment].[ManHour],
		[ServiceAssignment].[ActualManHour]
	FROM
		[ServiceAssignment]
		INNER JOIN [Service]
			ON [Service].[ID] = [ServiceAssignment].[ServiceID]
		INNER JOIN [Project]
			ON [Project].[ID] = [ServiceAssignment].[ProjectID]
	WHERE
		(@ProjectID IS NULL OR [ServiceAssignment].[ProjectID] = @ProjectID) AND
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 1 AND [ServiceAssignment].[State] = 1) OR
			(@StateSelector = 2 AND [ServiceAssignment].[State] = 5)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceAssignmentBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceAssignmentBrowseByAddendum]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceAssignmentBrowseByAddendum'
		DROP PROCEDURE [dbo].[pjm5ServiceAssignmentBrowseByAddendum]
	END
GO

