IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestCreate'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestCreate]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestCreate'
GO

/******************************************************************************
**		File: pjm5ServiceRequestCreate.sql
**		Name: pjm5ServiceRequestCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.07.10	MAN				 ,     .
**		11.03.13	MAB				  OPENXML
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceRequestCreate]
	@Xml XML
AS
	DECLARE 
			@EmployeeID TIdentifier,
			@State TState,
			@ID TIdentifier,
			@ProjectID TIdentifier,
			@ExecutorID TIdentifier,
			@PriorityID TIdentifier,
			@Date TDate,
			@Number TCode,
			@FileAs TName,
			@StartDate TDate,
			@DueDate TDate,
			@Billable TBool,
			@VATIsIncluded TBool,
			@ServiceTypeID TIdentifier,
			@Comments TNotes,
			@Description TNotes,
			@RecurrenceID TIdentifier,
			@ReminderState TState,
			@ReminderInterval TTimeSpan,
			@ManHour TCount
	
	SET NOCOUNT ON
	
	DECLARE @ServiceRequestClass TClass
	SET @ServiceRequestClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')
	
	SET @State = dbo.adfwfGetInitialState('47383a06-ed8c-4aec-9468-4c4e4da3be29')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	SELECT
		@ProjectID			= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/ProjectID)[1]','int'),

		@ExecutorID			= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/EmployeeID)[1]','int'),
		@PriorityID			=	CASE 
									WHEN @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/PriorityID)[1]','int') IS NULL THEN 
										0 
									ELSE 
										@Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/PriorityID)[1]','int') 
								END,
		@Date				= CONVERT(datetime, @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/Date)[1]','nvarchar(19)')),
		@Number				= ISNULL(@Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/Number)[1]','varchar(32)'), ''),
		@FileAs				= ISNULL(@Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/FileAs)[1]','nvarchar(512)'), ''),
		@StartDate			= CONVERT(datetime, @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/StartDate)[1]','nvarchar(19)')),
		@DueDate			= CONVERT(datetime, @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/DueDate)[1]','nvarchar(19)')),
		@Billable			= CASE WHEN @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/Billable)[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@VATIsIncluded		= CASE WHEN @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/VATIsIncluded)[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@ServiceTypeID		= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/ServiceTypeID)[1]','int'),
		@Comments			= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/Comments)[1]','nvarchar(max)'),
		@ReminderState		= CASE WHEN @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/ReminderState)[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@ReminderInterval	= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/ReminderInterval)[1]','int'),
		@Description		= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/Description)[1]','nvarchar(max)'),
		@ManHour			= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/ManHour)[1]','int')
	
	IF(@ExecutorID IS NOT NULL)
	BEGIN
		IF NOT EXISTS(SELECT * FROM [vwAssignment] WHERE [ProjectID] = @ProjectID AND [EmployeeID] = @ExecutorID AND [State]=1)
		BEGIN
			RAISERROR('#notassignedtospecifiedproject', 18, -1)
			RETURN 1
		END
	END
	
	DECLARE
		@RStartDate TDatetime, 
		@REndDate TDatetime, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount
	SELECT
		
		@RStartDate = CAST(@Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/StartDate)[1]','varchar(19)') as datetime),
		@REndDate = CAST(@Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/EndDate)[1]','varchar(19)') as datetime),
		@RRecurrenceType = @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/RecurrenceType)[1]','int'),
		@ROccurrences = @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/Occurrences)[1]','int'),
		@RInterval = @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/Interval)[1]','int'),
		@RDayOfWeekMask = @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/DayOfWeekMask)[1]','int'),
		@RInstance = @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/Instance)[1]','int'),
		@RMonthOfYear = @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/MonthOfYear)[1]','int'),
		@RDayOfMonth = @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/DayOfMonth)[1]','int')

	IF dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID) = 0
	BEGIN
		IF dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, NULL) = 0 AND
			dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	
	IF NOT EXISTS (SELECT * FROM [Project] WHERE [ID] = @ProjectID AND [State] = 2)
	BEGIN
		RAISERROR('#ProjectIsNotOpen', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION
	IF @RRecurrenceType IS NOT NULL
	BEGIN
		INSERT INTO [RecurrencePattern]
			([StartDate], [EndDate], [RecurrenceType], [Occurrences],
			[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
		VALUES
			(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
			@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SET @RecurrenceID = SCOPE_IDENTITY()
	END

	INSERT INTO [ServiceRequest]
		([Flag], [State], [ProjectID], [EmployeeID], [PriorityID],
		 [Date], [Number], [FileAs], [StartDate], [DueDate], [Billable],
		 [VATIsIncluded], [Comments], [ServiceTypeID], [Description], [ManHour], [ActualManHour], [ActualBudget])	
	VALUES
		(0, @State,
		 @ProjectID, @ExecutorID, @PriorityID, @Date, @Number,
		 @FileAs, @StartDate, @DueDate, @Billable,
		 @VATIsIncluded, @Comments, @ServiceTypeID, @Description, ISNULL(@ManHour, 0), 0, 0)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	IF @RecurrenceID IS NOT NULL
	BEGIN
		UPDATE
			[Document]
		SET
			[RecurrencePatternID] = @RecurrenceID
		WHERE
			[Class] = @ServiceRequestClass AND [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	DECLARE @rv int		
	EXEC @rv = pjm7ServiceRequestReminderCreate @ID,
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	COMMIT TRANSACTION

	EXEC pjm5ServiceRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceRequestCreate TO PUBLIC
GO 