IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestDelayBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestDelayBrowse'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestDelayBrowse]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestDelayBrowse'
GO

/******************************************************************************
**		File: pjm5ServiceRequestDelayBrowse.sql
**		Name: pjm5ServiceRequestDelayBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceRequestDelayBrowse]
AS
	SET NOCOUNT ON
	
	DECLARE
		@date TDateTime,
		@CurrentEmployeeID TIdentifier,
		@ViewAllProjects TBool
		
	DECLARE @ViewAllFinance TBool
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	
	SELECT 
		@CurrentEmployeeID =  dbo.adfGetCurrentEmployeeID(),
		@date = GETDATE(),
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))
	
	SELECT
		[ServiceRequest].[Class],
		[ServiceRequest].[ID],
		[ServiceRequest].[ProjectID],
		[ServiceRequest].[EmployeeID],
		[ServiceRequest].[PriorityID],
		[ServiceRequest].[State],
		[ServiceRequest].[Flag],
		[ServiceRequest].[Date],
		[ServiceRequest].[Number],
		[ServiceRequest].[FileAs],
		[ServiceRequest].[Description],
		[ServiceRequest].[StartDate],
		[ServiceRequest].[DueDate],
		[ServiceRequest].[Billable],
		[ServiceRequest].[VATIsIncluded],
		[ServiceRequest].[Comments],
		[ServiceRequest].[Created],
		[ServiceRequest].[CreatedBy],
		[ServiceRequest].[Modified],
		[ServiceRequest].[ModifiedBy],
		[ServiceRequest].[Timestamp],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[Project].[CurrencyCode] AS [CurrencyCode],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[ServiceRequest].[ManHour],
		[ServiceRequest].[ActualManHour],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [ServiceRequest].[ActualBudget]
			ELSE -1
		END AS [ActualBudget]
	FROM
		[ServiceRequest]
		INNER JOIN [Project]
			ON [Project].[ID] = [ServiceRequest].[ProjectID]
	WHERE
		(
			@ViewAllProjects = 1 OR		
			dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR
			dbo.fnPjm5AllowCreateProjectEntry([Project].[ID], [ServiceRequest].[EmployeeID]) = 1
		)
		AND
		[ServiceRequest].[State] IN (1, 2, 7) AND
		[ServiceRequest].[DueDate] < @date
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceRequestDelayBrowse] TO PUBLIC
GO 