IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'adftrServiceRequestUpdate')
	BEGIN
		PRINT 'Dropping Trigger adftrServiceRequestUpdate'
		DROP  Trigger adftrServiceRequestUpdate
	END
GO

/******************************************************************************
**		File: 
**		Name: adftrServiceRequestUpdate
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger adftrServiceRequestUpdate'
GO
CREATE TRIGGER adftrServiceRequestUpdate 
ON [ServiceRequest] FOR UPDATE
AS
BEGIN
    IF @@rowcount = 0
       RETURN

	SET NOCOUNT ON

	DECLARE @count int
	
	SET @count = 0

	SELECT @count = COUNT([INSERTED].[ID])
	FROM [INSERTED] INNER JOIN [DELETED] ON [INSERTED].[ID] = [DELETED].[ID]
	WHERE [DELETED].[STATE] = [INSERTED].[STATE] AND [INSERTED].[State] in (4, 5, 6, 7)

	IF (@count = 0 OR (UPDATE([ActualManHour]) OR UPDATE([ActualBudget])))
	BEGIN		
		UPDATE [Document] 
		SET
			[State] = [inserted].[State], 
			[Flag] = [inserted].[Flag], 
			[FileAs] = [inserted].[FileAs], 
			[Modified] = [inserted].[Modified], 
			[ModifiedBy] = [inserted].[ModifiedBy], 
			[Timestamp] = [inserted].[Timestamp]
		FROM
			[Document] INNER JOIN [inserted]
				ON ([Document].[ID] = [inserted].[ID] AND [Document].[Class] = [inserted].[Class])
	END
	ELSE
		BEGIN
			RAISERROR('#TransitionTemplateCouldNotBeFound', 16, -1)
			ROLLBACK TRANSACTION
		END
    RETURN
END
GO
