 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskAssignmentsGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskAssignmentsGet'
		DROP PROCEDURE [dbo].[pjm5TaskAssignmentsGet]
	END
GO

PRINT 'Creating procedure pjm5TaskAssignmentsGet'
GO

/******************************************************************************
**		File: pjm5TaskAssignmentsGet.sql
**		Name: pjm5TaskAssignmentsGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskAssignmentsGet]
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON
		
	SELECT
		[BusinessCard].[ID],
		[BusinessCard].[Class],
		[BusinessCard].[State],
		[BusinessCard].[FileAs],
		[BusinessCard].[CompanyID],
		[BusinessCard].[PositionID],
		(SELECT [FileAs] FROM [Position] WHERE [ID] = [BusinessCard].[PositionID]) as [Position],
		(SELECT COALESCE([LegalName], [FileAs]) FROM [Company] WHERE [ID] = [BusinessCard].[CompanyID]) as [Company],
		[Employee].[QualificationID],
		(SELECT [FileAs] FROM [Qualification] WHERE [ID] = [Employee].[QualificationID]) as [Qualification],
		[BusinessCard].[Created],
		[BusinessCard].[CreatedBy],
		[BusinessCard].[Modified],
		[BusinessCard].[ModifiedBy],
		[BusinessCard].[Timestamp]
	FROM
		[BusinessCard] INNER JOIN [Employee]
			ON ([BusinessCard].[ID] = [Employee].[ID] AND [BusinessCard].[Class] = [Employee].[Class])
		INNER JOIN [Company]
			ON ([BusinessCard].[CompanyID] = [Company].[ID] AND [Company].[Own] = 1)
		LEFT OUTER JOIN [vwAssignment] as [Assignment]
			ON ([Assignment].[EmployeeID] = [Employee].[ID] AND 
				[Assignment].[ProjectID] = @ProjectID AND
				[Assignment].[State] IN (1,3) --     
				)
	WHERE
		[Assignment].[ID] IS NOT NULL
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskAssignmentsGet] TO PUBLIC
GO 