IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskPercentUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TaskPercentUpdate'
		DROP PROCEDURE [dbo].[pjm6TaskPercentUpdate]
	END
GO

PRINT 'Creating procedure pjm6TaskPercentUpdate'
GO


CREATE PROCEDURE pjm6TaskPercentUpdate
	@ID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @PercentComplete TPercent,
			@SumDuration TAmount,
			@SumRemainingWork TAmount,
			@State TState
	
	SELECT @State = [State] FROM [Task] WHERE [ID] = @ID

	IF @State IN (2, 5)
		AND NOT EXISTS(SELECT [ID] FROM [Task] WHERE [Task].[ParentID] = @ID)
	BEGIN
		SELECT
			@SumDuration = ISNULL(SUM([TimeEntry].[Duration]),0)
		FROM
			[TimeEntry]
		WHERE
			[TimeEntry].[TaskID] = @ID 
			AND [TimeEntry].[State] IN (2, 3, 6)
			
		SELECT
			@SumRemainingWork = ISNULL(SUM(ISNULL([TaskAssignment].[RemainingWork],0)), 0)-- + SUM(ISNULL([TaskAssignment].[RemainingOvertimeWork],0)),0)
		FROM
			[TaskAssignment]
		WHERE
			[TaskAssignment].[TaskID] = @ID
		
		DECLARE @percent TPercent
		SET @percent = @SumDuration/(CASE WHEN (@SumRemainingWork + @SumDuration) = 0 THEN 1.0 ELSE (@SumRemainingWork + @SumDuration) END)
		UPDATE 
			[Task]
		SET	
			[PercentComplete] = @percent
		WHERE 
			[ID] = @ID AND
			[PercentComplete] != @percent
		
		IF @@ERROR != 0
		BEGIN
			RETURN 1
		END
	END
RETURN 0
GO
GRANT EXECUTE ON pjm6TaskPercentUpdate TO PUBLIC
GO
 