
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskUpdate'
		DROP PROCEDURE [dbo].[pjm5TaskUpdate]
	END
GO

PRINT 'Creating procedure pjm5TaskUpdate'
GO

/******************************************************************************
**		File: pjm5TaskUpdate.sql
**		Name: pjm5TaskUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.03.13	SOV				 OpenXml  Xml
**		01.04.13	SOV				   . -   
*******************************************************************************/
CREATE PROCEDURE pjm5TaskUpdate
	@Xml	XML
AS
	
	DECLARE	@ID TIdentifier,
		@FileAs TName,
		@ProjectID TIdentifier,
		@PriorityID TIdentifier,
		@ParentID TIdentifier,
		@StartDate TDate,
		@DueDate TDate,
		@EndDate TDate,
		@Duration TAmount,
		@Estimated TBool,
		@ManHour TAmount,
		@Budget TMoney,
		@Milestone TBool,
		@SendStatusReport TBool,
		@Comments TNotes,
		@State TState,
		@ToState TState,
		@AllowFullUpdate TBool,
		@AssignmentState TState,
		@IsProjectTemplate int,
		@CurrentEmployeeID TIdentifier,
		@CurrentUserID TIdentifier,
		@CreatedBy TIdentifier,
		@ReminderState TState,
		@ReminderTime TDateTime,
		@ReminderInterval TTimeSpan,
		@MsTaskID TIdentifier,
		@TaskIndex int,
		@Wbs TName,
		@rv int
			
	SET NOCOUNT ON

	SELECT
		@ID = [XmlTable].value('ID[1]', 'int'),
		@FileAs = [XmlTable].value('FileAs[1]', 'nvarchar(256)'),
		@ProjectID = [XmlTable].value('ProjectID[1]', 'int'),
		@PriorityID = [XmlTable].value('PriorityID[1]', 'int'),
		@StartDate = [XmlTable].value('StartDate[1]', 'varchar(19)'),
		@DueDate = [XmlTable].value('DueDate[1]', 'varchar(19)'),
		@Duration = [XmlTable].value('Duration[1]', 'decimal(18, 4)'),
		@ManHour = [XmlTable].value('ManHour[1]', 'decimal(18, 4)'), 
		@Milestone = (CASE [XmlTable].value('Milestone[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@SendStatusReport = (CASE [XmlTable].value('SendStatusReport[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@Comments = [XmlTable].value('Comments[1]', 'nvarchar(max)'),
		@CreatedBy = [XmlTable].value('CreatedBy[1]', 'int'),
		@ReminderState = (CASE [XmlTable].value('ReminderState[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@ReminderTime = [XmlTable].value('ReminderTime[1]', 'varchar(19)'),
		@TaskIndex = [XmlTable].value('TaskIndex[1]', 'int'),
		@Wbs = [XmlTable].value('Wbs[1]', 'nvarchar(256)')
	FROM
		@Xml.nodes('/pjm5TaskGet/Task') AS List(XmlTable)
		
	SELECT @MsTaskID = [MsTaskID] FROM [Task] WHERE [ID] = @ID
		
	IF @ManHour IS NOT NULL AND @ManHour < 0
	BEGIN
		RAISERROR('#ManHourIsInvalid', 18, -1)
		RETURN 1
	END

	SELECT 
		@State = [State],
		@CreatedBy = [CreatedBy]
	FROM 
		[Task] 
	WHERE 
		[Task].[ID] = @ID

	SET @AssignmentState = 1 --dbo.adfwfGetInitialState('7797BD53-86CE-415E-9E13-B11BCBD52359')
	SELECT @IsProjectTemplate = COUNT(*) FROM [ProjectTemplate] WHERE [ID] = @ProjectID
	
	IF EXISTS (SELECT * FROM [ProjectTemplate] WHERE [ID] = @ProjectID)
	BEGIN
		SET @AssignmentState = 3
	END
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @AllowFullUpdate = dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) 
		| dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID)
	IF @State = 8 AND @CreatedBy = @CurrentUserID
	BEGIN
		SET @AllowFullUpdate = 1
	END

	SELECT
		@Budget = SUM([TaskAssignment].[Work] * [Assignment].[StandardRate] / 60.0)
	FROM
		[TaskAssignment]
		INNER JOIN [Assignment]
			ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
	WHERE
		[TaskAssignment].[TaskID] = @ID 
		
	BEGIN TRANSACTION
	IF @AllowFullUpdate = 1 OR @IsProjectTemplate > 0
	BEGIN
	
		DELETE 
			[MsAssignment] 
		FROM 
			[MsAssignment]
			INNER JOIN [Assignment]
				ON [MsAssignment].[ID] = [Assignment].[ID]
		WHERE 
			[TaskID] = @ID AND 
			[Assignment].[ID] NOT IN (
				SELECT 
					[XMLTable].value('ID[1]', 'int')
				FROM 
					@Xml.nodes('/pjm5TaskGet/BusinessCard') As List(XMLTable))
		
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END	

		DELETE 
			[TaskAssignment] 
		WHERE 
			[TaskID] = @ID AND 
			[AssignmentID] NOT IN (
				SELECT 
					[XMLTable].value('ID[1]', 'int')
				FROM 
					@Xml.nodes('/pjm5TaskGet/BusinessCard') As List(XMLTable))
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		-- TODO: Booking

		UPDATE
			[TaskAssignment]
		SET
			[Units] = [XmlTable].value('Units[1]', 'decimal(18,4)'),
			[Work] = [XmlTable].value('Work[1]', 'int'),
			[RemainingWork] = CASE 
				WHEN [XmlTable].value('TaskAssignmentState[1]', 'int') = 2 THEN 0
				WHEN
				(SELECT COUNT(ID) FROM [TimeEntry] WHERE [TaskID] = [TaskAssignment].[TaskID] AND [EmployeeID] = [Assignment].[EmployeeID]) = 0
				THEN [XmlTable].value('Work[1]', 'int') ELSE [RemainingWork] END,
			[State] = [XmlTable].value('TaskAssignmentState[1]', 'int')
		FROM 
			[TaskAssignment]
			INNER JOIN @Xml.nodes('/pjm5TaskGet/BusinessCard') AS List(XmlTable)
				ON ([XmlTable].value('ID[1]', 'int') = [TaskAssignment].[AssignmentID])
			INNER JOIN [vwAssignment] as [Assignment]
				ON [Assignment].[ID] = [XmlTable].value('TaskAssignmentState[1]', 'int')
		WHERE
			[TaskAssignment].[TaskID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		INSERT INTO [TaskAssignment] ([TaskID], [AssignmentID], [Units], [Work], [RemainingWork])
		SELECT
			@ID,
			[Assignment].[ID],
			[XmlTable].value('Units[1]', 'decimal(18,4)'),
			[XmlTable].value('Work[1]', 'int'),
			[XmlTable].value('Work[1]', 'int')
		FROM
			[vwAssignment] AS [Assignment]
			INNER JOIN @Xml.nodes('/pjm5TaskGet/BusinessCard') AS List(XmlTable)
				ON ([XmlTable].value('ID[1]', 'int') = [Assignment].[ID])
			LEFT OUTER JOIN [TaskAssignment]
				ON ([TaskAssignment].[TaskID] = @ID AND 
					[TaskAssignment].[AssignmentID] = [Assignment].[ID])
		WHERE
			[Assignment].[ProjectID] = @ProjectID AND 
			[Assignment].[State] = @AssignmentState AND
			[TaskAssignment].[AssignmentID] IS NULL
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		DECLARE @WorkHours TCount,
				@val TVariant
		EXEC adfParameterGet @Name='WorkTime', @Group='Pjm5', @Value = @val OUTPUT
		SET @WorkHours = CAST(@val as int)
		
		SELECT @DueDate = dbo.fnPjm5AddWorkingDays(@StartDate, @Duration)
		UPDATE [Task]
		SET
			[Task].[FileAs] = @FileAs,
			[Task].[ProjectID] = @ProjectID,
			[Task].[PriorityID] = @PriorityID,
			[Task].[StartDate] = @StartDate,
			[Task].[DueDate] = @DueDate,
			[Task].[EndDate] = @EndDate,
			[Task].[Duration] = @Duration,
			[Task].[ManHour] = CAST(@ManHour * 60 AS int),
			[Task].[Budget] = @Budget,
			[Task].[Milestone] = @Milestone,
			[Task].[SendStatusReport] = @SendStatusReport,
			[Task].[Comments] = @Comments,
			[Task].[Modified] = DEFAULT,
			[Task].[ModifiedBy] = DEFAULT
		WHERE
			[Task].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		EXEC @rv = pjm6TaskUpdateWbs @ID, @TaskIndex, @Wbs
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		-- TODO: Booking TaskAssignmentBooking
		DELETE [BusyEntry] WHERE [TaskID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		;
		WITH [ActualTime] ([AssignmentID], [EmployeeID], [Date], [ActualWork]) AS
		(
			SELECT 
				[TimeEntry].[AssignmentID] as [AssignmentID],
				[TimeEntry].[EmployeeID],
				CONVERT(varchar(19), [TimeEntry].[StartTime], 112) as [Date],
				SUM([TimeEntry].[Duration]) as [ActualWork]
			FROM 
				[TimeEntry]
			WHERE
				[TimeEntry].[State] IN (2,3,6) AND
				[TimeEntry].[TaskID] = @ID
			GROUP BY
				[TimeEntry].[AssignmentID], 
				[TimeEntry].[EmployeeID],
				CONVERT(varchar(19), [TimeEntry].[StartTime], 112)
		)
		INSERT INTO [BusyEntry] ([AssignmentID], [ProjectID], [TaskID], [Date], [EmployeeID], [Planned], [Canceled], [Committed], [ActualWork])
		SELECT
			ISNULL([XmlTable].value('AssignmentID[1]', 'int'), [ActualTime].[AssignmentID]),
			@ProjectID,
			@ID,
			CAST(ISNULL([XmlTable].value('Date[1]', 'varchar(19)'), [ActualTime].[Date])  AS DateTime),
			ISNULL([AssignmentEntry].[EmployeeID], [ActualTime].[EmployeeID]),
			ISNULL([XmlTable].value('Planned[1]', 'int'), 0),
			ISNULL([XmlTable].value('Canceled[1]', 'int'), 0),
			ISNULL((CASE [XmlTable].value('Committed[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END), 0),
			ISNULL([ActualTime].[ActualWork], 0)
		FROM
			@Xml.nodes('/pjm5TaskGet/TaskAssignmentBooking') AS List(XmlTable)
			INNER JOIN [AssignmentEntry]
				ON [AssignmentEntry].[AssignmentID] = [XmlTable].value('AssignmentID[1]', 'int')
			FULL OUTER JOIN [ActualTime]
				ON [ActualTime].[AssignmentID] = [XmlTable].value('AssignmentID[1]', 'int')
				AND CAST([ActualTime].[Date] as DateTime) = CAST([XmlTable].value('Date[1]', 'varchar(19)') as DateTime) 
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
		IF NOT EXISTS(
				SELECT * 
				FROM
					[TaskAssignment]
					INNER JOIN [vwAssignment]
						ON [TaskAssignment].[AssignmentID] = [vwAssignment].[ID]
				WHERE
					[TaskAssignment].[TaskID] = @ID AND
					[vwAssignment].[EmployeeID] = @CurrentEmployeeID
				)
		BEGIN
			ROLLBACK TRANSACTION
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END

		UPDATE [Task]
		SET
			[Task].[Modified] = DEFAULT,
			[Task].[ModifiedBy] = DEFAULT
		WHERE
			[Task].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	SET @ReminderInterval = DATEDIFF(minute, @ReminderTime, @DueDate)
	EXEC @rv = pjm7TaskReminderCreate @ID,
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	EXEC @rv = pjm6TaskPercentUpdate @ID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
		
	EXEC pjm5TaskGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5TaskUpdate TO PUBLIC
GO
 