IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskCreateFromProject]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TaskCreateFromProject'
		DROP PROCEDURE [dbo].[pjm6TaskCreateFromProject]
	END
GO

PRINT 'Creating procedure pjm6TaskCreateFromProject'
GO

/******************************************************************************
**		File: pjm6TaskCreateFromProject.sql
**		Name: pjm6TaskCreateFromProject
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskCreateFromProject]
	@ProjectID TIdentifier,
	@SubProjectID TIdentifier
AS
	INSERT INTO [Task]
		([State], [Flag], [FileAs], [ProjectID], [SubProjectID],
		[PriorityID],  
		[StartDate], [DueDate], [EndDate],
		[Duration], 
		[ManHour], [Budget],
		[PercentComplete], [WSSDocumentsURL],
		[Milestone], [SendStatusReport], 
		[Comments])
	SELECT
		8,
		[pjm5vwProject].[Flag],
		[pjm5vwProject].[FileAs],
		@ProjectID,
		[pjm5vwProject].[ID],
		[pjm5vwProject].[PriorityID],
		[pjm5vwProject].[Date],
		[pjm5vwProject].[Duedate],
		[pjm5vwProject].[EndDate],
		ISNULL([Project].[Duration],0),
		[pjm5vwProject].[ManHour],
		[pjm5vwProject].[Budget],
		[pjm5vwProject].[PercentComplete],
		[pjm5vwProject].[WSSDocumentsURL],
		0,
		0,
		[pjm5vwProject].[Comments]
	FROM [pjm5vwProject]
		INNER JOIN [Project]
			ON [Project].[ID] = @SubProjectID
		WHERE [pjm5vwProject].[ID] = @SubProjectID
	RETURN 0

	UPDATE [Task]
	SET
		[Task].[State] = [Project].[State]
	FROM [Project]
	WHERE
		[Project].[ID] = @SubProjectID
GO

GRANT EXECUTE ON pjm6TaskCreateFromProject TO PUBLIC
GO 