 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5vwProject]') and OBJECTPROPERTY(id, N'IsView') = 1)
	BEGIN
		PRINT 'Dropping view pjm5vwProject'
		DROP VIEW [dbo].[pjm5vwProject]
	END
GO

PRINT 'Creating view pjm5vwProject'
GO

/*CREATE VIEW [pjm5vwProject]
AS
	SELECT
		[Project].[Class],
		[Project].[ID],
		[Project].[State],
		[Project].[Flag],
		[Project].[Date],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[ProjectTypeID],
		[Project].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID],
		[Project].[CustomerFinanceManagerID],
		[Project].[ResponsiblePersonEmployeeID],
		[Project].[PriorityID],
		[Project].[DueDate],
		[Project].[EndDate],
		ISNULL([Project].[PlannedManHour] / 60.0, 0) AS [ManHour],
		[Project].[Budget],
		[Project].[PlannedManHour],
		[Project].[PlannedBudget],
		[Project].[CurrencyCode],
		[Project].[CostCenterID],
		[Project].[Billable],
		[Project].[RoundingInterval],
		[Project].[RoundingMode],
		[Project].[ContractNumber],
		[Project].[ContractDate],
		[Project].[ContractEndDate],
		[Project].[ContractSubject],
		[Project].[ServiceLevelID],
		[Project].[ApplyVAT],
		[Project].[InvoiceExpirationPeriod],
		[Project].[InvoiceExpirationPeriodType],
		[Project].[WSSDocumentsURL],
		[Project].[SupportsRequestManagement],
		[Project].[Comments],
		[Project].[Created],
		[Project].[CreatedBy],
		[Project].[Modified],
		[Project].[ModifiedBy],
		[Project].[Timestamp],
		[Project].[RatesWithVAT],
		[Project].[PercentComplete],
		ISNULL([TimeEntryBudget].[TimeEntryDuration], 0) AS [RealManHour],
		ISNULL([TimeEntryBudget].[TimeEntryBudget], 0) AS [TimeRealBudget],
		ISNULL([ExpenseBudget].[ExpenseBudget], 0) AS  [ExpenseRealBudget],
		[Project].[PaymentCurrencyPoint],
		[Project].[InitialBalance]
	FROM
		[Project]
		LEFT OUTER JOIN 
			(
			SELECT 
				[Expense].[ProjectID],
				SUM([Expense].[Billable] * ISNULL(CASE 
					WHEN [Project].[RatesWithVAT] = 0 
						THEN [Expense].[TotalPC]
					ELSE [Expense].[TotalWithVATPC]
				END, 0)) AS [ExpenseBudget]
			FROM 
				[Expense]
				INNER JOIN [Project]
					ON [Project].[ID] = [Expense].[ProjectID]
			WHERE
				[Expense].[State] IN (2,3,6)
			GROUP BY 
				[Expense].[ProjectID]
			) AS [ExpenseBudget]
			ON [ExpenseBudget].[ProjectID] = [Project].[ID]
		LEFT OUTER JOIN 
			(
			SELECT 
				[TimeEntry].[ProjectID],
				ISNULL(SUM([TimeEntry].[Duration]), 0) / 60.0 AS [TimeEntryDuration],
				SUM([TimeEntry].[Billable] * [EntryAmount].[Amount] * [TimeEntry].[Rate]) AS [TimeEntryBudget]
			FROM 
				[TimeEntry]
				INNER JOIN [EntryAmount]
					ON [TimeEntry].[ID] = [EntryAmount].[ID]
			WHERE
				[TimeEntry].[State] IN (2,3,6)
			GROUP BY 
				[TimeEntry].[ProjectID]
			) AS [TimeEntryBudget]
			ON [TimeEntryBudget].[ProjectID] = [Project].[ID]
	WHERE
		[Project].[State] NOT IN (5, 6)
*/	
GO
  